	//ͻ
	// GRaton.Cpp                                       
	//                                                  
	// Implementacin de los mtodos de la clase GRaton 
	//                                                  
	// 27 Mayo 1992                                     
	//ͼ

#include <dos.h>
#include <stdlib.h>

#include "GRaton.Hpp"

 // En principio el ratn se asume no instalado, valor 0

int GRaton::Activado = 0 ;

GRaton _Raton ; // Objeto global que visualice el ratn al comenzar
              // la aplicacin y lo oculte al terminar esta

char * GRaton::Buffer = NULL ;

	// Este mtodo es el punto de entrada al controlador
	// de ratn. Recibe el servicio a ejecutar y los
	// posibles parmetros.

REGPACK GRaton::Raton( Servicio X, unsigned BX, unsigned CX, unsigned DX,
				   unsigned SI, unsigned DI, unsigned ES )
 {
	struct REGPACK R ;

	R . r_ax = X ;	// Establecer el servicio

	R . r_bx = BX ;	// Establecer los parmetros
	R . r_cx = CX ;
	R . r_dx = DX ;
	R . r_si = SI ;
	R . r_di = DI ;
	R . r_es = ES ;

	intr( 0x33, & R ) ;	// Llamar al controlador de ratn

	return R ;	// Devolver posibles parmetros

 }

	// El constructor comprueba si el ratn no ha sido an
	// inicializado, y en ese caso lo inicializa, en el caso
	// contrario incrementa el contador de objetos que se
	// han declarado, para que el ratn se pueda seguir uti-
	// lizando hasta que se destruya el ltimo de ellos.

GRaton::GRaton()
 {

	if( ! Activado )
	 {
		// El servicio Inicializar devuelve 0 si no hay ratn
		//  -1 si lo hay, por eso se utiliza abs()

		Activado = abs( ( Raton( Inicializar ) ) . r_ax ) ;

		// Si hay ratn preparar espacio para salvar el estado

		if( Activado )
		 {
			Buffer = new char[ ( Raton( LeerEspacioBuffer ) ) . r_bx ] ;

			Raton( MostrarCursor ) ; // Mostrar el cursor
		 }
	 }
	else

		// Si ya estaba instalado lo que ocurre es que
		// se ha creado otro objeto para controlarlo

		Activado++ ;

 }

	// El destructor decrementa el contador de objetos, y si
	// es el ltimo objeto de la clase se oculta el cursor
	// y se libera el espacio reservado en el constructor

GRaton::~GRaton()
 {
	if( Activado )
	 {
		--Activado ;

		if( ! Activado )
		 {

			Raton( OcultarCursor ) ;

			delete [] Buffer ;
		 }
	 }
 }

	// Fija los lmites en los que se podr mover el ratn


void GRaton::FijaLimites( unsigned X1, unsigned Y1, unsigned X2, unsigned Y2 )
 {
	if( Activado )
	 {
		Raton( FijarLimitesHorizontales, 0, X1, X2 ) ;

		Raton( FijarLimitesVerticales, 0, Y1, Y2 ) ;
	 }
 }
