	//
	// GVentaGr.Hpp
	//
	// Definicin de la clase GESGrafico, para implementar
	// ventanas en modo grfico
	//
	// 7 Septiembre 1992
	//

#ifndef _GVENTAGR_HPP_
#define _GVENTAGR_HPP_

#ifndef __cplusplus
#error No se puede utilizar GESGrafico en C
#endif

#include "GVentana.Hpp"  // La clase base es GES

	//
	// Clase : GESGrafico
	//
	// Deriva de : GES
	//
	// Base de : -
	//
	// Finalidad : Implementar los mtodos de
	//	       bajo nivel para salida a
	//	       pantalla grfica
	//
	// Fecha de creacin : 7 Septiembre 1992
	//
	// Fecha de revisin : -
	//

class GESGrafico : public GES
 {
	public :

		GESGrafico( ModoPantalla ) ; // Constructor

		 // Mtodos virtuales heredados, que permiten
		 // la accin a bajo nivel sobre la pantalla grfica

		 // Refresca el aspecto de la pantalla volcando
		 // la informacin contenida en el GES

		void Actualiza( Area & ) ;

		 // Sita el cursor en una determinada posicin

		void PosCursor( int, int ) ;

		 // Cambia el aspecto del cursor

		void AspCursor( GVenBuf::TipoCursor ) ;

 } ; // GESGrafico

	//
	// Mtodos inline de la clase GESGrafico
	//

	//
	// Mtodo : Constructor
	//
	// Construye un objeto simplemente llamando al constructor base
	//

inline GESGrafico::GESGrafico( GES::ModoPantalla X ) :

                               GES( X )

	{}

#endif // _GVENTAGR_HPP_