	//ͻ
	//  GVentana.Cpp                
	//                              
	// Implementacin de los mtodos
	// correspondientes a las clases
	// definidas en GVentana.Hpp    
	//                              
	// Agosto 1992                  
	//ͼ

#include <dos.h> // Para utilizar FP_OFF y FP_SEG

#include <mem.h> // Para utilizar movedata

	// Si el modelo de memoria seleccionado permite varios segmentos de datos
	// habr que utilizar las versiones far de algunas funciones

#if defined(__LARGE__) || defined(__HUGE__) || defined(__COMPACT__)

	#define istrcpy( orig, dest )	_fstrcpy( (orig), (dest) )
	#define istrcmp( orig, dest )	_fstrcmp( (orig), (dest) )
	#define istrcat( orig, dest )	_fstrcat( (orig), (dest) )
	#define istrchr( cade, cara )	_fstrchr( (cade), (cara) )
	#define istrlen( cade )			_fstrlen( (cade) )
	#define imemcmp( orig, dest, long ) _fmemcmp( (orig), (dest), (long) )

#else

	#define istrcpy( orig, dest )	strcpy( (orig), (dest) )
	#define istrcmp( orig, dest )	strcmp( (orig), (dest) )
	#define istrcat( orig, dest )	strcat( (orig), (dest) )
	#define istrchr( cade, cara )	strchr( (cade), (cara) )
	#define istrlen( cade )			strlen( (cade) )
	#define imemcmp( orig, dest, long ) memcmp( (orig), (dest), (long) )

#endif

#include "GRaton.Hpp"

#include "GVentana.Hpp" // Incluir la definicin de las clases

	//
	// Mtodos de la clase Area
	//

	//
	// Mtodo : Coincidente
	//
	// Devuelve el rea coincidente entre dos reas,
	// la implcita y la pasada como parmetro.
	//
	//
	//      ͻ
	//          V1      Ŀ
	//                  <A>ۺ     
	//      ͼ     
	//                         V2     
	//                   
	//
	//
	//    Dadas las ventanas V1 y V2, para hallar el rea
	// comn, <A>, hay que tomar como columna izquierda la
	// que est ms a la derecha, es decir, la mayor, y como
	// lnea superior la que est ms abajo, tambin la mayor.
	// Como columna derecha habr que tomar la que est ms
	// a la izquierda, la menor, y como lnea inferior la
	// que est ms arriba, tambin la menor.
	//
	//    Por tanto el proceso se reduce a tomar esas cuatro
	// coordenadas.
	//

Area Area::Coincidente( Area & Area2 )
 {
	Area Temporal ;

	    // Se halla la zona coincidente
	Temporal . ColI = ColI < Area2 . ColI ? Area2 . ColI : ColI ;
	Temporal . LinS = LinS < Area2 . LinS ? Area2 . LinS : LinS ;
	Temporal . ColD = ColD > Area2 . ColD ? Area2 . ColD : ColD ;
	Temporal . LinI = LinI > Area2 . LinI ? Area2 . LinI : LinI ;

	return Temporal ; // Y se devuelve
 }

	//
	// Mtodo : NoCoincidentes
	//
	// Halla las zonas no coincidentes entre dos ventanas
	// que tienen una zona coincidente.
	//
	// ͻ
	// <A1>ۺ
	// Ŀ
	// <A2>     <A4>
	// 
	// <A3>
	// ͼ
	//
	//     Dadas dos ventanas que se solapan, siempre existe
	// un rea solapada y cuatro reas no coincidentes, designadas
	// como <A1>, <A2>, <A3> y <A4>, que seran, respectivamente,
	// el rea no coincidente superior, izquierda, inferior y
	// derecha. Hay que calcular cada una de ellas por separado,
	// comprobando si se encuentra delimitada por los extremos de
	// una ventana o la otra.
	//


void Area::NoCoincidentes( Area & Area2, Matriz<Area> & NC )
 {
	// Calcular el rea no coincidente a la izquierda

	NC[ 0 ] . ColI = ColI < Area2 . ColI ?
			 ( NC[ 0 ] . ColD = Area2 . ColI - 1,
			   NC[ 0 ] . LinS = LinS,
			   NC[ 0 ] . LinI = LinI, ColI ) :

			 ( NC[ 0 ] . ColD = ColI - 1,
			   NC[ 0 ] . LinS = Area2 . LinS,
			   NC[ 0 ] . LinI = Area2 . LinI, Area2 . ColI ) ;

	// Calcular el rea no coincidente a la derecha

	NC[ 1 ] . ColI = ColD < Area2 . ColD ?
			 ( NC[ 1 ] . ColD = Area2 . ColD,
			   NC[ 1 ] . LinS = Area2 . LinS,
			   NC[ 1 ] . LinI = Area2 . LinI, ColD + 1 ) :

			 ( NC[ 1 ] . ColD = ColD,
			   NC[ 1 ] . LinS = LinS,
			   NC[ 1 ] . LinI = LinI, Area2 . ColD + 1 ) ;

	// Calcular el rea no coincidente arriba

	NC[ 2 ] . LinS = LinS < Area2 . LinS ?
			 ( NC[ 2 ] . LinI = Area2 . LinS - 1,
			   NC[ 2 ] . ColI = ColI,
			   NC[ 2 ] . ColD = ColD, LinS ) :

			 ( NC[ 2 ] . LinI = LinS - 1,
			   NC[ 2 ] . ColI = Area2 . ColI,
			   NC[ 2 ] . ColD = Area2 . ColD, Area2 . LinS ) ;

	// Calcular la ltima zona posible, en la parte inferior

	NC[ 3 ] . LinS = LinI < Area2 . LinI ?
			 ( NC[ 3 ] . LinI = Area2 . LinI,
			   NC[ 3 ] . ColD = Area2 . ColD,
			   NC[ 3 ] . ColI = Area2 . ColI, LinI + 1 ) :

			 ( NC[ 3 ] . LinI = LinI,
			   NC[ 3 ] . ColI = ColI,
			   NC[ 3 ] . ColD = ColD, Area2 . LinI + 1 ) ;

 }

	//
	// Mtodos de la clase GVenBuf
	//

	// Se fija el controlador de errores por defecto

void (*GVenBuf::ErrorVentana)( ErrVen ) = GVenBuf::GestorErroresPorDefecto ;

long GVentana::fGES = GVentana::bitalloc() ; // Se obtiene el bit indicador

	//
	// Mtodo : Constructor por defecto
	//
	// Da valores iniciales a los distintos miembros, y asigna
	// la memoria necesaria para el contenido de la ventana
	//

GVenBuf::GVenBuf( int Cols, int Lins, TipoBorde B, Color T, Color F ) :
		Columnas( Cols ), Lineas( Lins ), Borde( B ) // Inicializar

 {
	Contenido = new char[ (Cols+2) * (Lins+2) * 2 ] ; // Asignar memoria

	if( ! Contenido ) // Si no hay memoria

			// Llamar al gestor de errores indicndole el error
		ErrorVentana( GVenBuf::SinMemoria ) ;
	else
	 {
		  // Fijar el rea
		setb( Contenido, Contenido + ( (Cols+2)*(Lins+2)*2 ) ) ;

		ColorActual = ColorDefecto = ( F << 4 ) | T ; // Se componen los atributos

		TrazaRecuadro() ; // Dibuja el recuadro alrededor de la ventana

		Limpia() ; // Limpia el contenido

		AspectoCursor( GVenBuf::CursorNormal ) ; // El aspecto del cursor es normal

		FijaPosicionCursor( 1, 1 ) ; // El cursor est en principio al inicio de la ventana
	 }
 }

	//
	// Mtodo : Constructor de copia
	//
	// Permite construir un objeto a partir de otro
	//

GVenBuf::GVenBuf( GVenBuf & O ) :

	  // Inicializar todos los miembros a partir del objeto O

	Columnas( O . Columnas ), Lineas( O . Lineas ), Borde( O . Borde ),
	ColorActual( O . ColorActual ), ColorDefecto( O . ColorDefecto ),
	AspCursor( O . AspCursor ), ColCursor( O . ColCursor ), LinCursor( O . LinCursor ),
	Columna( O . Columna ), Linea( O . Linea )
 {

	if( O . Contenido != NULL ) // Si la ventana que se copia tiene un contenido
	 {
			// Asignar memoria para l

		Contenido = new char[ (Columnas+2) * (Lineas+2) * 2 ] ;

		if( ! Contenido ) // Si no hay memoria para crear el objeto

			ErrorVentana( GVenBuf::SinMemoria ) ;
		else
		{
			// Fijar el rea buffer

			setb( Contenido, Contenido + ( (Columnas+2)*(Lineas+2)*2 ) ) ;

			// Tomar el mismo contenido de la ventana O

			movedata( FP_SEG( O . Contenido ), FP_OFF( O . Contenido ),
				  FP_SEG( Contenido ), FP_OFF( Contenido ),
				  (Columnas+2) * (Lineas+2) * 2 ) ;

			EsModificado( GVenBuf::Si ) ; // La ventana se ha modificado

			Zona . ColI = Zona . LinS = 1 ; // La ventana entera tiene que ser refrescada
			Zona . ColD = Columnas ;
			Zona . LinI = Lineas ;
		}
	 }
	else // Si la ventana que se copia no tiene contenido

		Contenido = NULL ; // la que se crea tampoco
 }

	//
	// Mtodo : Destructor
	//
	// El destructor base libera la memoria ocupada por la ventana,
	// y se asegura que ningn objeto GES har referencia a ella.
	//

GVenBuf::~GVenBuf()
 {
	if( Contenido ) // Si hay una memoria asignada

		delete [] Contenido ; // liberarla
 }

	//
	// Mtodo : Operador de asignacin
	//
	// Permite asignar un objeto a otro
	//

void GVenBuf::operator= ( const GVenBuf & O )
 {
	if( Contenido ) // Si hay un contenido asignado

		delete [] Contenido ; // elimnalo

		// Asignar todos los miembros del objeto O al implcito

	Columnas = O . Columnas ;
	Lineas = O . Lineas ;
	Borde = O . Borde ;
	ColorActual = O . ColorActual ;
	ColorDefecto = O . ColorDefecto ;
	AspCursor = O . AspCursor ;
	ColCursor = O . ColCursor ;
	LinCursor = O . LinCursor ;
	Columna = O . Columna ;
	Linea = O . Linea ;

	if( O . Contenido != NULL ) // Si el objeto tiene un contenido
	 {
			// Se asigna memoria para contenerlo

		Contenido = new char[ (Columnas+2) * (Lineas+2) * 2 ] ;

		// Comprobar que no hubo error en la asignacin

		if( ! Contenido )

			ErrorVentana( GVenBuf::SinMemoria ) ;

		else
		 {
			setb( Contenido, Contenido + ( (Columnas+2)*(Lineas+2)*2 ) ) ;

			// Copia el contenido

			movedata( FP_SEG( O . Contenido ), FP_OFF( O . Contenido ),
				  FP_SEG( Contenido ), FP_OFF( Contenido ),
				  (Columnas+2) * (Lineas+2) * 2 ) ;

			EsModificado( GVenBuf::Si ) ; // La ventana ha sido modificada

			Zona . LinS = Zona . ColI = 1 ;
			Zona . ColD = Columnas ;
			Zona . LinI = Lineas ;

		 }
	 }
	else // Si el objeto est vaco

		Contenido = NULL ;
 }

	//
	// Mtodo : operador relacional de igualdad
	//
	// Permite comparar dos objetos
	//

int GVenBuf::operator== ( const GVenBuf & O )
 {
	return
		Columnas == O . Columnas &&    // Compara todos los miembros
		Lineas == O . Lineas &&
		Borde == O . Borde &&
		ColorActual == O . ColorActual &&
		ColorDefecto == O . ColorDefecto &&
		AspCursor == O . AspCursor &&
		ColCursor == O . ColCursor &&
		LinCursor == O . LinCursor &&
		Columna == O . Columna &&
		Linea == O . Linea &&
		  // Y el contenido de la ventana
		! imemcmp( Contenido, O . Contenido, (Columnas+2) * (Lineas+2) * 2 ) ;
 }
	//
	// Mtodo : FijaPosicionCursor
	//
	// Permite posicionar el cursor dentro de la ventana
	//

void GVenBuf::FijaPosicionCursor( int X, int Y )
 {
	if( X > Columnas || Y > Lineas || X < 1 || Y < 1 ) // Si la posicin es invlida

		ErrorVentana( GVenBuf::CursorFueraLimites ) ; // Generar un error

	else
	 {
		ColCursor = X ; // Tomar la nueva posicin
		LinCursor = Y ;
	 }
 }

	//
	// Mtodo : AspectoCursor
	//
	// Permite alterar el aspecto de cursor
	//

void GVenBuf::AspectoCursor( TipoCursor T )
 {
	if( T < SinCursor || T > CursorNormal ) // Si el tipo no es vlido

		ErrorVentana( GVenBuf::TipoCursorInvalido ) ; // Generar un error

	else

		AspCursor = T ; // Nuevo tipo de cursor

 }

	//
	// Mtodo : BordeVentana
	//
	// Permite establecer un nuevo tipo de borde en la ventana
	//

void GVenBuf::BordeVentana( TipoBorde B )
 {
	    // Comprobar que el borde indicado es correcto

	if( B < GVenBuf::Ninguno || B > GVenBuf::Grueso )

			// Si no es as generar un error
		ErrorVentana( GVenBuf::TipoBordeInvalido ) ;

	else
	 {
		Borde = B ; // Al cambiar el tipo de recuadro
		TrazaRecuadro() ; // Hay que volver a redibujarlo
	 }
 }

	  //
	  // Mtodo : Caracter
	  //
	  // Devuelve una referencia al carcter correspondiente
	  // a una cierta posicin, permitiendo as su manipulacin
	  //

char & GVenBuf::Caracter( int C, int L )
 {
	static char NULO ;

		// Si la columna es invlida
	if( C < 0 || C > Columnas+1 ||  L < 0 || L > Lineas+1 )
	 {
			// Generar el error correspondiente
		ErrorVentana( GVenBuf::CoordenadasInvalidas ) ;

		return NULO ; // y devolver el objeto nulo
	 }
	else
		    // Si es correcto devolver el carcter de esa posicin

		return * ( Contenido + ( ( L * (Columnas+2) + C ) * 2 ) ) ;
 }

	//
	// Mtodo : Atributo
	//
	// Devuelve una referencia al atributo de una cierta
	// posicin, permitiendo su manipulacin
	//

char & GVenBuf::Atributo( int C, int L )
 {
	static char NULO ;

	if( C < 0 || C > Columnas+1 || L < 0 || L > Lineas+1 )
	 {
		ErrorVentana( GVenBuf::CoordenadasInvalidas ) ;
		return NULO ;
	 }
	else

		return * ( Contenido + ( ( L * (Columnas+2) + C ) * 2 + 1 ) ) ;
 }

	//
	// Mtodo : FijaFondo
	//
	// Modifica el color de fondo de un rea de la ventana
	//

void GVenBuf::FijaFondo( int CI, int LS, int CD, int LI, Color C )
 {
	     // Si las coordenadas exceden el rea de la ventana

	if( CI < 1 || CD < 1 || LS < 1 || LI < 1 ||
	    CI > Columnas || CD > Columnas || LS > Lineas || LI > Lineas ||
	    CI > CD || LS > LI )

		    // Generar un error
		ErrorVentana( GVenBuf::CoordenadasInvalidas ) ;

	else // Si son correctas
	{
	  for( int I = CI ; I <= CD ; I++ ) // Desde la columna izquierda hasta la derecha

		for( int J = LS ; J <= LI ; J++ ) // Desde la lnea superior a la inferior

			 // Asignar a cada celdilla el nuevo color de fondo

			Atributo( I, J ) = ( Atributo( I, J ) & 0xf ) | ( C << 4 ) ;

	  if( ! EsModificado() ) // Si el contenido no estaba modificado
	   {
		EsModificado( GVenBuf::Si ) ; // Ya si est modificado

		Zona . ColI = CI ; // Esta es el rea modificada
		Zona . LinS = LS ;
		Zona . ColD = CD ;
		Zona . LinI = LI ;
	   }
	  else // si ya existe un rea modificada
	   {
		   // Ampliarla si es necesario, segn la zona
		   // que haba modificada y la que se ha modificado ahora

		Zona . ColI = CI < Zona . ColI ? CI : Zona . ColI ;
		Zona . LinS = LS < Zona . LinS ? LS : Zona . LinS ;
		Zona . ColD = CD > Zona . ColD ? CD : Zona . ColD ;
		Zona . LinI = LI > Zona . LinI ? LI : Zona . LinI ;
	   }
	}
 }

	//
	// Mtodo : FijaTinta
	//
	// Modifica el color de tinta de un rea de la ventana
	//

void GVenBuf::FijaTinta( int CI, int LS, int CD, int LI, Color C )
 {
	if( CI < 1 || CD < 1 || LS < 1 || LI < 1 ||
	    CI > Columnas || CD > Columnas || LS > Lineas || LI > Lineas ||
	    CI > CD || LS > LI )

		ErrorVentana( GVenBuf::CoordenadasInvalidas ) ;
	else
	{
	  for( int I = CI ; I <= CD ; I++ ) // Desde la columna izquierda hasta la derecha

		for( int J = LS ; J <= LI ; J++ ) // Desde la lnea superior a la inferior

			  // Modificar el color de tinta de la celdilla

			Atributo( I, J ) = ( Atributo( I, J ) & 0xf0 ) | C ;

	  if( ! EsModificado() ) // Si el contenido no estaba modificado
	   {
		EsModificado( GVenBuf::Si ) ; // Ya si est modificado

		Zona . ColI = CI ; // Esta es el rea modificada
		Zona . LinS = LS ;
		Zona . ColD = CD ;
		Zona . LinI = LI ;
	   }
	  else // si ya existe un rea modificada
	   {
		   // Ampliarla si es necesario, segn la zona
		   // que haba modificada y la que se ha modificado ahora

		Zona . ColI = CI < Zona . ColI ? CI : Zona . ColI ;
		Zona . LinS = LS < Zona . LinS ? LS : Zona . LinS ;
		Zona . ColD = CD > Zona . ColD ? CD : Zona . ColD ;
		Zona . LinI = LI > Zona . LinI ? LI : Zona . LinI ;
	   }
	}
 }

	//
	// Mtodo : FijaRelleno
	//
	// Llena un rea de la ventana con un cierto carcter
	//

void GVenBuf::FijaRelleno( int CI, int LS, int CD, int LI, char C )
 {
	if( CI < 1 || CD < 1 || LS < 1 || LI < 1 ||
	    CI > Columnas || CD > Columnas || LS > Lineas || LI > Lineas ||
	    CI > CD || LS > LI )

		ErrorVentana( GVenBuf::CoordenadasInvalidas ) ;

	else
	{
	  for( int I = CI ; I <= CD ; I++ ) // Recorrer las columnas del rea

		for( int J = LS ; J <= LI ; J++ ) // y por cada columna todas sus lneas

			Caracter( I, J ) = C ; // asignando el carcter dado

	  if( ! EsModificado() ) // Si el contenido no estaba modificado
	   {
		EsModificado( GVenBuf::Si ) ; // Ya si est modificado

		Zona . ColI = CI ; // Esta es el rea modificada
		Zona . LinS = LS ;
		Zona . ColD = CD ;
		Zona . LinI = LI ;
	   }
	  else // si ya existe un rea modificada
	   {
		   // Ampliarla si es necesario, segn la zona
		   // que haba modificada y la que se ha modificado ahora

		Zona . ColI = CI < Zona . ColI ? CI : Zona . ColI ;
		Zona . LinS = LS < Zona . LinS ? LS : Zona . LinS ;
		Zona . ColD = CD > Zona . ColD ? CD : Zona . ColD ;
		Zona . LinI = LI > Zona . LinI ? LI : Zona . LinI ;
	   }
	}
 }

	//
	// Mtodo : Col
	//
	// Permite fijar la columna en la que aparecer
	// la ventana en pantalla
	//

void GVenBuf::Col( int C )
 {
	    // Si la ventana queda fuera de pantalla

	if( C + Columnas + 1 > 80 || C < 1 )

			// Generar el error correspondiente
		ErrorVentana( GVenBuf::PosicionInvalida ) ;

	else
		Columna = C ;
 }

	//
	// Mtodo : Lin
	//
	// Permite establecer la lnea en la que la ventana
	// aparecer en pantalla
	//

void GVenBuf::Lin( int L )
 {
	if( L + Lineas + 1 > 50 || L < 1 )

		ErrorVentana( GVenBuf::PosicionInvalida ) ;

	else
		Linea = L ;
 }

	//
	// Mtodo : do_sputn
	//
	// Este es un mtodo virtual heredado de streambuf, que
	// se utilizar cuando un objeto GVentana, derivado de ostream,
	// intente escribir algo.
	//

int GVenBuf::do_sputn( const char * C, int N )
 {
	int M = 0 ; // Caracteres actualmente insertados

	int CI = ColCursor, LS = LinCursor ; // Se comienza a modificar desde esta posicin

	while( N > M++ ) // Mientras queden caracteres a insertar
	 {
		Caracter( ColCursor, LinCursor ) = *C++ ; // Tomar carcter

		Atributo( ColCursor, LinCursor ) = ColorActual ; // Asignar atributo

		  // Actualizar la posicin del cursor

		ColCursor = ColCursor < Columnas ? ColCursor + 1 :
		( LinCursor = LinCursor < Lineas ? LinCursor + 1 : 1, 1 ) ;
	 }

	int CD = ColCursor, LI = LinCursor ; // Se finaliza la modificacin

	if( CD < CI ) // Si la columna derecha es menor que la izquierda

		CI = CD ; // corregir

	if( LS != LI ) // Si se ha avanzado lnea

		CD = Columnas ; // es que se ha llegado al margen derecho

	  if( ! EsModificado() ) // Si el contenido no estaba modificado
	   {
		EsModificado( GVenBuf::Si ) ; // Ya si est modificado

		Zona . ColI = CI ; // Esta es el rea modificada
		Zona . LinS = LS ;
		Zona . ColD = CD ;
		Zona . LinI = LI ;
	   }
	  else // si ya existe un rea modificada
	   {
		   // Ampliarla si es necesario, segn la zona
		   // que haba modificada y la que se ha modificado ahora

		Zona . ColI = CI < Zona . ColI ? CI : Zona . ColI ;
		Zona . LinS = LS < Zona . LinS ? LS : Zona . LinS ;
		Zona . ColD = CD > Zona . ColD ? CD : Zona . ColD ;
		Zona . LinI = LI > Zona . LinI ? LI : Zona . LinI ;
	   }

	return N ; // Devolver nmero de caracteres insertados
 }

	//
	// Mtodo : GestorErroresPorDefecto
	//
	// Este es el mtodo al que se llamar por defecto cuando
	// se produzca un error.
	//

void GVenBuf::GestorErroresPorDefecto( GVenBuf::ErrVen Codigo )
 {
	cerr << "Se produce un error " << Codigo << endl ;
	abort() ;
 }

	//
	// Mtodo : TrazaRecuadro
	//
	// Dibuja el borde alrededor de la ventana
	//

void GVenBuf::TrazaRecuadro()
 {
	struct
	 {
		char EsqSI, EsqSD, EsqII, EsqID,
		     Vertical, Horizontal ;

	 } X[] = { { 32, 32, 32, 32, 32, 32 }, 		// Tipos de borde
		   { 218, 191, 192, 217, 179, 196 }, 	// utilizados inicialmente
		   { 201, 187, 200, 188, 186, 205 },
		   { 219, 219, 219, 219, 219, 219 }
		} ;

	for( int I = 1 ; I <= Columnas ; I++ ) // Recorrer de izquierda a derecha
	 {
		  // Situar los laterales horizontales

		Caracter( I, 0 ) = X[ Borde ] . Horizontal ;
		Caracter( I, Lineas + 1 ) = X[ Borde ] . Horizontal ;

		  // Asignar el atributo correspondiente

		Atributo( I, 0 ) = ColorDefecto ;
		Atributo( I, Lineas + 1 ) = ColorDefecto ;
	 }

	for( I = 1 ; I <= Lineas ; I++ ) // Recorrer de arriba a abajo
	 {
		 // Situar los laterales verticales

		Caracter( 0, I ) = X[ Borde ] . Vertical ;
		Caracter( Columnas + 1, I ) = X[ Borde ] . Vertical ;

		 // Asignar el atributo

		Atributo( 0, I ) = ColorDefecto ;
		Atributo( Columnas + 1, I ) = ColorDefecto ;
	 }

	  // Situar las esquinas del borde

	Caracter( 0, 0 ) = X[ Borde ] . EsqSI ;
	Caracter( Columnas + 1, 0 ) = X[ Borde ] . EsqSD ;
	Caracter( 0, Lineas + 1 ) = X[ Borde ] . EsqII ;
	Caracter( Columnas + 1, Lineas + 1 ) = X[ Borde ] . EsqID ;

	  // Atributo de cada esquina

	Atributo( 0, 0 ) = ColorDefecto ;
	Atributo( Columnas + 1, 0 ) = ColorDefecto ;
	Atributo( 0, Lineas + 1 ) = ColorDefecto ;
	Atributo( Columnas + 1, Lineas + 1 ) = ColorDefecto ;

	EsModificado( GVenBuf::Si ) ;

	Zona . ColI = Zona . LinS = 1 ; // Se ha modificado el rea exterior
	Zona . ColD = Columnas ;
	Zona . LinI = Lineas ;
 }

	//
	// Mtodo : DespArriba
	//
	// Desplaza el contenido de la ventana una lnea hacia arriba
	//

void GVenBuf::DespArriba()
 {
	   // Calcular el origen, destino y longitud del bloque a mover

	unsigned Orig = 2 * ( Columnas + 2 ) * 2 ;
	unsigned Dest = ( Columnas + 2 ) * 2 ;
	unsigned Long = ( Lineas - 1 ) * ( Columnas + 2 ) * 2 ;

		// Mover el bloque, utilizando una zona de memoria auxiliar,
		// para evitar solapamientos, porque movedata no tiene en
		// cuenta la direccin en que se mueven los datos.

	char * Temporal = new char[ Long ] ;

	movedata( FP_SEG( Contenido + Orig ), FP_OFF( Contenido + Orig ),
			  FP_SEG( Temporal ), FP_OFF( Temporal ), Long ) ;

	movedata( FP_SEG( Temporal ), FP_OFF( Temporal ),
			  FP_SEG( Contenido + Dest ), FP_OFF( Contenido + Dest ), Long ) ;

	delete [] Temporal ;

		// Hay que refrescar el rea que se ha desplazado

	Zona . ColI = Zona . LinS = 1 ;
	Zona . ColD = Columnas ;
	Zona . LinI = Lineas ;
 }

	//
	// Mtodo : DespAbajo
	//
	// Desplaza el contenido de la ventana una lnea hacia abajo
	//

void GVenBuf::DespAbajo()
 {
	unsigned Orig = ( Columnas + 2 ) * 2 ;
	unsigned Dest = 2 * ( Columnas + 2 ) * 2 ;
	unsigned Long = ( Lineas - 1 ) * ( Columnas + 2 ) * 2 ;

	char * Temporal = new char[ Long ] ;

	movedata( FP_SEG( Contenido + Orig ), FP_OFF( Contenido + Orig ),
			  FP_SEG( Temporal ), FP_OFF( Temporal ), Long ) ;

	movedata( FP_SEG( Temporal ), FP_OFF( Temporal ),
			  FP_SEG( Contenido + Dest ), FP_OFF( Contenido + Dest ), Long ) ;

	delete [] Temporal ;

		// Hay que refrescar el rea que se ha desplazado

	Zona . ColI = Zona . LinS = 1 ;
	Zona . ColD = Columnas ;
	Zona . LinI = Lineas ;
 }

	//
	// Mtodo : DespIzquierda
	//
	// Desplaza el contenido de la ventana una columna a la izquierda
	//

void GVenBuf::DespIzquierda()
 {
	for( int I = 1 ; I <= Lineas ; I++ ) // Hay que hacerlo lnea a lnea
	 {
		unsigned Orig = I * ( Columnas + 2 ) * 2 + 4 ;
		unsigned Dest = Orig - 2 ;
		unsigned Long = (Columnas-1) * 2 ;

		char * Temporal = new char[ Long ] ;

		movedata( FP_SEG( Contenido + Orig ), FP_OFF( Contenido + Orig ),
				  FP_SEG( Temporal ), FP_OFF( Temporal ), Long ) ;

		movedata( FP_SEG( Temporal ), FP_OFF( Temporal ),
				  FP_SEG( Contenido + Dest ), FP_OFF( Contenido + Dest ), Long ) ;

		delete [] Temporal ;
	 }

		// Hay que refrescar el rea que se ha desplazado

	Zona . ColI = Zona . LinS = 1 ;
	Zona . ColD = Columnas ;
	Zona . LinI = Lineas ;
 }

	//
	// Mtodo : DespDerecha
	//
	// Desplaza el contenido de la ventana una columna a la derecha
	//

void GVenBuf::DespDerecha()
 {
	for( int I = 1 ; I <= Lineas ; I++ ) // Hay que hacerlo lnea a lnea
	 {
		unsigned Orig = I * ( Columnas + 2 ) * 2 + 2 ;
		unsigned Dest = Orig + 2 ;
		unsigned Long = (Columnas-1) * 2 ;

		char * Temporal = new char[ Long ] ;

		movedata( FP_SEG( Contenido + Orig ), FP_OFF( Contenido + Orig ),
				  FP_SEG( Temporal ), FP_OFF( Temporal ), Long ) ;

		movedata( FP_SEG( Temporal ), FP_OFF( Temporal ),
				  FP_SEG( Contenido + Dest ), FP_OFF( Contenido + Dest ), Long ) ;

		delete [] Temporal ;
	 }
		// Hay que refrescar el rea que se ha desplazado

	Zona . ColI = Zona . LinS = 1 ;
	Zona . ColD = Columnas ;
	Zona . LinI = Lineas ;
 }

	//
	// Mtodo : operador de insercin en un stream
	//
	// Escribe la informacin contenida en el objeto en un stream
	//

ostream & operator<< ( ostream & Stream, GVenBuf & O )
 {
		// Escribir los miembros que definen las caractersticas
		// de la ventana

	Stream . write( (char *) & O . Columnas, sizeof( O . Columnas ) ) ;
	Stream . write( (char *) & O . Lineas, sizeof( O . Lineas ) ) ;
	Stream . write( (char *) & O . AspCursor, sizeof( O . AspCursor ) ) ;
	Stream . write( (char *) & O . ColorActual, sizeof( O . ColorActual ) ) ;
	Stream . write( (char *) & O . ColorDefecto, sizeof( O . ColorDefecto ) ) ;
	Stream . write( (char *) & O . Borde, sizeof( O . Borde ) ) ;
	Stream . write( (char *) & O . ColCursor, sizeof( O . ColCursor ) ) ;
	Stream . write( (char *) & O . LinCursor, sizeof( O . LinCursor ) ) ;
	Stream . write( (char *) & O . Columna, sizeof( O . Columna ) ) ;
	Stream . write( (char *) & O . Linea, sizeof( O . Linea ) ) ;

		// Escribir el contenido

	Stream . write( O . Contenido, (O . Columnas+2) * (O . Lineas+2) * 2 ) ;

	return Stream ;
 }

	//
	// Mtodo : operador de extraccin de un stream
	//
	// Crea un objeto tomando los datos de un stream
	//

istream & operator>> ( istream & Stream, GVenBuf & O )
 {
	if( O . Contenido ) // Si la ventana ya tiene asignada una memoria

		delete [] O . Contenido ; // se libera

	Stream . read( (char *) & O . Columnas, sizeof( O . Columnas ) ) ; // Leer los datos de la ventana
	Stream . read( (char *) & O . Lineas, sizeof( O . Lineas ) ) ;
	Stream . read( (char *) & O . AspCursor, sizeof( O . AspCursor ) ) ;
	Stream . read( (char *) & O . ColorActual, sizeof( O . ColorActual ) ) ;
	Stream . read( (char *) & O . ColorDefecto, sizeof( O . ColorDefecto ) ) ;
	Stream . read( (char *) & O . Borde, sizeof( O . Borde ) ) ;
	Stream . read( (char *) & O . ColCursor, sizeof( O . ColCursor ) ) ;
	Stream . read( (char *) & O . LinCursor, sizeof( O . LinCursor ) ) ;
	Stream . read( (char *) & O . Columna, sizeof( O . Columna ) ) ;
	Stream . read( (char *) & O . Linea, sizeof( O . Linea ) ) ;

		// Asignar memoria para el contenido

	O . Contenido = new char[ (O . Columnas+2) * (O . Lineas+2) * 2 ] ;

		// Comprobar que la asignacin de memoria es correcta

	if( ! O . Contenido )

		O . ErrorVentana( GVenBuf::SinMemoria ) ;
	else
	 {
		// Leer el contenido desde el stream

		Stream . read( O . Contenido, (O . Columnas+2) * (O . Lineas+2) * 2 ) ;

		O . EsModificado( GVenBuf::Si ) ;

		O . Zona . ColI = O . Zona . LinS = 1 ;
		O . Zona . ColD = O . Columnas ;
		O . Zona . LinI = O . Lineas ;
	 }

	return Stream ;
 }

	//
	// Mtodos de la clase GVentana
	//


	//
	// Implementacin de los manipuladores a utilizar
	// con los objetos GVentana.
	//

	// Todos los manipuladores funcionan de forma similar:
	// primero comprueban que el stream sobre el que se
	// estn utilizando sea un objeto GVentana, y en caso
	// afirmativo utilizando el mtodo rdbuf() para obtener
	// un puntero al buffer asociado, al GVenBuf, para as
	// poder llamar al mtodo correspondiente.

ostream & _PosCursor( ostream & Stream, int X, int Y )
 {
	if( Stream . flags() & GVentana::EsGES() ) // Asegurarse de que es un GVentana

		( (GVentana &) Stream ). rdbuf() -> FijaPosicionCursor( X, Y ) ; // Llamar al mtodo

	return Stream ; // Devolver referencia al stream
 }

ostream & _AspCursor( ostream & Stream, GVenBuf::TipoCursor T )
 {
	if( Stream . flags() & GVentana::EsGES() )

		( (GVentana &) Stream ). rdbuf() -> AspectoCursor( T ) ;

	return Stream ;
 }

ostream & _TintaV( ostream & Stream, GVenBuf::Color C )
 {
	if( Stream . flags() & GVentana::EsGES() )

		( (GVentana &) Stream ). rdbuf() -> TintaVentana( C ) ;

	return Stream ;
 }

ostream & _FondoV( ostream & Stream, GVenBuf::Color C )
 {
	if( Stream . flags() & GVentana::EsGES() )

		( (GVentana &) Stream ). rdbuf() -> FondoVentana( C ) ;

	return Stream ;
 }

ostream & _TintaA( ostream & Stream, GVenBuf::Color C )
 {
	if( Stream . flags() & GVentana::EsGES() )

		( (GVentana &) Stream ). rdbuf() -> TintaActual( C ) ;

	return Stream ;
 }

ostream & _FondoA( ostream & Stream, GVenBuf::Color C )
 {
	if( Stream . flags() & GVentana::EsGES() )

		( (GVentana &) Stream ). rdbuf() -> FondoActual( C ) ;

	return Stream ;
 }

ostream & _Borde( ostream & Stream, GVenBuf::TipoBorde B )
 {
	if( Stream . flags() & GVentana::EsGES() )

		( (GVentana &) Stream ). rdbuf() -> BordeVentana( B ) ;

	return Stream ;
 }

ostream & Limpia( ostream & Stream )
 {
	if( Stream . flags() & GVentana::EsGES() )

		( (GVentana &) Stream ). rdbuf() -> Limpia() ;

	return Stream ;
 }

ostream & Tab( ostream & Stream )
 {
	if( Stream . flags() & GVentana::EsGES() )
	 {
		int X, Y ;

		   // Se obtiene la posicin actual del cursor

		( (GVentana &) Stream ). rdbuf() -> PosicionCursor( X, Y ) ;

		X += ( 8 - X % 8 ) ; // Se avanza al siguiente punto de tabulacin

		   // Si el cursor sigue estando dentro de la pantalla

		if( X <= ( (GVentana &) Stream ). rdbuf() -> Cols() )

			  // Fijarlo en su nueva posicin

			( (GVentana &) Stream ). rdbuf() -> FijaPosicionCursor( X, Y ) ;

		else // Pero si se sale por el extremo derecho

			Stream << NL ; // Avanzar a la siguiente lnea
	 }

	return Stream ;
 }

ostream & NL( ostream & Stream )
 {
	if( Stream . flags() & GVentana::EsGES() )
	 {
		int X, Y ;

			// Obtener la posicin actual del cursor

		( (GVentana &) Stream ). rdbuf() -> PosicionCursor( X, Y ) ;

		if( Y < ( (GVentana &) Stream ). rdbuf() -> Lins() ) // Si no est en la ltima lnea
		 {
			Y++ ; // Avanza al principio de la siguiente lnea
			X = 1 ;

				// Fija el cursor en la nueva posicin

			( (GVentana &) Stream ). rdbuf() -> FijaPosicionCursor( X, Y ) ;
		 }
	 }

	return Stream ;
 }

	//
	// Aplicadores para los manipuladores con parmetros
	//

	// Todos los aplicadores funcionan de forma similar:
	// crean un objeto de la familia OApp, al que llaman O,
	// pasndole la direccin del mtodo al que tienen que
	// llamar, y a continuacin utilizan el operador (),
	// sobrecargado en las plantillas de Pmanip, para llamar
	// a la funcin con los parmetros recibidos

OManip2<int, int> PosCursor( int X, int Y )
 { OApp2<int, int> O( _PosCursor ) ; return O( X, Y ) ; }

OManip<GVenBuf::TipoCursor> AspCursor( GVenBuf::TipoCursor T )
 { OApp<GVenBuf::TipoCursor> O( _AspCursor ) ; return O( T ) ; }

OManip<GVenBuf::Color> TintaV( GVenBuf::Color C )
 { OApp<GVenBuf::Color> O( _TintaV ) ; return O( C ) ; }

OManip<GVenBuf::Color> FondoV( GVenBuf::Color C )
 { OApp<GVenBuf::Color> O( _FondoV ) ; return O( C ) ; }

OManip<GVenBuf::Color> TintaA( GVenBuf::Color C )
 { OApp<GVenBuf::Color> O( _TintaA ) ; return O( C ) ; }

OManip<GVenBuf::Color> FondoA( GVenBuf::Color C )
 { OApp<GVenBuf::Color> O( _FondoA ) ; return O( C ) ; }

OManip<GVenBuf::TipoBorde> Borde( GVenBuf::TipoBorde B )
 { OApp<GVenBuf::TipoBorde> O( _Borde ) ; return O( B ) ; }

	//
	// Mtodos de la clase GES
	//

	//
	// Mtodo : Constructor
	//
	// Asigna la memoria necesaria para mantener el GES
	//

GES::GES( ModoPantalla M )
 {
	Modo = M ; // Guarda el modo

		// Asigna la memoria necesaria

	Pantalla = new char[ M * 80 * 2 ] ;

		// Comprobar que la asignacin es correcta

	if( ! Pantalla )

		GVenBuf::ErrorVentana( GVenBuf::SinMemoria ) ;
 }

	//
	// Mtodo : Destructor
	//
	// Libera la memoria asignada por el constructor
	//

GES::~GES()
 {
	delete [] Pantalla ; // Libera la memoria
 }

	//
	// Mtodo : Anade
	//
	// Aade una ventana al GES, permitiendo su visualizacin
	// en pantalla.
	//

GVentana * GES::Anade( GVentana & O, int C, int L )
 {
	if( (*this)( O . ID ) == 0 ) // Si la ventana no est ya en el GES
	 {
		Ventanas . InseInicio() ; // Insertarla al principio

		O . rdbuf() -> Columna = C ; // Tomar la posicin en la que aparecer
		O . rdbuf() -> Linea = L ;

		Ventanas << O ; // Aadirla a la lista de ventanas visibles

		return (*this)( O . ID ) ; // Devuelve el puntero a la ventana
	 }

	return 0 ;
 }

	//
	// Mtodo : Elimina
	//
	// Elimina una ventana del GES
	//

void GES::Elimina( GVentana * O )
 {
	Oculta( O ) ; // Primero hay que ocultar la ventana

	Ventanas . Extr( *O ) ; // Extraer a partir de esa ventana
	Ventanas >> *O ; // Extraerla
 }

	//
	// Mtodo : Muestra
	//
	// Hace visible la ventana en pantalla
	//

void GES::Muestra( GVentana * O )
 {
	if( O -> Visible == GVenBuf::No ) // Si no est visible
	 {
		O -> Visible = GVenBuf::Si ; // Se hace visible la ventana

		Area Temporal ;

			// Hay que refrescar ese rea de la pantalla
			// para hacer que la ventana sea visible

		Temporal . ColI = O -> rdbuf() -> Col() ;
		Temporal . LinS = O -> rdbuf() -> Lin() ;
		Temporal . ColD = O -> rdbuf() -> Col() + O -> rdbuf() -> Cols() + 1 ;
		Temporal . LinI = O -> rdbuf() -> Lin() + O -> rdbuf() -> Lins() + 1 ;

			// Si esa zona no est ya en la lista de zonas
			// a refrescar

		if( Zonas . Esta( Temporal ) == Falso )

			Zonas << Temporal ; // adela
	 }
 }

	//
	// Mtodo : Oculta
	//
	// Quita la ventana de la pantalla
	//

void GES::Oculta( GVentana * O )
 {
	if( O -> Visible == GVenBuf::Si ) // Si es visible
	 {
		O -> Visible = GVenBuf::No ; // Ya no es visible

		Area Temporal ;

		  // Hay que refrescar ese rea para ocultar la ventana

		Temporal . ColI = O -> rdbuf() -> Col() ;
		Temporal . LinS = O -> rdbuf() -> Lin() ;
		Temporal . ColD = O -> rdbuf() -> Col() + O -> rdbuf() -> Cols() + 1 ;
		Temporal . LinI = O -> rdbuf() -> Lin() + O -> rdbuf() -> Lins() + 1 ;

		if( Zonas . Esta( Temporal ) == Falso )

			Zonas << Temporal ;
	 }
 }

	//
	// Mtodo : Encima
	//
	// Pone la ventana indicada sobre las dems
	//

void GES::Encima( GVentana * O )
 {
	Ventanas . Primero( *O ) ; // Se pasa al principio

	Area Temporal ;

		// Refrescar el rea ocupada por la ventana

	Temporal . ColI = O -> rdbuf() -> Col() ;
	Temporal . LinS = O -> rdbuf() -> Lin() ;
	Temporal . ColD = O -> rdbuf() -> Col() + O -> rdbuf() -> Cols() + 1 ;
	Temporal . LinI = O -> rdbuf() -> Lin() + O -> rdbuf() -> Lins() + 1 ;

	if( Zonas . Esta( Temporal ) == Falso )

		Zonas << Temporal ;
 }

	//
	// Mtodo : Debajo
	//
	// Pone la ventana indicada bajo las dems
	//

void GES::Debajo( GVentana * O )
 {
	Ventanas . Ultimo( *O ) ; // Se pasa al final

	Area Temporal ;

		// Hay que actualizar el rea que ocupaba la pantalla

	Temporal . ColI = O -> rdbuf() -> Col() ;
	Temporal . LinS = O -> rdbuf() -> Lin() ;
	Temporal . ColD = O -> rdbuf() -> Col() + O -> rdbuf() -> Cols() + 1 ;
	Temporal . LinI = O -> rdbuf() -> Lin() + O -> rdbuf() -> Lins() + 1 ;

	if( Zonas . Esta( Temporal ) == Falso )

		Zonas << Temporal ;
 }

	//
	// Mtodo : Mueve
	//
	// Desplaza la ventana a una nueva posicin
	//

void GES::Mueve( GVentana * O, int X, int Y )
 {
	Area Temporal ;

		// El rea que ocupa la ventana antes de ser movida
		// habr que refrescarla.

	Temporal . ColI = O -> rdbuf() -> Col() ;
	Temporal . LinS = O -> rdbuf() -> Lin() ;
	Temporal . ColD = O -> rdbuf() -> Col() + O -> rdbuf() -> Cols() + 1 ;
	Temporal . LinI = O -> rdbuf() -> Lin() + O -> rdbuf() -> Lins() + 1 ;

	if( Zonas . Esta( Temporal ) == Falso )

		Zonas << Temporal ;

	O -> rdbuf() -> Col( X ) ; // Se actualiza la posicin de la ventana
	O -> rdbuf() -> Lin( Y ) ;

		// Tambin habr que refrescar la nueva zona que ocupa la ventana

	Temporal . ColI = O -> rdbuf() -> Col() ;
	Temporal . LinS = O -> rdbuf() -> Lin() ;
	Temporal . ColD = O -> rdbuf() -> Col() + O -> rdbuf() -> Cols() + 1 ;
	Temporal . LinI = O -> rdbuf() -> Lin() + O -> rdbuf() -> Lins() + 1 ;

	if( Zonas . Esta( Temporal ) == Falso )

		Zonas << Temporal ;
 }

	//
	// Mtodo : Ventana
	//
	// Devuelve el nombre de la ventana que es actualmente visible
	// en un punto dado de la pantalla.
	//

char * GES::Ventana( int X, int Y )
 {
	static char * NULO = "NULL" ;

	GVentana Temporal = Ventanas . Primero() ; // Comienza desde el primer GVentana

	while( istrcmp( Temporal .ID, "NULL" ) ) // Mientras no hayamos llegado al ltimo
	 {

      if( Temporal . Visible ) // Si la ventana es visible
       {
		   // Mirar si el punto X, Y est dentro de la ventana

         if( X >= Temporal . rdbuf() -> Col() &&
			      X <= Temporal . rdbuf() -> Col() + Temporal . rdbuf() -> Cols() + 1 &&
			      Y >= Temporal . rdbuf() -> Lin() &&
               Y <= Temporal . rdbuf() -> Lin() + Temporal . rdbuf() -> Lins() + 1 )

               		return Temporal . ID ; // devolver su nombre
       }

			// Si no pasar a la siguiente

		Temporal = Ventanas . Siguiente( Temporal ) ;
	 }

	return NULO ; // Si no hay ninguna devolver ventana nula
 }

	//
	// Mtodo : Primera
	//
	// Devuelve el nombre de la ventana que est en primer
	// plano en pantalla
	//

char * GES::Primera()
 {
	static char * NULO = "NULL" ;

	GVentana Temporal = Ventanas . Primero() ; // Toma la primera ventana

	while( istrcmp( Temporal . ID, "NULL" ) && ! EsVisible( Temporal . ID ) ) // Si esa ventana no es visible

		Temporal = Ventanas . Siguiente( Temporal ) ; // ir a la siguiente

	if( istrcmp( Temporal . ID, "NULL" ) ) // Si hay ventanas visibles

		return Temporal . ID ;

	else
		return NULO ; // Devolver el nombre de la ventana
 }

	//
	// Mtodo : Ultima
	//
	// Devuelve el nombre de la ltima ventana en pantalla
	//

char * GES::Ultima()
 {
	static char * NULO = "NULL" ;

	GVentana Temporal = Ventanas . Ultimo() ; // Toma la primera ventana

	while( istrcmp( Temporal . ID, "NULL" ) && ! EsVisible( Temporal . ID ) ) // Si esa ventana no es visible

		Temporal = Ventanas . Anterior( Temporal ) ; // ir a la siguiente

	if( istrcmp( Temporal . ID, "NULL" ) ) // Si hay ventanas visibles

		return Temporal . ID ;

	else
		return NULO ; // Devolver el nombre de la ventana
 }

	//
	// Mtodo : Siguiente
	//
	// Devuelve el nombre de la siguiente ventana a una dada
	//

char * GES::Siguiente( GVentana * O )
 {
	static char * NULO = "NULL" ;

	GVentana Temporal = Ventanas . Siguiente( *O ) ; // Comenzar desde la siguiente ventana

	while( istrcmp( Temporal . ID, "NULL" ) && ! EsVisible( Temporal . ID ) ) // Si esa ventana no es visible

		Temporal = Ventanas . Siguiente( Temporal ) ; // ir a la siguiente

	if( istrcmp( Temporal . ID, "NULL" ) ) // Si hay ventanas visibles

		return Temporal . ID ;

	else
		return NULO ; // Devolver el nombre de la ventana
 }

	//
	// Mtodo : Anterior
	//
	// Devuelve el nombre de la ventana anterior a una dada
	//

char * GES::Anterior( GVentana * O )
 {
	static char * NULO = "NULL" ;

	GVentana Temporal = Ventanas . Anterior( *O ) ; // Comenzar desde la ventana anterior

	while( istrcmp( Temporal . ID, "NULL" ) && ! EsVisible( Temporal . ID ) ) // Si esa ventana no es visible

		Temporal = Ventanas . Anterior( Temporal ) ; // ir a la anterior

	if( istrcmp( Temporal . ID, "NULL" ) ) // Si hay ventanas visibles

		return Temporal . ID ;

	else
		return NULO ; // Devolver el nombre de la ventana
 }

	//
	// Mtodo : EsVisible
	//
	// Informa si una ventana es o no visible
	//

int GES::EsVisible( GVentana * O )
 {
	return O -> Visible ;
 }

	//
	// Mtodo : operador ()
	//
	// Recibe el nombre de una ventana y devuelve un puntero a ella
	//

GVentana * GES::operator() ( char * Ventana )
 {
	GVentana * Temporal = Ventanas . pPrimero() ; // Tomar la primera ventana

	while( Temporal != NULL ) // Mientras no hayamos llegado a la ltima

	   if( ! istrcmp( Ventana, Temporal -> ID ) ) // Si coincide el nombre

		    return Temporal ; // devolverla

	   else

		    Temporal = Ventanas . pSiguiente( *Temporal ) ; // ir a la siguiente

	return 0 ; // No se encontr
 }

	//
	// Mtodo : Refresca
	//
	// Compone la imagen en memoria de lo que debera tener la pantalla
	// y llama al mtodo virtual apropiado para redibujar la zona
	// que haya sido modificada
	//

void GES::Refresca()
 {
	 // Esta lista contendr las reas de la pantalla en las que
	 // an no se ha escrito nada

	Lista<Area> Pendientes ;

	Area Temporal, AreaVentana ;

	 // En principio la pantalla entera est vaca
	Temporal . ColI = Temporal . LinS = 1 ;
	Temporal . ColD = 80 ;
	Temporal . LinI = (int ) Modo ;

	Pendientes << Temporal ;

	// Hay que borrar el contenido de la pantalla antes
	// de dibujar en ella

	for( int N = 0 ; N < Modo * 80 ; N++ )
	 {
		* ( Pantalla + N*2 ) = ' ' ;
		* ( Pantalla + N*2 + 1 ) = ( GVenBuf::Negro << 4 ) | GVenBuf::Blanco ;
	 }

	GVentana * V = Ventanas . pPrimero() ; // Toma la primera ventana

	int ActCursor = 0 ; // Indicador de que ha sido actualizado el cursor

	while( V != NULL ) // Mientras no lleguemos a la ltima ventana
	 {
		if( ! EsVisible( V -> ID ) ) // Si la ventana no es visible actualmente
		 {
			V = Ventanas . pSiguiente( * V ) ; // Pasar a la siguiente ventana

			continue ; // y continuar
		 }

		if( ! ActCursor ) // Si es la primera ventana visible que se encuentra
		 {
			  // Se actualiza la posicin del cursor

			  PosCursor( V -> rdbuf() -> Columna + V -> rdbuf() -> ColCursor,
				 V -> rdbuf() -> Linea + V -> rdbuf() -> LinCursor ) ;

			AspCursor( V -> rdbuf() -> AspCursor ) ; // Y su aspecto

			ActCursor = 1 ;
		 }

			// Calcular las coordenadas de pantalla donde
			 // aparece la ventana
		AreaVentana . ColI = V -> rdbuf() -> Col() ;
		AreaVentana . LinS = V -> rdbuf() -> Lin() ;
		AreaVentana . ColD = V -> rdbuf() -> Col() + V -> rdbuf() -> Cols() + 1 ;
		AreaVentana . LinI = V -> rdbuf() -> Lin() + V -> rdbuf() -> Lins() + 1 ;

		Temporal = Pendientes . Primero() ; // Toma el primer rea pendiente de dibujar

		while( Temporal != NULL ) // Mientras no lleguemos al ltimo rea
		 {
			  // Preservar la siguiente zona

			Area Siguiente = Pendientes . Siguiente( Temporal ) ;

			if( AreaVentana | Temporal ) // Si coinciden en algn punto
			 {
				// Volcar a la imagen de pantalla la zona coincidente

				Area AVolcar = Temporal . Coincidente( AreaVentana ) ;

				  // Recorrer todas las lneas

				for( int L = AVolcar . LinS ; L <= AVolcar . LinI ; L++ )
				 {
					  // Tomar una lnea de la ventana y
					  // volcarla a la zona de memoria que
					  // es la pantalla

						 int Li = L - V -> rdbuf() -> Lin() ;
						 int Co = AVolcar . ColI - V -> rdbuf() -> Col() ;
						 int Cos = V -> rdbuf() -> Cols() + 2 ;

						 unsigned Orig = ( Li * Cos + Co ) * 2 ;

						 unsigned Dest = ( (L-1) * 80 + (AVolcar.ColI-1) ) * 2 ;

					movedata( FP_SEG( V -> rdbuf() -> Imagen() + Orig ),
						  FP_OFF( V -> rdbuf() -> Imagen() + Orig ),
						  FP_SEG( Pantalla + Dest ),
						  FP_OFF( Pantalla + Dest ),
						  (AVolcar.ColD-AVolcar.ColI+1) * 2 ) ;
				 }

				// Quitar de la lista de zonas el rea escrita, y
				// aadir las sub-zonas que han quedado pendientes

				Pendientes . Vale() ; // Borrar un posible indicador de error

				Pendientes . Extr( Temporal ) ;
				Pendientes >> Temporal ;

				Matriz<Area> TrozosNoCoincidentes ;

				  // Se hallan las reas no coincidentes

				Temporal . NoCoincidentes( AVolcar, TrozosNoCoincidentes ) ;

				Pendientes . InseInicio() ; // Insertar al principio de la lista

				for( int N = 0 ; N < 4 ; N++ )
							 // Aadirlos a la lista

					  if( Pendientes . Esta( TrozosNoCoincidentes[ N ] ) == Falso )

					Pendientes << TrozosNoCoincidentes[ N ] ;

			 }

			  // Continuar el proceso con la siguiente rea

			Temporal = Siguiente ;

		 } // while reas

		if( V -> rdbuf() -> EsModificado() ) // Si la ventana ha sido modificada
		 {
			Area T = V -> rdbuf() -> Zona ; // Tomar la zona

			T . ColI += V -> rdbuf() -> Col() - 1 ; // Convertir a coordenadas de pantalla
			T . ColD += V -> rdbuf() -> Col() + 1 ;
			T . LinS += V -> rdbuf() -> Lin() - 1 ;
			T . LinI += V -> rdbuf() -> Lin() + 1 ;

			if( Zonas . Esta( T ) == Falso )

				Zonas << T ;

			 // Se desactiva el indicador de modificado
			V -> rdbuf() -> EsModificado( GVenBuf::No ) ;
		 }

		  // Continuar el proceso con la siguiente ventana

		V = Ventanas . pSiguiente( * V ) ;

	 } // while ventanas

	//
	// Llegados a este punto Pantalla tiene la imagen en memoria
	// de lo que debera verse en pantalla, y la lista Zonas
	// contiene todas las reas que hay que refrescar, es posible
	// que incluso repetidas.
	//

	// Hay que evitar el redibujar varias veces la misma zona, por
	// lo que vamos a recorrer la lista Zonas comparando las distintas
	// reas y eliminando las coincidencias, para quedarnos tan slo
	// con las zonas a redibujar.

	Lista<Area> ARedibujar ; // Lista donde quedarn las reas a redibujar

	Zonas . Vale() ; // Borrar un posible indicador de error

	Zonas . ExtrInicio() ; // Extraer desde el inicio de la lista

	Zonas >> Temporal ; // Tomar la primera zona

	while( 1 ) // Mientras no lleguemos a la ltima
	 {
		if( ! Zonas ) // Si la lista se qued vaca

			break ;

		ARedibujar << Temporal ; // Ese rea se redibujar

		Area Busca = Zonas . Primero() ; // Recorrer las zonas que quedan
		Area Siguiente ;

		while( Busca != NULL ) // Mientras queden zonas por inspeccionar
		 {
			  // Preservar la zona siguiente

			Siguiente = Zonas . Siguiente( Busca ) ;

			if( Temporal == Busca ||
			    Temporal & Busca ) // Si las zonas son iguales o estn contenidas
			 {
				Zonas . Extr( Busca ) ;
				Zonas >> Busca ; // Extraer esa zona

			 }
			else // Si no son o iguales o estn contenidas

			if( Temporal | Busca ) // puede ser que se solapen
			 {
				Zonas . Extr( Busca ) ;
				Zonas >> Busca ; // Extraer la zona

				Matriz<Area> Pendientes ;

					 // Obtener las zonas no coincidentes, y que por
					 // lo tanto s hay que refrescar

				Temporal . NoCoincidentes( Busca, Pendientes ) ;

					// Aadirlos a la lista de zonas por redibujar

				for( int I = 0 ; I < 4 ; I++ )

					if( ARedibujar . Esta( Pendientes[I] ) == Falso )

						ARedibujar << Pendientes[I] ;
			 }

			Busca = Siguiente ; // Inspeccionar la siguiente zona

		 } // while

		Zonas . Vale() ;
		Zonas . ExtrInicio() ; // Extraer del inicio de la lista

		Zonas >> Temporal ; // Tomar la primera zona

	 } // while

	//
	// Al llegar aqu es de suponer que la lista ARedibujar
	// contiene slo las reas que es preciso reescribir en
	// pantalla, sin repeticiones que causen el redibujado
	// de una misma zona varias veces.
	//

	ARedibujar . Vale() ; // Borrar indicador de error

	ARedibujar . ExtrInicio() ; // Extraer desde el inicio de la lista

	ARedibujar >> Temporal ;

	while( 1 ) // Extraer todos los elementos de la lista
	 {
		if( ! ARedibujar ) // Si la lista est vaca

			break ;

		Actualiza( Temporal ) ; // Actualizar esa zona

		ARedibujar >> Temporal ; // y extraer la siguiente
	 }

 }

void GES::Refresca2()
 {
	 // Esta lista contendr las reas de la pantalla en las que
	 // an no se ha escrito nada

	Lista<Area> Pendientes ;

	Area Temporal, AreaVentana ;

	 // En principio la pantalla entera est vaca
	Temporal . ColI = Temporal . LinS = 1 ;
	Temporal . ColD = 80 ;
	Temporal . LinI = (int ) Modo ;

	Pendientes << Temporal ;

	// Hay que borrar el contenido de la pantalla antes
	// de dibujar en ella

	for( int N = 0 ; N < Modo * 80 ; N++ )
	 {
		* ( Pantalla + N*2 ) = ' ' ;
		* ( Pantalla + N*2 + 1 ) = ( GVenBuf::Negro << 4 ) | GVenBuf::Blanco ;
	 }

	GVentana * V = Ventanas . pPrimero() ; // Toma la primera ventana

	int ActCursor = 0 ; // Indicador de que ha sido actualizado el cursor

	while( V != NULL ) // Mientras no lleguemos a la ltima ventana
	 {
		if( ! EsVisible( V -> ID ) ) // Si la ventana no es visible actualmente
		 {
			V = Ventanas . pSiguiente( * V ) ; // Pasar a la siguiente ventana

			continue ; // y continuar
		 }

		if( ! ActCursor ) // Si es la primera ventana visible que se encuentra
		 {
			  // Se actualiza la posicin del cursor

			  PosCursor( V -> rdbuf() -> Columna + V -> rdbuf() -> ColCursor,
				 V -> rdbuf() -> Linea + V -> rdbuf() -> LinCursor ) ;

			AspCursor( V -> rdbuf() -> AspCursor ) ; // Y su aspecto

			ActCursor = 1 ;
		 }

			// Calcular las coordenadas de pantalla donde
			 // aparece la ventana
		AreaVentana . ColI = V -> rdbuf() -> Col() ;
		AreaVentana . LinS = V -> rdbuf() -> Lin() ;
		AreaVentana . ColD = V -> rdbuf() -> Col() + V -> rdbuf() -> Cols() + 1 ;
		AreaVentana . LinI = V -> rdbuf() -> Lin() + V -> rdbuf() -> Lins() + 1 ;

		Temporal = Pendientes . Primero() ; // Toma el primer rea pendiente de dibujar

		while( Temporal != NULL ) // Mientras no lleguemos al ltimo rea
		 {
			  // Preservar la siguiente zona

			Area Siguiente = Pendientes . Siguiente( Temporal ) ;

			if( AreaVentana | Temporal ) // Si coinciden en algn punto
			 {
				// Volcar a la imagen de pantalla la zona coincidente

				Area AVolcar = Temporal . Coincidente( AreaVentana ) ;

				  // Recorrer todas las lneas

				for( int L = AVolcar . LinS ; L <= AVolcar . LinI ; L++ )
				 {
					  // Tomar una lnea de la ventana y
					  // volcarla a la zona de memoria que
					  // es la pantalla

						 int Li = L - V -> rdbuf() -> Lin() ;
						 int Co = AVolcar . ColI - V -> rdbuf() -> Col() ;
						 int Cos = V -> rdbuf() -> Cols() + 2 ;

						 unsigned Orig = ( Li * Cos + Co ) * 2 ;

						 unsigned Dest = ( (L-1) * 80 + (AVolcar.ColI-1) ) * 2 ;

					movedata( FP_SEG( V -> rdbuf() -> Imagen() + Orig ),
						  FP_OFF( V -> rdbuf() -> Imagen() + Orig ),
						  FP_SEG( Pantalla + Dest ),
						  FP_OFF( Pantalla + Dest ),
						  (AVolcar.ColD-AVolcar.ColI+1) * 2 ) ;
				 }

				// Quitar de la lista de zonas el rea escrita, y
				// aadir las sub-zonas que han quedado pendientes

				Pendientes . Vale() ; // Borrar un posible indicador de error

				Pendientes . Extr( Temporal ) ;
				Pendientes >> Temporal ;

				Matriz<Area> TrozosNoCoincidentes ;

				  // Se hallan las reas no coincidentes

				Temporal . NoCoincidentes( AVolcar, TrozosNoCoincidentes ) ;

				Pendientes . InseInicio() ; // Insertar al principio de la lista

				for( int N = 0 ; N < 4 ; N++ )
							 // Aadirlos a la lista

					  if( Pendientes . Esta( TrozosNoCoincidentes[ N ] ) == Falso )

					Pendientes << TrozosNoCoincidentes[ N ] ;

			 }

			  // Continuar el proceso con la siguiente rea

			Temporal = Siguiente ;

		 } // while reas

		// if( V -> rdbuf() -> EsModificado() ) // Si la ventana ha sido modificada
		// {
			Area T = V -> rdbuf() -> Zona ; // Tomar la zona

			T . ColI += V -> rdbuf() -> Col() - 1 ; // Convertir a coordenadas de pantalla
			T . ColD += V -> rdbuf() -> Col() + 1 ;
			T . LinS += V -> rdbuf() -> Lin() - 1 ;
			T . LinI += V -> rdbuf() -> Lin() + 1 ;

			if( Zonas . Esta( T ) == Falso )

				Zonas << T ;

			 // Se desactiva el indicador de modificado
			V -> rdbuf() -> EsModificado( GVenBuf::No ) ;
		 // }

		  // Continuar el proceso con la siguiente ventana

		V = Ventanas . pSiguiente( * V ) ;

	 } // while ventanas

	//
	// Llegados a este punto Pantalla tiene la imagen en memoria
	// de lo que debera verse en pantalla, y la lista Zonas
	// contiene todas las reas que hay que refrescar, es posible
	// que incluso repetidas.
	//

	// Hay que evitar el redibujar varias veces la misma zona, por
	// lo que vamos a recorrer la lista Zonas comparando las distintas
	// reas y eliminando las coincidencias, para quedarnos tan slo
	// con las zonas a redibujar.

	Lista<Area> ARedibujar ; // Lista donde quedarn las reas a redibujar

	Zonas . Vale() ; // Borrar un posible indicador de error

	Zonas . ExtrInicio() ; // Extraer desde el inicio de la lista

	Zonas >> Temporal ; // Tomar la primera zona

	while( 1 ) // Mientras no lleguemos a la ltima
	 {
		if( ! Zonas ) // Si la lista se qued vaca

			break ;

		ARedibujar << Temporal ; // Ese rea se redibujar

		Area Busca = Zonas . Primero() ; // Recorrer las zonas que quedan
		Area Siguiente ;

		while( Busca != NULL ) // Mientras queden zonas por inspeccionar
		 {
			  // Preservar la zona siguiente

			Siguiente = Zonas . Siguiente( Busca ) ;

			if( Temporal == Busca ||
			    Temporal & Busca ) // Si las zonas son iguales o estn contenidas
			 {
				Zonas . Extr( Busca ) ;
				Zonas >> Busca ; // Extraer esa zona

			 }
			else // Si no son o iguales o estn contenidas

			if( Temporal | Busca ) // puede ser que se solapen
			 {
				Zonas . Extr( Busca ) ;
				Zonas >> Busca ; // Extraer la zona

				Matriz<Area> Pendientes ;

					 // Obtener las zonas no coincidentes, y que por
					 // lo tanto s hay que refrescar

				Temporal . NoCoincidentes( Busca, Pendientes ) ;

					// Aadirlos a la lista de zonas por redibujar

				for( int I = 0 ; I < 4 ; I++ )

					if( ARedibujar . Esta( Pendientes[I] ) == Falso )

						ARedibujar << Pendientes[I] ;
			 }

			Busca = Siguiente ; // Inspeccionar la siguiente zona

		 } // while

		Zonas . Vale() ;
		Zonas . ExtrInicio() ; // Extraer del inicio de la lista

		Zonas >> Temporal ; // Tomar la primera zona

	 } // while

	//
	// Al llegar aqu es de suponer que la lista ARedibujar
	// contiene slo las reas que es preciso reescribir en
	// pantalla, sin repeticiones que causen el redibujado
	// de una misma zona varias veces.
	//

	ARedibujar . Vale() ; // Borrar indicador de error

	ARedibujar . ExtrInicio() ; // Extraer desde el inicio de la lista

	ARedibujar >> Temporal ;

	while( 1 ) // Extraer todos los elementos de la lista
	 {
		if( ! ARedibujar ) // Si la lista est vaca

			break ;

		Actualiza( Temporal ) ; // Actualizar esa zona

		ARedibujar >> Temporal ; // y extraer la siguiente
	 }

 }

	//
	// Mtodos de la clase GESTexto
	//

	//
	// Mtodo : Actualiza
	//
	// Realiza la salida de una zona de la pantalla
	//

void GESTexto::Actualiza( Area & Z )
 {
	GRaton Raton ;

	Raton . OcultaCursor() ; // Ocultar el cursor del ratn

	   // Hay que actualizar lnea a lnea

	for( int I = Z . LinS ; I <= Z . LinI ; I++ )

		puttext( Z . ColI, I, Z . ColD, I, // Mostrar en pantalla
			( Pantalla + (I-1) * 160 + (Z . ColI-1) * 2 ) ) ;

	Raton . MuestraCursor() ; // Vuelve a mostrarlo
 }

	//
	// Mtodo : PosCursor
	//
	// Fija el cursor en una determinada posicin de una ventana
	//

void GESTexto::PosCursor( int X, int Y )
 {
	gotoxy( X, Y ) ;
 }

	//
	// Mtodo : AspCursor
	//
	// Modifica el aspecto del cursor en pantalla de texto
	//

void GESTexto::AspCursor( GVenBuf::TipoCursor C )
 {
	_setcursortype( C ) ;
 }
