	//ͻ
	//  GVentana.Hpp                          
	//                                        
	//  Definicin de las clases de salida    
	//  por pantalla y asociadas.             
	//                                        
	//  Agosto 1992                           
	//ͼ


#ifndef _GVENTANA_HPP_   // Asegurar que no se incluye ms de una vez

#define _GVENTANA_HPP_

#ifndef __cplusplus
#error No se pueda usar GVentana en C // Hay que utilizar el compilador C++
#endif

#include <iostream.h> // Para derivar de streambuf y ostream

#include <string.h> // Para usar funciones de tratamiento de cadenas

	// Si el modelo de memoria seleccionado permite varios segmentos de datos
	// habr que utilizar las versiones far de algunas funciones

#if defined(__LARGE__) || defined(__HUGE__) || defined(__COMPACT__)

	#define istrcpy( orig, dest )	_fstrcpy( (orig), (dest) )
	#define istrcmp( orig, dest )	_fstrcmp( (orig), (dest) )
	#define istrcat( orig, dest )	_fstrcat( (orig), (dest) )
	#define istrchr( cade, cara )	_fstrchr( (cade), (cara) )
	#define istrlen( cade )			_fstrlen( (cade) )
	#define imemcmp( orig, dest, long ) _fmemcmp( (orig), (dest), (long) )

#else

	#define istrcpy( orig, dest )	strcpy( (orig), (dest) )
	#define istrcmp( orig, dest )	strcmp( (orig), (dest) )
	#define istrcat( orig, dest )	strcat( (orig), (dest) )
	#define istrchr( cade, cara )	strchr( (cade), (cara) )
	#define istrlen( cade )			strlen( (cade) )
	#define imemcmp( orig, dest, long ) memcmp( (orig), (dest), (long) )

#endif

#include <conio.h> // Contiene enumeraciones de colores, prototipos de
		   // funciones de acceso a pantalla, etc.

#include "EstDat.Hpp" // Plantillas de estructuras de datos

#include "PManip.Hpp" // Para creacin de manipuladores parametrizados

	//
	// Clase : Area
	//
	// Deriva de : -
	//
	// Base de : -
	//
	// Finalidad : Mantener zonas de pantalla
	//
	// Fecha de creacin : Agosto 1992
	//
	// Fecha de revisin : -
	//

class Area  // Estructura para registrar reas modificadas y pendientes de refrescar
 {
     public :

	  // El constructor por defecto crea un objeto vaco

	Area() { ColI = LinS = ColD = LinI = 0 ; }

	  // El constructor de copia

	Area( Area & O ) { ColI = O . ColI ; LinS = O . LinS ;
			   ColD = O . ColD ; LinI = O . LinI ; }

	  // Constructor para crear objetos nulos

	Area( int ) { ColI = LinS = ColD = LinI = 0 ; }

	  // Comprobar si dos objetos son iguales o distintos

	int operator== ( const Area & O )

	 { return ColI == O . ColI && LinS == O . LinS &&
		  ColD == O . ColD && LinI == O . LinI ; }

	 // Comprobar que dos objetos son distintos

	int operator!= ( const Area & O )

	  { return ! operator==( O ) ; }

	   // Operador de insercin en stream

	friend ostream & operator<< ( ostream & Stream, Area & O )

	   { Stream . write( (char *) & O, sizeof( O ) ) ; return Stream ; }

	   // Operador de extraccin de stream

	friend istream & operator>> ( istream & Stream, Area & O )

	   { Stream . read( (char *) & O, sizeof( O ) ) ; return Stream ; }

	   // Devuelve distinto de 0 si un rea est dentro de otra

	int operator & ( Area & O )

	 { return ColI <= O . ColI && LinS <= O . LinS &&
		  ColD >= O . ColD && LinI >= O . LinI ; }

	   // Devuelve distinto de 0 si un rea no solapa en ningn punto a otra

	int operator ^ ( Area & O )

	 { return ColI > O . ColD || LinS > O . LinI ||
		  ColD < O . ColI || LinI < O . LinS ; }

	    // Devuelve distinto de 0 si un rea solapa a otra en algn punto

	 int operator | ( Area & O )

	  { return ! operator^( O ) ; }

	   // Mtodo para obtener el rea coincidente entre dos reas dadas

	 Area Coincidente( Area & ) ;

	   // Mtodo para obtener las reas no coincidentes entre dos reas dadas

	 void NoCoincidentes( Area &, Matriz<Area> & ) ;

	  // Miembros para mantener las coordenadas del rea

	int ColI, LinS, ColD, LinI ;
 } ;

class GES ; // Referencia avanzada

	//
	// Clase : GVenBuf
	//
	// Deriva de : streambuf
	//
	// Base de : -
	//
	// Finalidad : Servir como buffer de los
	//	       objetos GVentana y derivados
	//
	// Fecha de creacin : 12 Agosto 1992
	//
	// Fecha de revisin : -
	//

class GVenBuf : public streambuf
 {
	public :

		 friend class GES ; // La clase GES tiene acceso a GVenBuf

		 // Enumeracin de los posibles aspectos del cursor

		enum TipoCursor { SinCursor = _NOCURSOR,
				  CursorNormal = _NORMALCURSOR,
				  CursorBloque = _SOLIDCURSOR } ;

		 // Enumeracin con los colores

		enum Color { Negro = BLACK, Azul = BLUE, Verde = GREEN,
		       Celeste = CYAN, Rojo = RED, Malva = MAGENTA,
		       Marron = BROWN, GrisClaro = LIGHTGRAY,
		       GrisOscuro = DARKGRAY, AzulClaro = LIGHTBLUE,
		       VerdeClaro = LIGHTGREEN, CelesteClaro = LIGHTCYAN,
		       RojoClaro = LIGHTRED, MalvaClaro = LIGHTMAGENTA,
		       Amarillo = YELLOW, Blanco = WHITE
		     } ;

		     // Tipos posibles de borde para una ventana

		enum TipoBorde { Ninguno, Simple, Doble, Grueso } ;

		enum SN { No, Si } ;

		     // Enumeracin con los posibles errores

		enum ErrVen { SinMemoria, CursorFueraLimites,
			      CoordenadasInvalidas, TipoCursorInvalido,
			      TipoBordeInvalido, PosicionInvalida } ;

		 // Crea el buffer necesario para mantener una ventana
		 // con las dimensiones dadas

		GVenBuf( int, int, TipoBorde = Ninguno, Color = Blanco, Color = Negro ) ;

		GVenBuf( GVenBuf & ) ; // Constructor de copia

		GVenBuf() ; // Constructor de objeto vaco

		~GVenBuf() ; // Destruye la ventana

		void operator= ( const GVenBuf & ) ; // Operador de asignacin

		int operator== ( const GVenBuf & ) ; // Operador relacional de igualdad

		void PosicionCursor( int &, int & ) ; // Informa sobre la posicin actual del cursor
		void FijaPosicionCursor( int, int ) ; // Posiciona el cursor

		int Cols() ; // Devuelve el nmero de columnas de la ventana
		int Lins() ; // Devuelve el nmero de lneas de la ventana

		TipoCursor AspectoCursor() ; // Devuelve el aspecto actual del cursor
		void AspectoCursor( TipoCursor ) ; // Fija el aspecto del cursor

		Color TintaVentana() ; // Devuelve el color de tinta de la ventana
		void TintaVentana( Color ) ; // Fija el color de tinta de la ventana

		Color FondoVentana() ; // Devuelve el color de fondo de la ventana
		void FondoVentana( Color ) ; // Fija el color de fondo de la ventana

		Color TintaActual() ; // Devuelve el color de tinta actual
		void TintaActual( Color ) ; // Fija el color de tinta actual

		Color FondoActual() ; // Devuelve el color de fondo actual
		void FondoActual( Color ) ; // Fija el color de fondo actual

		TipoBorde BordeVentana() ; // Devuelve el tipo de borde actual
		void BordeVentana( TipoBorde ) ; // Fija el tipo de borde

		void Limpia() ; // Limpia el contenido de la ventana
		void Limpia( int, int, int, int ) ; // Limpia un recuadro de la ventana

		char & Caracter( int, int ) ; // Devuelve el carcter que est en una cierta posicin
		char & Atributo( int, int ) ; // Devuelve el atributo

		void FijaFondo( int, int, int, int, Color ) ; // Cambiar el color de fondo de un rea
		void FijaTinta( int, int, int, int, Color ) ; // Cambiar el color de tinta de un rea

		void FijaRelleno( int, int, int, int, char ) ; // Llenar una zona de un cierto carcter

		char * Imagen() ; // Devuelve el puntero al contenido de la ventana

		SN EsModificado() ; // Indica si se ha modificado o no

		void ( * GestorErrores() )( ErrVen ); // Devuelve la direccin del actual gestor de errores
		void GestorErrores( void (*)( ErrVen ) ) ; // Fija un nuevo controlador

		 // Operadores para escribir y leer un objeto en un stream

		friend ostream & operator<< ( ostream &, GVenBuf & ) ;
		friend istream & operator>> ( istream &, GVenBuf & ) ;

		int Col() ; // Devuelve la posicin horizontal en pantalla
		int Lin() ; // Devuelve la posicin vertical en pantalla

		void DespArriba() ; // Desplaza el contenido de la ventana hacia arriba
		void DespAbajo() ; // Hacia abajo
		void DespIzquierda() ; // Hacia la izquierda
		void DespDerecha() ; // Hacia la derecha

	protected :

		 // Mtodo virtual que hace posible la escritura
		 // de datos en el buffer

		int do_sputn( const char *, int ) ;

		 // Este mtodo se hereda de streambuf y es virtual.
		 // Cuando se realiza una salida del stream se llama
		 // a sync() para que realice los ajustes necesarios
		 // y devuelva 0 o EOF, segn que todo est correcto
		 // o se haya producido un error. En este caso bastar
		 // con devolver 0, ya que la salida al dispositivo
		 // no la realiza esta clase.

		int sync() { return 0 ; }

		// Al igual que el anterior este mtodo tambin es
		// virtual, y se le llama cada vez que el buffer
		// est lleno y hay que volcarlo al dispositivo
		// final. En este caso bastar con devolver un 0
		// para indicar que todo es correcto.

		int overflow( int ) { return 0 ; }

	private :

		static void (* ErrorVentana)( ErrVen ) ; // Puntero a la funcin de gestin de errores

		static void GestorErroresPorDefecto( ErrVen ) ; // Gestor por defecto de los errores

		void TrazaRecuadro() ; // Dibuja el recuadro en memoria

		int Columnas, Lineas ; // Dimensiones de la ventana

		int ColorActual, ColorDefecto ; // Atributo actual de escritura y atributo inicial

		TipoCursor AspCursor ; // Aspecto actual del cursor

		TipoBorde Borde ; // Tipo de borde para la ventana

		SN Modificado ; // Indicador de ventana modificada

		Area Zona ; // Zona de la ventana que ha sido modificada

		void EsModificado( SN ) ; // Activa/Desactiva indicador de modificado

		int ColCursor, LinCursor ; // Posicion actual del cursor

		int Columna, Linea ; // Posicin de la ventana en pantalla

		void Col( int ) ; // Fija la posicin horizontal en pantalla

		void Lin( int ) ; // Fija la posicin horizontal en pantalla

		char * Contenido ; // Puntero al contenido de la ventana

 } ; // GVenBuf

	// Implementacin de los mtodos inline

	//
	// Mtodo : Constructor por defecto
	//
	// Crea un objeto vaco
	//

inline GVenBuf::GVenBuf()

       { Contenido = NULL ; }

	//
	// Mtodo : PosicionCursor
	//
	// Facilita la obtencin de la posicin actual del cursor
	//

inline void GVenBuf::PosicionCursor( int & X, int & Y )

	{ X = ColCursor ; // Toma la posicin del cursor y la
	  Y = LinCursor ; // almacena en las referencias recibidas
	}

	//
	// Mtodo : Cols
	//
	// Devuelve el nmero de columnas de la ventana
	//

inline int GVenBuf::Cols()

	{ return Columnas ; }

	//
	// Mtodo : Lins
	//
	// Devuelve el nmero de lneas de la ventana
	//

inline int GVenBuf::Lins()

	{ return Lineas ; }

	//
	// Mtodo : AspectoCursor
	//
	// Devuelve el tipo de cursor actual en la ventana
	//

inline GVenBuf::TipoCursor GVenBuf::AspectoCursor()

	{ return AspCursor ; }

	//
	// Mtodo : TintaVentana
	//
	// Devuelve el color que est fijado actualmente como
	// color por defecto para la ventana
	//

inline GVenBuf::Color GVenBuf::TintaVentana()

	{ return Color( ColorDefecto & 0xf ) ; }

	//
	// Mtodo : TintaVentana
	//
	// Permite modificar el color de tinta por defecto
	//

inline void GVenBuf::TintaVentana( Color C )

	{ ColorDefecto = ( ColorDefecto & 0xf0 ) | C ; }

	//
	// Mtodo : FondoVentana
	//
	// Devuelve el color fijado actualmente como color
	// de fondo por defecto
	//

inline GVenBuf::Color GVenBuf::FondoVentana()

	{ return Color( ColorDefecto >> 4 ) ; }

	//
	// Mtodo : FondoVentana
	//
	// Permite fijar un nuevo color de fondo por defecto
	//

inline void GVenBuf::FondoVentana( Color C )

	{ ColorDefecto = ( ColorDefecto & 0xf ) | ( C << 4 ) ; }

	//
	// Mtodo : TintaActual
	//
	// Devuelve el color de tinta que se est utilizando actualmente
	//

inline GVenBuf::Color GVenBuf::TintaActual()

	{ return Color( ColorActual & 0xf ) ; }

	//
	// Mtodo : TintaActual
	//
	// Permite fijar un nuevo color de tinta actual
	//

inline void GVenBuf::TintaActual( Color C )

	{ ColorActual = ( ColorActual & 0xf0 ) | C ; }

	//
	// Mtodo : FondoActual
	//
	// Devuelve el color de fondo que se est utilizando actualmente
	//

inline GVenBuf::Color GVenBuf::FondoActual()

	{ return Color( ColorActual >> 4 ) ; }

	//
	// Mtodo : FondoActual
	//
	// Permite establecer un nuevo color de fondo actual
	//

inline void GVenBuf::FondoActual( Color C )

	{ ColorActual = ( ColorActual & 0xf ) | ( C << 4 ) ; }

	//
	// Mtodo : BordeVentana
	//
	// Devuelve el tipo actual de borde que tiene la ventana
	//

inline GVenBuf::TipoBorde GVenBuf::BordeVentana()

	{ return Borde ; }

	//
	// Mtodo : Limpia
	//
	// Limpia el contenido actual de toda la ventana
	//

inline void GVenBuf::Limpia()

	{ Limpia( 1, 1, Columnas, Lineas ) ; }

	//
	// Mtodo : Limpia
	//
	// Limpia el contenido actual del rea delimitada
	// por las coordenadas, restableciendo los colores
	// por defecto.
	//

inline void GVenBuf::Limpia( int CI, int LS, int CD, int LI )

	{ FijaRelleno( CI, LS, CD, LI, ' ' ) ;
	  FijaFondo( CI, LS, CD, LI, Color( ColorDefecto >> 4 ) ) ;
	  FijaTinta( CI, LS, CD, LI, Color( ColorDefecto & 0xf ) ) ; }

	//
	// Mtodo : Col
	//
	// Devuelve la columna en la que aparece la ventana en pantalla
	//

inline int GVenBuf::Col()

	{ return Columna ; }

	//
	// Mtodo : Lin
	//
	// Devuelve la lnea en la que la ventana aparece en pantalla
	//

inline int GVenBuf::Lin()

	{ return Linea ; }

	//
	// Mtodo : Imagen
	//
	// Devuelve la direccin del contenido de la ventana, dando
	// paso a que otros mtodos puedan utilizar esa informacin
	// para almacenarla, representarla, etc.
	//

inline char * GVenBuf::Imagen()

	{ return Contenido ; }

	//
	// Mtodo : EsModificado
	//
	// Devuelve Si o No, dependiendo de que la ventana haya
	// sido modificada o no
	//

inline GVenBuf::SN GVenBuf::EsModificado()

	{ return Modificado ; }

	//
	// Mtodo : EsModificado
	//
	// Permite alterar el estado del indicador de modificado
	//

inline void GVenBuf::EsModificado( SN M )

	{ Modificado = M ; }

	//
	// Mtodo : GestorErrores
	//
	// Devuelve la direccin del gestor de errores actualmente
	// establecido para la clase
	//

inline void ( * GVenBuf::GestorErrores() ) ( GVenBuf::ErrVen )

	{ return ErrorVentana ; }

	//
	// Mtodo : GestorErrores
	//
	// Permite establecer un nuevo gestor de errores
	//

inline void GVenBuf::GestorErrores( void ( * F ) ( GVenBuf::ErrVen ) )

	{ ErrorVentana = F ; }

	//
	// Clase : GVentana
	//
	// Deriva de : ostream
	//
	// Base de : -
	//
	// Finalidad : Ser interfaz de salida de
	//	       datos a una ventana
	//
	// Fecha de creacin : 12 Agosto 1992
	//
	// Fecha de revisin : -
	//

class GVentana : public ostream
 {
	public :

		friend class GES ; // La clase GES tiene acceso a GVentana

		GVentana() ; // Constructor por defecto, crea un objeto vaco

		  // Constructor estndar, toma los parmetros necesarios
		  // para definir una ventana

		GVentana( char *, int, int, GVenBuf::TipoBorde = GVenBuf::Ninguno,
					GVenBuf::Color = GVenBuf::Negro,
					GVenBuf::Color = GVenBuf::Blanco )  ;

		~GVentana() ; // Destructor

		GVenBuf * rdbuf() ; // Devuelve el buffer asociado

		static long EsGES() ; // Devuelve bit indicador

		 // Mtodos necesarios para poder crear listas de GVentana

		GVentana( GVentana & ) ; // Constructor de copia

		GVentana( int ) ; // Crear un objeto nulo

		void operator= ( const GVentana & ) ; // Asignar un objeto a otro

		int operator== ( const GVentana & ) ; // Comprobar si son iguales

		     // Para poder insertar y extraer objetos de un stream

		friend ostream & operator<< ( ostream &, GVentana & ) ;
		friend istream & operator>> ( istream &, GVentana & ) ;

	private :

		 // Bit para saber si el stream es un GES o no

		static long fGES ;

		GVenBuf::SN Visible ; // Indicador de si est visible

		char ID[ 21 ] ; // Identificador de la ventana

		GVenBuf Buffer ; // Buffer del objeto

 } ; // GVentana

	//
	// Mtodo : Constructor por defecto
	//
	// Crea un objeto vaco

inline GVentana::GVentana() : Buffer() // Inicializa Buffer, que es el GVenBuf asociado

	{ ios::init( & Buffer ) ; setf( fGES ) ; istrcpy( ID, "NULL" ) ; Visible = GVenBuf::No ; }

	//
	// Mtodo : Constructor estndar
	//
	// Crea un objeto segn los parmetros facilitados

inline GVentana::GVentana( char * I, int C, int L, GVenBuf::TipoBorde B, GVenBuf::Color T, GVenBuf::Color F ) :

			 // Llama al constructor del objeto GVenBuf creando el buffer
		      Buffer( C, L, B, T, F )

	       // Inicializa los dems parmetros
	{ ios::init( & Buffer ) ; setf( fGES ) ; istrcpy( ID, I ) ; Visible = GVenBuf::No ; }

	//
	// Mtodo : Constructor de copia
	//
	// Permite construir un objeto a partir otro
	//

inline GVentana::GVentana( GVentana & O ) : Buffer( O . Buffer )

	 { ios::init( & Buffer ) ; setf( fGES ) ; istrcpy( ID, O . ID ) ; Visible = O . Visible ; }

	//
	// Mtodo : Constructor de conversin int
	//
	// Su finalidad es crear un objeto nulo
	//

inline GVentana::GVentana( int ) : Buffer()

	{ ios::init( & Buffer ) ; setf( fGES ) ; istrcpy( ID, "NULL" ) ; }

	//
	// Mtodo : Destructor
	//

inline GVentana::~GVentana()

       { }

	//
	// Mtodo : rdbuf()
	//
	// Devuelve un puntero al GVenBuf asociado con la GVentana
	//

inline GVenBuf * GVentana::rdbuf()

	{ return & Buffer ; } // Devuelve direccin del buffer

	//
	// Mtodo : EsGES
	//
	// Devuelve la posicin del bit indicador, con el que
	// es posible comprobar si el objeto es un GES o un ostream normal
	//

inline static long GVentana::EsGES()

	{ return fGES ; } // Devuelve bit indicador

	//
	// Mtodo : operador =
	//
	// Permite asignar un objeto a otro
	//

inline void GVentana::operator= ( const GVentana & O )

	    // Asigna el buffer,		y el nombre de la ventana
	{ *rdbuf() = *((GVentana &)O).rdbuf() ; istrcpy( ID, O . ID ) ; Visible = O . Visible ; }

	//
	// Mtodo : operador ==
	//
	// Permite comparar dos objetos
	//

inline int GVentana::operator== ( const GVentana & O )

	{ return ! istrcmp( ID, O . ID ) ; } // Compara los dos nombres

	//
	// Mtodo : operador de insercin en un stream
	//
	// Permite escribir una ventana en un stream
	//

inline ostream & operator<< ( ostream & Stream, GVentana & O )

	  // Insertar el nombre de la ventana, y su buffer
	{ Stream . write( O . ID, 21 ) ; return Stream << *O . rdbuf() ; }

	//
	// Mtodo : operador de extraccin desde un stream
	//
	// Permite leer una ventana almacenada en un stream
	//

inline istream & operator>> ( istream & Stream, GVentana & O )

	  // Extraer el nombre de la ventana, y su buffer
	{ Stream . read( O . ID, 21 ) ; return Stream >> *O . rdbuf() ; }

	// Prototipos de los manipuladores

	// Posiciona el cursor

OManip2<int, int> PosCursor( int, int ) ;

	// Fija el tipo de cursor

OManip<GVenBuf::TipoCursor> AspCursor( GVenBuf::TipoCursor ) ;

	// Fija el color de tinta por defecto

OManip<GVenBuf::Color> TintaV( GVenBuf::Color ) ;

	// Fija el color de fondo por defecto

OManip<GVenBuf::Color> FondoV( GVenBuf::Color ) ;

	// Fija el color de tinta actual

OManip<GVenBuf::Color> TintaA( GVenBuf::Color ) ;

	// Fija el color de fondo actual

OManip<GVenBuf::Color> FondoA( GVenBuf::Color ) ;

	// Fija el tipo de borde para la ventana

OManip<GVenBuf::TipoBorde> Borde( GVenBuf::TipoBorde ) ;

	// Limpia el contenido de la ventana

ostream & Limpia( ostream & ) ;

	// Avanza hasta el siguiente punto de tabulacin

ostream & Tab( ostream & ) ;

	// Avanza hasta la siguiente lnea

ostream & NL( ostream & ) ;

	//
	// Clase : GES
	//
	// Deriva de : -
	//
	// Base de : GESTexto, GESGrafico
	//
	// Finalidad : Gestionar la presentacin en
	//	       pantalla de objetos GVentana
	//
	// Fecha de creacin : 13 Agosto 1992
	//
	// Fecha de revisin : -
	//

class GES
 {
	public :

		  // Modos de pantalla en los que se puede trabajar

		enum ModoPantalla { Modo25 = 25, Modo43 = 43, Modo50 = 50 } ;

		 // Al crear el objeto hay que indicar el modo de pantalla

		GES( ModoPantalla ) ;

		~GES() ; // Destructor

		 // Aade la ventana al GES dndole una posicin inicial

		GVentana * Anade( GVentana &, int, int ) ;

		 // Devuelve la direccin de la ventana indicada

		GVentana * operator() ( char * ) ;

		 // Elimina la ventana del GES

		void Elimina( char * ) ;
		void Elimina( GVentana * ) ;

		 // Hace visible la ventana indicada

		void Muestra( char * ) ;
		void Muestra( GVentana * ) ;

		 // Oculta la ventana

		void Oculta( char * ) ;
		void Oculta( GVentana * ) ;

		 // Pone la ventana indicada sobre las dems, en primer plano

		void Encima( char * ) ;
		void Encima( GVentana * ) ;

		 // Pone la ventana indicada bajo las dems

		void Debajo( char * ) ;
		void Debajo( GVentana * ) ;

		 // Desplaza la ventana indicada

		void Mueve( char *, int, int ) ;
		void Mueve( GVentana *, int, int ) ;

		 // Devuelve la ventana que es actualmente visible
		 // en una posicin dada

		char * Ventana( int, int ) ;

		 // Devuelve la ventana que est en primer plano

		char * Primera() ;

		 // Devuelve la ventana que est en el fondo

		char * Ultima() ;

		 // Devuelve la ventana siguiente a una dada

		char * Siguiente( char * ) ;
		char * Siguiente( GVentana * ) ;

		 // Devuelve la ventana anterior a una dada

		char * Anterior( char * ) ;
		char * Anterior( GVentana * ) ;

		 // Indica si una ventana est actualmente en el GES

		int EsVisible( char * ) ;
		int EsVisible( GVentana * ) ;

		 // Compone la imagen en memoria de lo que se debera
		 // ver en la pantalla y actualiza la zona que sea necesaria

		void Refresca() ;

		void Refresca2() ;

		 // Los siguientes mtodos son virtuales puros, y
		 // por lo tanto tendrn que ser definidos en las
		 // clases que deriven de esta, implementando la
		 // verdadera salida a bajo nivel.

		 // Refresca el aspecto de la pantalla volcando
		 // la informacin contenida en el GES

		virtual void Actualiza( Area & ) = 0 ;

		 // Posiciona el cursor en una determinada posicin

		virtual void PosCursor( int, int ) = 0 ;

		 // Cambia el aspecto del cursor

		virtual void AspCursor( GVenBuf::TipoCursor ) = 0 ;

	protected :

		  // Lista con las ventanas actualmente en el GES

		Lista<GVentana> Ventanas ;

		Lista<Area> Zonas ; // Zonas de la pantalla que necesitan ser refrescadas

		ModoPantalla Modo ; // Modo de visualizacin

		char * Pantalla ; // Imagen de la pantalla

 } ;  // GES

	//
	// Mtodos inline de la clase GES
	//

	//
	// Todos estos mtodos funcionan de igual forma, reciben
	// el nombre de una ventana, hayan su direccin, utilizando
	// el operador (), y llaman al mtodo que realmente lleva
	// a cabo la accin
	//

inline void GES::Elimina( char * Ventana )

	{ Elimina( (*this)( Ventana ) ) ; }

inline void GES::Muestra( char * Ventana )

	{ Muestra( (*this)( Ventana ) ) ; }

inline void GES::Oculta( char * Ventana )

	{ Oculta( (*this)( Ventana ) ) ; }

inline void GES::Encima( char * Ventana )

	{ Encima( (*this)( Ventana ) ) ; }

inline void GES::Debajo( char * Ventana )

	{ Debajo( (*this)( Ventana ) ) ; }

inline void GES::Mueve( char * Ventana, int X, int Y )

	{ Mueve( (*this)( Ventana ), X, Y ) ; }

inline char * GES::Siguiente( char * Ventana )

	{ return Siguiente( (*this)( Ventana ) ) ; }

inline char * GES::Anterior( char * Ventana )

	{ return Anterior( (*this)( Ventana ) ) ; }

inline int GES::EsVisible( char * Ventana )

	{ return EsVisible( (*this)( Ventana ) ) ; }

	//
	// Clase : GESTexto
	//
	// Deriva de : GES
	//
	// Base de : -
	//
	// Finalidad : Implementar los mtodos de
	//	       bajo nivel para salida a
	//	       pantalla de texto
	//
	// Fecha de creacin : 13 Agosto 1992
	//
	// Fecha de revisin : -
	//

class GESTexto : public GES
 {
	public :

		GESTexto( ModoPantalla ) ; // Constructor

		 // Mtodos virtuales heredados, que permiten
		 // la accin a bajo nivel sobre la pantalla de texto

		 // Refresca el aspecto de la pantalla volcando
		 // la informacin contenida en el GES

		void Actualiza( Area & ) ;

		 // Sita el cursor en una determinada posicin

		void PosCursor( int, int ) ;

		 // Cambia el aspecto del cursor

		void AspCursor( GVenBuf::TipoCursor ) ;

 } ; // GESTexto

	//
	// Mtodos inline de la clase GESTexto
	//

	//
	// Mtodo : Constructor
	//
	// Construye un objeto simplemente llamando al constructor base
	//

inline GESTexto::GESTexto( GES::ModoPantalla X ) : GES( X )

	{}

#endif // _GVENTANA_HPP_
