/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              GFILE.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Wen Jul 03 17:48:50 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *
 *      INCLUDES:
 *
 ******************************************************************************/
#include <process.h> // Para utilizar spawnv

#include "gfile.hpp"


	//
	// Constructor
	//

GFile::GFile( int l, int t, int w, int h, GESGrafico *p, char *f ) : Pantalla( p ),
							DirectorioActual( 0 ), ArchivoActual( 0 ),
							LineaDirectorio( 1 ), LineaArchivo( 1 ) // Inicializa los miembros
 {
	left = l;
	top = t;
	width = w;
	height = h;

	file = f;

	istrcpy( Referencia, "*.BSP" ) ;

	LeeInformacion() ; // Lee la informacin del disco

	CreaVentanaInformativa() ; // Y crea las ventanas principales

	CreaVentanaDirectorios() ;

	CreaVentanaArchivos() ;

	activa = GFile::_Directorios;

	selec = 0;
 }

	//
	// Destructor
	//

GFile::~GFile()
 {
	EliminaVentanas() ; // Borra las ventanas

	Pantalla -> Refresca() ; // y activaiza el aspecto de la pantalla
 }

	//
	// Mtodo Ejecuta. Poner en marcha la demostracin
	//

void GFile::Ejecuta()
 {
	GEvento Control ;  // Para leer eventos
	Evento Suceso ;

		// Destacar la ventana activa con un borde doble

	(*Pantalla)( "Directorios" ) -> rdbuf() -> BordeVentana( GVenBuf::Doble ) ;

	int Salida = 0 ; // Indicador de salida

	while( ! Salida ) // Mientras no se active el indicador de salida
	 {
			// Si hay directorios en la lista

		if( DirectorioActual < Directorios . Elementos() )
		{

				// Destaca el directorio activa del resto, mostrndolo
				// en vdeo inverso

			* (*Pantalla)( "Directorios" )
				<< TintaA( GVenBuf::Blanco ) << FondoA( GVenBuf::Negro );

			MuestraDirectorio( DirectorioActual, LineaDirectorio ) ;
		}
			// Si hay archivos en la lista

		if( ArchivoActual < Archivos . Elementos() )
		 {
				// Destcalo del resto

			* (*Pantalla)( "Archivos" )
				<< TintaA( GVenBuf::Blanco ) << FondoA( GVenBuf::Negro ) ;

			MuestraArchivo( ArchivoActual, LineaArchivo ) ;
		 }

		Pantalla -> Refresca() ; // Actualizar el aspecto de la pantalla

			// Captura un evento

		do { Control >> Suceso ; } while( Suceso . Quien == Evento::Vacio ) ;

			// Si hay directorios en la lista se destac el activa

		if( DirectorioActual < Directorios . Elementos() )
		{

				// devolver el aspecto normal

			* (*Pantalla)( "Directorios" )
				<< TintaA( GVenBuf::Negro ) << FondoA( GVenBuf::GrisClaro );

			MuestraDirectorio( DirectorioActual, LineaDirectorio ) ;
		}
			// Si hay archivos en la lista

		if( ArchivoActual < Archivos . Elementos() )
		 {
				// Devolver su aspecto normal al activa

			* (*Pantalla)( "Archivos" )
				<< TintaA( GVenBuf::Negro ) << FondoA( GVenBuf::GrisClaro ) ;

			MuestraArchivo( ArchivoActual, LineaArchivo ) ;
		 }

			// Procesar el evento capturado

		Salida = ProcesaMensaje( Suceso ) ;
	 }
 }

	//
	// Mtodo LeeInformacion. Se sirve de un objeto GDisco para
	// obtener la unidad y directorio activa y crear la lista
	// de archivos y directorios.
	//

void GFile::LeeInformacion()
 {
	GDisco Disco ;

		// Se obtiene una referencia al directorio activa

	GDirectorio & Actual = Disco . Actual() . Directorio() ;

		// Contadores de directorios y archivos en las matrices

	unsigned NumDir = 0, NumArc = 0 ;

	Directorios = Matriz<GArchivo>(0) ; // Las matrices en principio
	Archivos = Matriz<GArchivo>(0) ; // estarn vacas

		// Inspeccionar todos los archivos del directorio activa
		// para tomar los directorios existentes

	for( unsigned I = 0 ; I < Actual . NumeroArchivos() ; I++ )

			// Si es un directorio

		if( Actual[ I ] . Atributo( GArchivo::Directorio ) )

				// aadir a la lista de directorios

			Directorios[ NumDir++ ] = Actual[ I ] ;

			// Buscar los archivos que cumplan la referencia establecida

		Actual . Selecciona( Referencia ) ;

		for( I = 0 ; I < Actual . NumeroArchivos() ; I++ )

				// Si no es un directorio aadir a la lista de archivos

			if( ! Actual[ I ] . Atributo( GArchivo::Directorio ) )
			 {
				Archivos[ NumArc++ ] = Actual[ I ] ;
			 }
 }

	//
	// Mtodo CreaVentanaInformativa. Crea en la parte superior
	// de la pantalla una ventana donde se muestra informacin
	// acerca de la capacidad del soporte, el espacio libre, el
	// directorio y unidad activaes.
	//

void GFile::CreaVentanaInformativa()
 {
	GVentana Temporal( "Informativa", width, 1, GVenBuf::Simple,
						  GVenBuf::Negro, GVenBuf::GrisClaro ) ;

		// El cursor no debe ser visible

	Temporal << AspCursor( GVenBuf::SinCursor ) ;

	Pantalla -> Anade( Temporal, left, top ) ; // Fijar en la parte superior

	ActualizaVentanaInformativa() ; // Actualizar su contenido

	Pantalla -> Muestra( "Informativa" ) ; // Mostrarla
 }

	//
	// Mtodo CreaVentanaDirectorios. Crea en la parte izquierda
	// de la pantalla una ventana donde se mostrar una lista
	// de los directorios existentes en el directorio activa.
	//

void GFile::CreaVentanaDirectorios()
 {
	GVentana Temporal( "Directorios", width/2-1, height-8, GVenBuf::Simple,
						GVenBuf::Negro, GVenBuf::GrisClaro ) ;

		// Ocultar el cursor

	Temporal << AspCursor( GVenBuf::SinCursor ) ;

		// Aadirla

	Pantalla -> Anade( Temporal, left, top+3 ) ;

	ActualizaVentanaDirectorios() ; // Actualizar su contenido

	Pantalla -> Muestra( "Directorios" ) ; // Mostrarla
 }

	//
	// Mtodo CreaVentanaArchivos. Crea una ventana que ocupa el
	// resto de la pantalla, en la que aparecer una lista con
	// los nombres de los archivos, su tamao, fecha y hora de
	// ltima modificacin y estado de los atributos.
	//

void GFile::CreaVentanaArchivos()
 {
	GVentana Temporal( "Archivos", width/2-1, height-8, GVenBuf::Simple,
					   GVenBuf::Negro, GVenBuf::GrisClaro ) ;

	Temporal << AspCursor( GVenBuf::SinCursor ) ;

	Pantalla -> Anade( Temporal, left+(width/2+1), top+3 ) ;

	ActualizaVentanaArchivos() ;

	Pantalla -> Muestra( "Archivos" ) ;
 }

	//
	// Mtodo ActualizaVentanaInformativa. Muestra en la
	// ventana informativa la informacin correspondiente
	//

void GFile::ActualizaVentanaInformativa()
 {
	GDisco Disco ;

		// Se obtiene un puntero a la ventana en la que hay que trabajar

	GVentana *ven = (*Pantalla)( "Informativa" ) ;

	char Unidad[ MAXDRIVE ], Camino[ MAXPATH ], Archivo[ MAXFILE ], Extension[ MAXEXT ] ;

		// Obtener los distintos componentes del camino activa

	fnsplit( (char *) Disco . Actual() . Directorio(),
			 Unidad, Camino, Archivo, Extension ) ;

		// Formar el directorio

	strcat( Camino, Archivo ) ;

		// Mostrar toda la informacin

	*ven << PosCursor( 2, 1 ) << "File: " << Camino;
 }

	//
	// Mtodo ActualizaVentanaInformativa. Muestra en la
	// ventana informativa la informacin correspondiente
	//

void GFile::ActualizaVentanaInformativa( unsigned int I )
 {
	GDisco Disco ;

	char Unidad[ MAXDRIVE ], Camino[ MAXPATH ], Archivo[ MAXFILE ];

	char Directorio[ MAXPATH ], Nombre[ MAXFILE ], Extension[ MAXEXT ] ;

		// Se obtiene un puntero a la ventana en la que hay que trabajar

	GVentana *ven = (*Pantalla)( "Informativa" ) ;

	fnsplit( (char *)Disco.Actual().Directorio(), Unidad, Camino, Archivo, Extension ) ;

	fnsplit( (char *)Archivos[ I ], Unidad, Directorio, Nombre, Extension ) ;

		// Formar el directorio

	strcat( Camino, Archivo ) ;

	if( !strcmp( Nombre, "" ) || Nombre == NULL )
	{
		selec = 0;
	}
	else
	{
		selec = 1;
		strcat( Camino, "\\" ) ;
		strcat( Camino, Nombre ) ;
		strcat( Camino, Extension ) ;
		strcpy( file, Camino );
	}
	while( ( istrlen( "File: ") + istrlen( Camino ) ) < (width-3) ) // Completar con espacios

		istrcat( Camino, " " ) ;

		// Mostrar toda la informacin

	*ven << PosCursor( 2, 1 ) << "File: " << Camino;
 }

	//
	// Mtodo ActualizaVentanaDirectorios. Muestra el contenido
	// activa de la lista de directorios.
	//

void GFile::ActualizaVentanaDirectorios()
 {

	GVentana *ven = (*Pantalla)( "Directorios" ) ;

	int Lin = 1 ; // Comenzaremos a contar desde la lnea 1

		// Recorrer la lista

	for( int I = 0 ; I < Directorios . Elementos() ; I++ )
	 {
			// Mostrar el nombre del directorio en la lnea adecuada

		MuestraDirectorio( I, Lin++ ) ; // Mostrar la informacin del archivo

		if( Lin > ven->rdbuf()->Lins() ) // Si llegamos al lmite de la ventana

			break ; // interrumpir el proceso
	 }
 }

	//
	// Mtodo ActualizaVentanaArchivos. Muestra el contenido
	// de la lista de archivos.
	//

void GFile::ActualizaVentanaArchivos()
 {
	GVentana *ven = (*Pantalla)( "Archivos" ) ;

	int Lin = 1 ; // Comenzaremos por la lnea 1

		// Recorrer la lista de archivos

	for( int I = 0 ; I < Archivos . Elementos() ; I++ )
	 {
		MuestraArchivo( I, Lin++ ) ; // Mostrar la informacin del archivo

		if( Lin > ven->rdbuf()->Lins() ) // Si llegamos al lmite de la ventana

			break ; // interrumpir el proceso
	 }

 }

	//
	// Mtodo MuestraDirectorio. Imprime el directorio I de la lista en
	// la lnea Lin.
	//

void GFile::MuestraDirectorio( unsigned I, int Lin )
 {
	char Buffer[ 60 ];

		// Se obtiene un puntero a la ventana sobre la que se va a trabajar

	GVentana *ven = (*Pantalla)( "Directorios" ) ;

		// Para componer la lnea de informacin

	istrcpy( Buffer, (char*)Directorios[I] ) ; // Aadir el nombre

	while( istrlen( Buffer ) < (width/2)-3 ) // Completar con espacios

		istrcat( Buffer, " " ) ;

	*ven << PosCursor( 2, Lin ) << Buffer ;
 }

	//
	// Mtodo MuestraArchivo. Imprime el archivo I de la lista en
	// la lnea Lin.
	//

void GFile::MuestraArchivo( unsigned I, int Lin )
 {
		// Se obtiene un puntero a la ventana sobre la que se va a trabajar

	GVentana *ven = (*Pantalla)( "Archivos" ) ;

		// Para componer la lnea de informacin

	char Buffer[ 60 ];

	char Unidad[ MAXDRIVE ], Directorio[ MAXPATH ],
		 Nombre[ MAXFILE ], Extension[ MAXEXT ] ;

		// Obtener los componentes del nombre del archivo

	fnsplit( (char *) Archivos[ I ], Unidad, Directorio, Nombre, Extension ) ;

	istrcpy( Buffer, Nombre ) ; // Aadir el nombre

	while( istrlen( Buffer ) < 9 ) // Completar con espacios

		istrcat( Buffer, " " ) ;

	istrcat( Buffer, Extension ) ; // y aadir la extensin

	while( istrlen( Buffer ) < 14 ) // Separar con espacios del siguiente campo

		istrcat( Buffer, " " ) ;

		// Anteceder con los espacios necesarios

	while( istrlen( Buffer ) < (width/2-3) )

		istrcat( Buffer, " " ) ;

		// Imprimir la lnea de informacin

	*ven << PosCursor( 2, Lin ) << Buffer ;
 }

	//
	// Mtodo EliminaVentanas. Elimina las ventanas de la pantalla
	//

void GFile::EliminaVentanas()
 {
	Pantalla -> Elimina( "Informativa" ) ;
	Pantalla -> Elimina( "Directorios" ) ;
	Pantalla -> Elimina( "Archivos" ) ;
 }

	//
	// Mtodo ProcesaMensaje. Procesa los eventos que se
	// produzcan, traducindolos en acciones
	//

int GFile::ProcesaMensaje( Evento & Suceso )
 {

		// Si el evento fue producido por el teclado

	if( Suceso . Quien == Evento::Teclado )

		switch( Suceso . Tecla ) // veamos que tecla se puls
		 {
			case GTeclado::ARRIBA : // Cursor arriba

				if( activa == GFile::_Directorios ) // Si estamos en la ventana de directorios
				 {
					if( DirectorioActual > 0 ) // No estamos en el primero
					 {
						DirectorioActual-- ; // Ir al anterior

						if( LineaDirectorio > 1 ) // No es la primera lnea

							LineaDirectorio-- ; // ir a la anterior

						else // Estamos al principio de la ventana

									// Desplazar el contenido activa

							(*Pantalla)( "Directorios" ) -> rdbuf() -> DespAbajo() ;
					 }
				 }
				// Estamos en la ventana de archivos
				else if( activa == GFile::_Archivos )
				{
					if( ArchivoActual > 0 ) // No estamos en el primer archivo
					 {
						ArchivoActual-- ; // Ir al anterior

						if( LineaArchivo > 1 ) // No estamos en la primera lnea

							LineaArchivo-- ; // ir a la anterior

						else // Estamos en la primera lnea de la ventana

								// Desplazar el contenido

							(*Pantalla)( "Archivos" ) -> rdbuf() -> DespAbajo() ;

						ActualizaVentanaInformativa( ArchivoActual );
					 }
				}

				break ;

			case GTeclado::ABAJO : // Cursor abajo


				if( activa == GFile::_Directorios ) // Si estamos en la ventana de directorios
				 {
						// Si no estamos en el ltimo directorio

					if( DirectorioActual < Directorios . Elementos() - 1 )
					 {
						DirectorioActual++ ; // Ir al siguiente

						if( LineaDirectorio < (*Pantalla)( "Directorios" )->rdbuf()->Lins() ) // No es la ltima lnea

							LineaDirectorio++ ; // ir a la siguiente

						else // Estamos en el fondo de la ventana

								// Desplazar el contenido

							(*Pantalla)( "Directorios" ) -> rdbuf() -> DespArriba() ;
					 }
				 }
				// Estamos en la ventana de archivos
				else if( activa == GFile::_Archivos )
				{
						// Si no estamos en el ltimo de la lista

					if( ArchivoActual < Archivos . Elementos() - 1 )
					 {
						ArchivoActual++ ; // Ir al siguiente

						if( LineaArchivo < (*Pantalla)( "Archivos" )->rdbuf()->Lins() ) // No estamos en la ltima lnea

							LineaArchivo++ ; // ir a la siguiente

						else // Estamos al final de la ventana

								// Desplazar el contenido

							(*Pantalla)( "Archivos" ) -> rdbuf() -> DespArriba() ;

						ActualizaVentanaInformativa( ArchivoActual );
					 }
				}

				break ;

			case GTeclado::TAB : // Tabulador

				switch( activa )
				{
					case GFile::_Directorios:

						// Quita el borde doble de la ventana de directorios
						// y ponlo en la ventana de archivos

						(*Pantalla)( "Directorios" ) -> rdbuf() -> BordeVentana( GVenBuf::Simple ) ;
						(*Pantalla)( "Archivos" ) -> rdbuf() -> BordeVentana( GVenBuf::Doble ) ;
						
						activa = GFile::_Archivos;
					break;

					case GFile::_Archivos:
			
						// El proceso es el contrario

						(*Pantalla)( "Directorios" ) -> rdbuf() -> BordeVentana( GVenBuf::Doble ) ;
						(*Pantalla)( "Archivos" ) -> rdbuf() -> BordeVentana( GVenBuf::Simple ) ;

						activa = GFile::_Directorios;
					break;

					default:
					break;
				 }

				break ;

			case GTeclado::INTRO :

					// Si tenemos un directorio seleccionado

				if( ( activa == GFile::_Directorios ) && DirectorioActual < Directorios . Elementos() )
				 {
						// Cambiar a ese directorio

					chdir( (char *) Directorios[ DirectorioActual ] ) ;

					LeeInformacion() ; // Leer la informacin correspondiente

						// Nos ponemos al principio de las listas
						// y de las ventanas

					DirectorioActual = ArchivoActual = 0 ;
					LineaDirectorio = LineaArchivo = 1 ;

						// Limpiamos las ventanas

					(*Pantalla)( "Informativa" ) -> rdbuf() -> Limpia() ;
					(*Pantalla)( "Directorios" ) -> rdbuf() -> Limpia() ;
					(*Pantalla)( "Archivos" ) -> rdbuf() -> Limpia() ;

						// Y activaizamos la informacin que hay en ellas

					ActualizaVentanaInformativa() ;
					ActualizaVentanaDirectorios() ;
					ActualizaVentanaArchivos() ;
				 }
						// Si tenemos seleccionado un archivo

				else if( ( activa == GFile::_Archivos ) && ( ArchivoActual < Archivos . Elementos() ) )
				{
					ActualizaVentanaInformativa( ArchivoActual );
					return 1;
				}

			case ' ' : // Barra espaciadora

					// Si estamos en la ventana de archivos y hay un archivo seleccionado

				if( ( activa == GFile::_Archivos ) && ArchivoActual < Archivos . Elementos() )
				 {
					ActualizaVentanaInformativa( ArchivoActual );

					GEvento Control ;

							// Simula la pulsacin de cursor abajo

					Control . Inserta( GTeclado::ABAJO ) ;
				 }

				break ;
		}

	else // El evento ha sido producido por el ratn
	{

		if( Suceso . Boton == Evento::ClickI ) // Si se puls el botn izquierdo
		 {
				// Veamos en qu ventana estaba el cursor

			GVentana * Cual = (*Pantalla)(

				Pantalla -> Ventana( Suceso . Posicion . X / 8 + 1,
						  	Suceso . Posicion . Y / 8 + 1 )
										  ) ;

				// Convertir la lnea a ordenada de ventana

			int Linea = Suceso . Posicion . Y / 8 + 1 - Cual->rdbuf()->Lin() ;

				// Si la lnea queda en los bordes de la ventana

			if( Linea < 1 || Linea > Cual->rdbuf()->Lins() )

				return 0 ; // no procesar el evento

			if( Cual == (*Pantalla)( "Directorios" ) ) // Si estaba en la ventana de directorios
			 {
				// Desplazarse hasta el directorio marcado si es que hay

					if( DirectorioActual + ( Linea - LineaDirectorio  )
							< Directorios . Elementos() )
					 {

								DirectorioActual += ( Linea - LineaDirectorio ) ;
								LineaDirectorio = Linea ;

									// Simular la pulsacin de INTRO

								GEvento Control ;

								if( activa != _Directorios ) // Si no est activa esta ventana

									Control . Inserta( GTeclado::TAB ) ; // activarla

								Control . Inserta( GTeclado::INTRO ) ;
					 }
			 }
			// Estaba en la ventana de archivos
			else if( Cual == (*Pantalla)( "Archivos" ) )
			{
				// Desplazarse hasta el archivo marcado, actuando como
				// en el caso anterior

				if( ArchivoActual + ( Linea - LineaArchivo )
						< Archivos . Elementos() )
				 {
						ArchivoActual += ( Linea - LineaArchivo ) ;
						LineaArchivo = Linea ;

						GEvento Control ;

						if( activa != GFile::_Archivos ) // Si no est activa esta ventana

							Control . Inserta( GTeclado::TAB ) ; // activarla

						Control . Inserta( GTeclado::INTRO ) ;
				 }
			}
		}
	}
	return 0 ;
 }


/*******************************************************************************
 *
 *      FIN DE FICHERO:
 *
 ******************************************************************************/
