	//
	// gfile.hpp
	//

#include "GVentana.Hpp"
#include "GDiscos.Hpp"
#include "GEvento.Hpp"
#include "GEntrada.Hpp"
#include "GVentaGr.Hpp"

	//
	// Clase : GFile
	//
	// Deriva de : RaizMenu, para controlar mensajes del men
	//
	// Base de : -
	//
	// Finalidad : Demostrar el uso de las clases
	//			   GArchivo, GDirectorio, GUnidad
	//			   y GDisco
	//
	// Fecha de creacin : 11 Septiembre 1992
	//
	// Fecha de revisin : -
	//

class GFile 
 {
	public :

		GFile( int left, int top, int width, int height, GESGrafico *p, char *f ) ; // Crea la demostracin

		~GFile() ; // La destruye

		void Ejecuta() ; // La pone en marcha

	private :

		int left, top, width, height;

		char *file;

		int selec;

		GESGrafico *Pantalla ; // Destino donde se visualizar la demostracin

			// Matrices para contener los directorios y los
			// archivos existentes en el directorio actual

		Matriz<GArchivo> Directorios ;
		Matriz<GArchivo> Archivos ;

			// Directorio seleccionado actualmente en la matriz

		unsigned DirectorioActual ;

			// Archivo seleccionado actualmente en la matriz

		unsigned ArchivoActual ;

		int LineaDirectorio ; // Lnea en la ventana de directorios

		int LineaArchivo ; // Lnea en la ventana de archivos

		enum  TipoVentana { _Directorios, _Archivos }; // Indicador para saber qu ventana es la activa

		TipoVentana activa;

		char Referencia[13] ; // Archivos a seleccionar

			// Toma la informacin actual y la almacena en
			// las matrices anteriores

		void LeeInformacion() ;

			// Crea en la parte superior de la pantalla una ventana
			// con informacin general

		void CreaVentanaInformativa() ;

			// Crea en la parte izquierda de la pantalla una ventana
			// con la lista de directorios

		void CreaVentanaDirectorios() ;

			// Crea en la parte derecha de la pantalla una ventana
			// con la lista de archivos

		void CreaVentanaArchivos() ;

			// Actualiza el contenido de la ventana informativa

		void ActualizaVentanaInformativa() ;

		void ActualizaVentanaInformativa( unsigned I ) ;

			// Actualiza el contenido de la ventana de directorios

		void ActualizaVentanaDirectorios() ;

			// Actualiza el contenido de la ventana de archivos

		void ActualizaVentanaArchivos() ;

			// Oculta las ventanas de la pantalla

		void EliminaVentanas() ;

			// Procesa los eventos producidos por teclado y ratn

		int ProcesaMensaje( Evento & ) ;

			// Muestra el archivo indicado en una cierta lnea de la ventana

		void MuestraArchivo( unsigned, int ) ;

		void MuestraDirectorio( unsigned, int ) ;

 } ;

