/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              GLISTA.HPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Sun Jun 21 22:50:45 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
#ifndef _GLISTA_HPP_
#define _GLISTA_HPP_


#ifndef __cplusplus
#error No se puede utilizar GLista en C
#endif



/*******************************************************************************
 *
 *      INCLUDES:
 *
 ******************************************************************************/
#include <graphics.h>
#include <string.h>
#include <iostream.h>

#include "doserror.h"
#include "xmsarray.h"

#include "GVentana.Hpp"
#include "GEntrada.Hpp"
#include "GEvento.Hpp"

	// Si el modelo de memoria seleccionado permite varios segmentos de datos
	// habr que utilizar las versiones far de algunas funciones

#if defined(__LARGE__) || defined(__HUGE__) || defined(__COMPACT__)

	#define istrcpy( orig, dest )   _fstrcpy( (orig), (dest) )
	#define istrcmp( orig, dest )   _fstrcmp( (orig), (dest) )
	#define istrcat( orig, dest )   _fstrcat( (orig), (dest) )

#else

	#define istrcpy( orig, dest )   strcpy( (orig), (dest) )
	#define istrcmp( orig, dest )   strcmp( (orig), (dest) )
	#define istrcat( orig, dest )   strcat( (orig), (dest) )

#endif


/*******************************************************************************
 *
 *      DEFINES:
 *
 ******************************************************************************/
#define MAX_DATOS_LEN           33
#define MAX_DATOS_NUM           513


/*******************************************************************************
 *
 *      STRUCT:
 *              DatoName:
 *
 ******************************************************************************/
struct DatoName
{
	char	name[MAX_DATOS_LEN];
};


/*******************************************************************************
 *
 *      CLASS:
 *              SelectedHandler:
 *
 ******************************************************************************/
class SelectedHandler
{
    public:

	virtual int 		Selected( unsigned ) = 0;

};


/*******************************************************************************
 *
 *      CLASS:
 *              GLista:
 *
 ******************************************************************************/
class GLista
{
    public:

				GLista();

				GLista( unsigned int numColus,
					unsigned int numLines,
					char* name,
					GES* pantalla,
					SelectedHandler *selectedHandler = NULL );

				GLista( const GLista& L );

				~GLista();

	void                    operator = ( const GLista& R );

	int                     operator == ( const GLista& R );

				// Actualiza el contenido de la lista.
	int                    	Actualiza(     	XMSarray<char> *pClassNames,
						long numLista );

				// Actualiza el contenido de la lista.
	int                    	Actualiza(     	char *pLista[MAX_DATOS_LEN],
						long numLista );

				// Actualiza el contenido de la lista.
	int                    	Actualiza(     	XMSarray<long> *pLista,
						long numLista );

				// Procesa los eventos que se produzcan, traduciendolos en acciones.
	int                     ProcesaMensaje( Evento& suceso );

				// Poner en marcha la lista 
	int                    	Ejecuta( void );

				// Obtiene el dato seleccionado actual.
	char*			GetDato( char* buf );	


    private:


	char                    name[17];

	GES*                    p; // Pantalla destino de la representacin.

	unsigned int            numLines, numColus;

	unsigned int            currLine;
	
	unsigned int            numDatos;
	
	unsigned int            currDato;
	
	char                    *datos[MAX_DATOS_NUM];

	char                    *lista[MAX_DATOS_NUM];

	SelectedHandler		*selectedHandler;

};


#endif // _GLISTA_HPP_


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

