/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              GRAFI3D.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Mon May 06 10:43:15 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

/*******************************************************************************
 *
 *      INCLUDES:
 *
 ******************************************************************************/
#include <stdio.h>
#include <math.h>

#include "grafi3d.hpp"
#include "tracelog.hpp"


/*******************************************************************************
 *
 *      VARIABLES GLOBALES:
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *      FUNCTION:
 *              float* BBoxToA( float p[8][3], boundbox_t bbox )
 *
 ******************************************************************************/
float* BBoxToA( float p[8][3], boundbox_t bbox )
{
	p[0][0] = bbox.min.x;
	p[0][1] = bbox.min.y;
	p[0][2] = bbox.min.z;

	p[1][0] = bbox.max.x;
	p[1][1] = bbox.min.y;
	p[1][2] = bbox.min.z;

	p[2][0] = bbox.max.x;
	p[2][1] = bbox.max.y;
	p[2][2] = bbox.min.z;

	p[3][0] = bbox.min.x;
	p[3][1] = bbox.max.y;
	p[3][2] = bbox.min.z;

	p[4][0] = bbox.min.x;
	p[4][1] = bbox.max.y;
	p[4][2] = bbox.max.z;

	p[5][0] = bbox.min.x;
	p[5][1] = bbox.min.y;
	p[5][2] = bbox.max.z;

	p[6][0] = bbox.max.x;
	p[6][1] = bbox.min.y;
	p[6][2] = bbox.max.z;

	p[7][0] = bbox.max.x;
	p[7][1] = bbox.max.y;
	p[7][2] = bbox.max.z;

	return &p[0][0];
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              float* BBoxToA( float p[8][3], shortbox_t bbox )
 *
 ******************************************************************************/
float* BBoxToA( float p[8][3], shortbox_t bbox )
{
	p[0][0] = (float)bbox.min.x;
	p[0][1] = (float)bbox.min.y;
	p[0][2] = (float)bbox.min.z;

	p[1][0] = (float)bbox.max.x;
	p[1][1] = (float)bbox.min.y;
	p[1][2] = (float)bbox.min.z;

	p[2][0] = (float)bbox.max.x;
	p[2][1] = (float)bbox.max.y;
	p[2][2] = (float)bbox.min.z;

	p[3][0] = (float)bbox.min.x;
	p[3][1] = (float)bbox.max.y;
	p[3][2] = (float)bbox.min.z;

	p[4][0] = (float)bbox.min.x;
	p[4][1] = (float)bbox.max.y;
	p[4][2] = (float)bbox.max.z;

	p[5][0] = (float)bbox.min.x;
	p[5][1] = (float)bbox.min.y;
	p[5][2] = (float)bbox.max.z;

	p[6][0] = (float)bbox.max.x;
	p[6][1] = (float)bbox.min.y;
	p[6][2] = (float)bbox.max.z;

	p[7][0] = (float)bbox.max.x;
	p[7][1] = (float)bbox.max.y;
	p[7][2] = (float)bbox.max.z;

	return &p[0][0];
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              GLine* BBoxToA( GLine g[24], float p[8][3] )
 *
 ******************************************************************************/
GLine* BBoxToA( GLine g[24], float p[8][3] )
{
	g[0].sv.x = p[0][0];
	g[0].sv.y = p[0][1];
	g[0].sv.z = p[0][2];
	g[0].ev.x = p[3][0];
	g[0].ev.y = p[3][1];
	g[0].ev.z = p[3][2];

	g[1].sv.x = p[3][0];
	g[1].sv.y = p[3][1];
	g[1].sv.z = p[3][2];
	g[1].ev.x = p[4][0];
	g[1].ev.y = p[4][1];
	g[1].ev.z = p[4][2];

	g[2].sv.x = p[4][0];
	g[2].sv.y = p[4][1];
	g[2].sv.z = p[4][2];
	g[2].ev.x = p[5][0];
	g[2].ev.y = p[5][1];
	g[2].ev.z = p[5][2];

	g[3].sv.x = p[5][0];
	g[3].sv.y = p[5][1];
	g[3].sv.z = p[5][2];
	g[3].ev.x = p[0][0];
	g[3].ev.y = p[0][1];
	g[3].ev.z = p[0][2];

	g[4].sv.x = p[1][0];
	g[4].sv.y = p[1][1];
	g[4].sv.z = p[1][2];
	g[4].ev.x = p[2][0];
	g[4].ev.y = p[2][1];
	g[4].ev.z = p[2][2];

	g[5].sv.x = p[2][0];
	g[5].sv.y = p[2][1];
	g[5].sv.z = p[2][2];
	g[5].ev.x = p[7][0];
	g[5].ev.y = p[7][1];
	g[5].ev.z = p[7][2];

	g[6].sv.x = p[7][0];
	g[6].sv.y = p[7][1];
	g[6].sv.z = p[7][2];
	g[6].ev.x = p[6][0];
	g[6].ev.y = p[6][1];
	g[6].ev.z = p[6][2];

	g[7].sv.x = p[6][0];
	g[7].sv.y = p[6][1];
	g[7].sv.z = p[6][2];
	g[7].ev.x = p[1][0];
	g[7].ev.y = p[1][1];
	g[7].ev.z = p[1][2];

	g[8].sv.x = p[0][0];
	g[8].sv.y = p[0][1];
	g[8].sv.z = p[0][2];
	g[8].ev.x = p[5][0];
	g[8].ev.y = p[5][1];
	g[8].ev.z = p[5][2];

	g[9].sv.x = p[5][0];
	g[9].sv.y = p[5][1];
	g[9].sv.z = p[5][2];
	g[9].ev.x = p[6][0];
	g[9].ev.y = p[6][1];
	g[9].ev.z = p[6][2];

	g[10].sv.x = p[6][0];
	g[10].sv.y = p[6][1];
	g[10].sv.z = p[6][2];
	g[10].ev.x = p[1][0];
	g[10].ev.y = p[1][1];
	g[10].ev.z = p[1][2];

	g[11].sv.x = p[1][0];
	g[11].sv.y = p[1][1];
	g[11].sv.z = p[1][2];
	g[11].ev.x = p[0][0];
	g[11].ev.y = p[0][1];
	g[11].ev.z = p[0][2];

	g[12].sv.x = p[3][0];
	g[12].sv.y = p[3][1];
	g[12].sv.z = p[3][2];
	g[12].ev.x = p[4][0];
	g[12].ev.y = p[4][1];
	g[12].ev.z = p[4][2];

	g[13].sv.x = p[4][0];
	g[13].sv.y = p[4][1];
	g[13].sv.z = p[4][2];
	g[13].ev.x = p[7][0];
	g[13].ev.y = p[7][1];
	g[13].ev.z = p[7][2];

	g[14].sv.x = p[7][0];
	g[14].sv.y = p[7][1];
	g[14].sv.z = p[7][2];
	g[14].ev.x = p[2][0];
	g[14].ev.y = p[2][1];
	g[14].ev.z = p[2][2];

	g[15].sv.x = p[2][0];
	g[15].sv.y = p[2][1];
	g[15].sv.z = p[2][2];
	g[15].ev.x = p[3][0];
	g[15].ev.y = p[3][1];
	g[15].ev.z = p[3][2];

	g[16].sv.x = p[0][0];
	g[16].sv.y = p[0][1];
	g[16].sv.z = p[0][2];
	g[16].ev.x = p[1][0];
	g[16].ev.y = p[1][1];
	g[16].ev.z = p[1][2];

	g[17].sv.x = p[1][0];
	g[17].sv.y = p[1][1];
	g[17].sv.z = p[1][2];
	g[17].ev.x = p[2][0];
	g[17].ev.y = p[2][1];
	g[17].ev.z = p[2][2];

	g[18].sv.x = p[2][0];
	g[18].sv.y = p[2][1];
	g[18].sv.z = p[2][2];
	g[18].ev.x = p[3][0];
	g[18].ev.y = p[3][1];
	g[18].ev.z = p[3][2];

	g[19].sv.x = p[3][0];
	g[19].sv.y = p[3][1];
	g[19].sv.z = p[3][2];
	g[19].ev.x = p[0][0];
	g[19].ev.y = p[0][1];
	g[19].ev.z = p[0][2];

	g[20].sv.x = p[5][0];
	g[20].sv.y = p[5][1];
	g[20].sv.z = p[5][2];
	g[20].ev.x = p[6][0];
	g[20].ev.y = p[6][1];
	g[20].ev.z = p[6][2];

	g[21].sv.x = p[6][0];
	g[21].sv.y = p[6][1];
	g[21].sv.z = p[6][2];
	g[21].ev.x = p[7][0];
	g[21].ev.y = p[7][1];
	g[21].ev.z = p[7][2];

	g[22].sv.x = p[7][0];
	g[22].sv.y = p[7][1];
	g[22].sv.z = p[7][2];
	g[22].ev.x = p[4][0];
	g[22].ev.y = p[4][1];
	g[22].ev.z = p[4][2];

	g[23].sv.x = p[4][0];
	g[23].sv.y = p[4][1];
	g[23].sv.z = p[4][2];
	g[23].ev.x = p[5][0];
	g[23].ev.y = p[5][1];
	g[23].ev.z = p[5][2];

	return &g[0];
}


/*******************************************************************************
 *
 *      CONSTRUCTOR:
 *              Grafi3D::Grafi3D()
 *
 ******************************************************************************/
Grafi3D::Grafi3D():Grafico()
{ 
	d = 6000.0;
	// r1 = 5.68319;
	r1 = 0.0;
	r2 = 6.28319;
	r3 = 3.14159;
	// r3 = 5.79778;
	sr1 = 0.0; sr2 = 0.0; sr3 = 0.0;                
	cr1 = 0.0; cr2 = 0.0; cr3 = 0.0;                
	mx = 0.0; my = 0.0; mz = -4000.0;
}


/*******************************************************************************
 *
 *      CONSTRUCTOR:
 *              Grafi3D::Grafi3D( GVentana* v )
 *
 ******************************************************************************/
Grafi3D::Grafi3D( GVentana* v ):Grafico( v )
{
	d = 6000.0;
	// r1 = 5.68319;
	r1 = 0.0;
	r2 = 6.28319;
	r3 = 3.14159;
	// r3 = 5.79778;
	sr1 = 0.0; sr2 = 0.0; sr3 = 0.0;                
	cr1 = 0.0; cr2 = 0.0; cr3 = 0.0;                
	mx = 0.0; my = 0.0; mz = -4000.0;
}


/*******************************************************************************
 *
 *      CONSTRUCTOR:
 *              Grafi3D::Grafi3D( const Grafi3D& O )
 *
 ******************************************************************************/
Grafi3D::Grafi3D( const Grafi3D& O ):Grafico( O )
{ 
	d = O.d;
	r1 = O.r1;
	r2 = O.r2;
	r3 = O.r3;
	sr1 = O.sr1; sr2 = O.sr2; sr3 = O.sr3;          
	cr1 = O.cr1; cr2 = O.cr2; cr3 = O.cr3;          
	mx = O.mx; my = O.my; mz = O.mz;
}


/*******************************************************************************
 *
 *      OPERATOR:
 *              void Grafi3D::operator = ( const Grafi3D& O )
 *
 ******************************************************************************/
void Grafi3D::operator = ( const Grafi3D& O )
{
	d = O.d;
	r1 = O.r1;
	r2 = O.r2;
	r3 = O.r3;
	sr1 = O.sr1; sr2 = O.sr2; sr3 = O.sr3;          
	cr1 = O.cr1; cr2 = O.cr2; cr3 = O.cr3;          
	mx = O.mx; my = O.my; mz = O.mz;
}


/*******************************************************************************
 *
 *      OPERATOR:
 *              void Grafi3D::operator == ( const Grafi3D& O )
 *
 ******************************************************************************/
int Grafi3D::operator == ( const Grafi3D& O )
{
	if( !( d == O.d ) ) {
		return 0;
	}
	if( r1 != O.r1 || r2 != O.r2 || r3 != O.r3 ) {
		return 0;
	}
	if( sr1 != O.sr1 || sr2 != O.sr2 || sr3 != O.sr3 ) {
		return 0;
	}
	if( cr1 != O.cr1 || cr2 != O.cr2 || cr3 != O.cr3 ) {
		return 0;
	}
	if( mx != O.mx || my != O.my || mz != O.mz ) {
		return 0;
	}
	return 1;
}

  
/*******************************************************************************
 *
 *      OPERATOR:
 *              Grafi3D& Grafi3D::operator * ( float r )
 *
 ******************************************************************************/
Grafi3D& Grafi3D::operator * ( float r )
{
	d = d*r;

	return *this;
}

  
/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Mover( Direccion direccion, int flag = 0 )
 *
 ******************************************************************************/
void Grafi3D::Mover( Direccion direccion, int flag )
{
	// Mueve el 10% del grafico en la direccion especificada.

	switch( flag )
	{
		case 1:
			switch( direccion )
			{
				case Left:
                                	mx -= ( Ventana()->rdbuf()->Cols()*8 ) * 0.5;
				break;
		
				case Up:
                                	my += ( Ventana()->rdbuf()->Lins()*8 ) * 0.5;
				break;

				case Down:
                                	my -= ( Ventana()->rdbuf()->Lins()*8 ) * 0.5;
				break;

				case Right:
				default:
					mx += ( Ventana()->rdbuf()->Cols()*8 ) * 0.5;
				break;
			}
		break;

		case 2:
			switch( direccion )
			{
				case Left:
					r2 -= 2*PI/36;
				break;
			
				case Up:
					r3 -= 2*PI/36;
				break;

				case Down:
					r3 += 2*PI/36;
				break;

				case Right:
				default:
					r2 += 2*PI/36;
				break;
			}
			if( r1 < 0 ) {
				r2 = 2*PI - r2;
			}
			else if( r1 > 2*PI ) {
				r2 = r2 - 2*PI;
			}
			if( r3 < 0 ) {
				r3 = 2*PI - r3;
			}
			else if( r3 > 2*PI ) {
				r3 = r3 - 2*PI;
			}
		break;

		case 0:
		default:
			switch( direccion )
			{
				case Left:
					r1 -= 2*PI/36;
				break;
			
				case Up:
					r3 -= 2*PI/36;
				break;

				case Down:
					r3 += 2*PI/36;
				break;

				case Right:
				default:
					r1 += 2*PI/36;
				break;
			}
			if( r1 < 0 ) {
				r1 = 2*PI - r1;
			}
			else if( r1 > 2*PI ) {
				r1 = r1 - 2*PI;
			}
			if( r3 < 0 ) {
				r3 = 2*PI - r3;
			}
			else if( r3 > 2*PI ) {
				r3 = r3 - 2*PI;
			}
		break;
	}
}


/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Actualiza(        GVenBuf::Color color,
 *                                              XMSarray<dleaf_t> *XL,
 *                                              long maxXLs,
 *                                              XMSarray<long> *XLI = NULL,
 *                                              long maxXLIs = 0,
 *                                              dleaf_t *pCenter = NULL )
 *
 ******************************************************************************/
void Grafi3D::Actualiza(        GVenBuf::Color color,
				XMSarray<dleaf_t>* XL,
				long maxXLs,
				XMSarray<long> *XLI,
				long maxXLIs,
				dleaf_t *pCenter )
{
	struct viewporttype             estadoPantalla;
	long                            i = 0;
	dleaf_t                         dleaf, c;
	short                           j = 0;
	float                           p[8][3];
	float                           p1[2];
	float                           p2[2];
	GLine                           gline[24];
	short                           x = 0, y = 0, z = 0;



	if( pCenter != NULL )
	{
		c = *pCenter;

		x = c.bound.min.x + ( ( c.bound.max.x - c.bound.min.x ) / 2 );
		y = c.bound.min.y + ( ( c.bound.max.y - c.bound.min.y ) / 2 );
		z = c.bound.min.z + ( ( c.bound.max.z - c.bound.min.z ) / 2 );
	}
	// Se preserva el rea establecida actualmente
	getviewsettings( &estadoPantalla );

	// Se delimita el rea de pantalla donde se llevar a cabo la representacin
	setviewport(    ( Ventana() -> rdbuf() -> Col() ) * 8,
			( Ventana() -> rdbuf() -> Lin() ) * 8,
			( Ventana() -> rdbuf() -> Col() + Ventana() -> rdbuf() -> Cols() ) * 8,
			( Ventana() -> rdbuf() -> Lin() + Ventana() -> rdbuf() -> Lins() ) * 8,
			1) ;

	// Calculamos los angulos de vision.
	Rotacion();

	if( XLI == NULL )
	{
		// Para todos los elementos de la matriz...
		for( i = 0; i < maxXLs; i++ )
		{
			dleaf = (*XL)[i];

			if( pCenter != NULL )
			{
				dleaf.bound.min.x -= x;
				dleaf.bound.max.x -= x;
				dleaf.bound.min.y -= y;
				dleaf.bound.max.y -= y;
				dleaf.bound.min.z -= z;
				dleaf.bound.max.z -= z;
			}
			BBoxToA( p, dleaf.bound );
			BBoxToA( gline, p );

			// Para todos los elementos del array...
			for( j = 0; j < 24; j++ )
			{
				Calcula3D( &p1[0], &p1[1], gline[j].sv.x, gline[j].sv.y, gline[j].sv.z );

				Calcula3D( &p2[0], &p2[1], gline[j].ev.x, gline[j].ev.y, gline[j].ev.z );

				DibujaLinea( color, p1, p2 );
			}
		}
	}
	else
	{
		// Para todos los elementos de la matriz seleccionados...
		for( i = 0; i < maxXLIs; i++ )
		{
			dleaf = (*XL)[(*XLI)[i]];

			if( pCenter != NULL )
			{
				dleaf.bound.min.x -= x;
				dleaf.bound.max.x -= x;
				dleaf.bound.min.y -= y;
				dleaf.bound.max.y -= y;
				dleaf.bound.min.z -= z;
				dleaf.bound.max.z -= z;
			}
			BBoxToA( p, dleaf.bound );
			BBoxToA( gline, p );

			// Para todos los elementos del array...
			for( j = 0; j < 24; j++ )
			{
				Calcula3D( &p1[0], &p1[1], gline[j].sv.x, gline[j].sv.y, gline[j].sv.z );

				Calcula3D( &p2[0], &p2[1], gline[j].ev.x, gline[j].ev.y, gline[j].ev.z );

				DibujaLinea( color, p1, p2 );
			}
		}
	}
	setviewport( estadoPantalla.left, estadoPantalla.top, estadoPantalla.right, estadoPantalla.bottom, estadoPantalla.clip );

} // Actualiza


/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Actualiza(        GVenBuf::Color color,
 *                                              XMSarray<dhull_t>* XH,
 *                                              long numXHS )
 *
 ******************************************************************************/
void Grafi3D::Actualiza(        GVenBuf::Color color,
				XMSarray<dhull_t>* XH,
				long numXHs )
{
	struct viewporttype             estadoPantalla;
	long                            i = 0;
	dhull_t                         dhull;
	short                           j = 0;
	float                           p[8][3];
	float                           p1[2];
	float                           p2[2];
	GLine                           gline[24];
	float                           px = 0.0, py = 0.0, pz = 0.0;



	// Se preserva el rea establecida actualmente
	getviewsettings( &estadoPantalla );

	// Se delimita el rea de pantalla donde se llevar a cabo la representacin
	setviewport(    ( Ventana() -> rdbuf() -> Col() ) * 8,
			( Ventana() -> rdbuf() -> Lin() ) * 8,
			( Ventana() -> rdbuf() -> Col() + Ventana() -> rdbuf() -> Cols() ) * 8,
			( Ventana() -> rdbuf() -> Lin() + Ventana() -> rdbuf() -> Lins() ) * 8,
			1) ;

	// Calculamos los angulos de vision.
	Rotacion();

	// Para todos los elementos de la matriz...
	for( i = 0; i < numXHs; i++ )
	{
		dhull = (*XH)[i];

		BBoxToA( p, dhull.bound );
		BBoxToA( gline, p );

		// Para todos los elementos del array...
		for( j = 0; j < 24; j++ )
		{
			Calcula3D( &p1[0], &p1[1], gline[j].sv.x, gline[j].sv.y, gline[j].sv.z );

			Calcula3D( &p2[0], &p2[1], gline[j].ev.x, gline[j].ev.y, gline[j].ev.z );

			DibujaLinea( color, p1, p2 );
		}
	}
	setviewport( estadoPantalla.left, estadoPantalla.top, estadoPantalla.right, estadoPantalla.bottom, estadoPantalla.clip );

} // Actualiza


/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Actualiza(        GVenBuf::Color color,
 *                                              XMSarray<node_t>* FM )
 *
 ******************************************************************************/
void Grafi3D::Actualiza(        GVenBuf::Color color,
				XMSarray<node_t>* FM )
{
	struct viewporttype             estadoPantalla;
	long                            n = 0;
	long                            i = 0;
	node_t                          node;
	short                           j = 0;
	float                           p[8][3];
	float                           p1[2];
	float                           p2[2];
	GLine                           gline[24];



	// Se preserva el rea establecida actualmente
	getviewsettings( &estadoPantalla );

	// Se delimita el rea de pantalla donde se llevar a cabo la representacin
	setviewport(    ( Ventana() -> rdbuf() -> Col() ) * 8,
			( Ventana() -> rdbuf() -> Lin() ) * 8,
			( Ventana() -> rdbuf() -> Col() + Ventana() -> rdbuf() -> Cols() ) * 8,
			( Ventana() -> rdbuf() -> Lin() + Ventana() -> rdbuf() -> Lins() ) * 8,
			1) ;

	// Obtenemos los elementos de la matriz...
	n = FM->size();

	// Calculamos los angulos de vision.
	Rotacion();

	// Para todos los elementos de la matriz...
	for( i = 0; i < n; i++ )
	{
		node = (*FM)[i];

		BBoxToA( p, node.box );
		BBoxToA( gline, p );

		// Para todos los elementos del array...
		for( j = 0; j < 24; j++ )
		{
			Calcula3D( &p1[0], &p1[1], gline[j].sv.x, gline[j].sv.y, gline[j].sv.z );

			Calcula3D( &p2[0], &p2[1], gline[j].ev.x, gline[j].ev.y, gline[j].ev.z );

			DibujaLinea( color, p1, p2 );
		}
	}
	setviewport( estadoPantalla.left, estadoPantalla.top, estadoPantalla.right, estadoPantalla.bottom, estadoPantalla.clip );

} // Actualiza


/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Actualiza(        GVenBuf::Color color,
 *                                              XMSarray<GLine>* XG,
 *                                              long numXGs,
 *                                              dleaf_t *pCenter = NULL )
 *
 ******************************************************************************/
void Grafi3D::Actualiza(        GVenBuf::Color color,
				XMSarray<GLine>* XG,
				long numXGs,
				dleaf_t *pCenter )
{
	struct viewporttype             estadoPantalla;
	float                           p1[2];
	float                           p2[2];
	dleaf_t                         dleaf, c;
	GLine                           gline;
	short                           x = 0, y = 0, z = 0;



	if( pCenter != NULL )
	{
		c = *pCenter;

		x = c.bound.min.x + ( ( c.bound.max.x - c.bound.min.x ) / 2 );
		y = c.bound.min.y + ( ( c.bound.max.y - c.bound.min.y ) / 2 );
		z = c.bound.min.z + ( ( c.bound.max.z - c.bound.min.z ) / 2 );
	}
	// Se preserva el rea establecida actualmente
	getviewsettings( &estadoPantalla );

	// Se delimita el rea de pantalla donde se llevar a cabo la representacin
	setviewport(    ( Ventana() -> rdbuf() -> Col() ) * 8,
			( Ventana() -> rdbuf() -> Lin() ) * 8,
			( Ventana() -> rdbuf() -> Col() + Ventana() -> rdbuf() -> Cols() ) * 8,
			( Ventana() -> rdbuf() -> Lin() + Ventana() -> rdbuf() -> Lins() ) * 8,
			1 );


	Rotacion();

	// Para todos los elementos de la matriz...
	for( long i = 0; i < numXGs; i++ )
	{
		gline = (*XG)[i];

		if( pCenter != NULL )
		{
			gline.sv.x -= x;
			gline.ev.x -= x;
			gline.sv.y -= y;
			gline.ev.y -= y;
			gline.sv.z -= z;
			gline.ev.z -= z;
		}
		Calcula3D( &p1[0], &p1[1], gline.sv.x, gline.sv.y, gline.sv.z );

		Calcula3D( &p2[0], &p2[1], gline.ev.x, gline.ev.y, gline.ev.z );

		DibujaLinea( color, p1, p2 );
	}
	setviewport( estadoPantalla.left, estadoPantalla.top, estadoPantalla.right, estadoPantalla.bottom, estadoPantalla.clip );

} // Actualiza


/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Vertices( GVenBuf::Color color,
 *                                      XMSarray<GLine>* XG,
 *                                      long numXGs )
 *
 ******************************************************************************/
void Grafi3D::Vertices( GVenBuf::Color color,
			XMSarray<GLine>* XG,
			long numXGs )
{
	struct viewporttype             estadoPantalla;
	float                           p1[2];
	float                           p2[2];
	GLine                           gline;



	// Se preserva el rea establecida actualmente
	getviewsettings( &estadoPantalla );

	// Se delimita el rea de pantalla donde se llevar a cabo la representacin
	setviewport(    ( Ventana() -> rdbuf() -> Col() ) * 8,
			( Ventana() -> rdbuf() -> Lin() ) * 8,
			( Ventana() -> rdbuf() -> Col() + Ventana() -> rdbuf() -> Cols() ) * 8,
			( Ventana() -> rdbuf() -> Lin() + Ventana() -> rdbuf() -> Lins() ) * 8,
			1) ;

	// Para todos los elementos de la matriz...
	for( long i = 0; i < numXGs; i++ )
	{
		gline = (*XG)[i];

		Rotacion();

		Calcula3D( &p1[0], &p1[1], gline.sv.x, gline.sv.y, gline.sv.z );

		Calcula3D( &p2[0], &p2[1], gline.ev.x, gline.ev.y, gline.ev.z );

		DibujaPunto( color, p1 );

		DibujaPunto( color, p2 );
	}
	setviewport( estadoPantalla.left, estadoPantalla.top, estadoPantalla.right, estadoPantalla.bottom, estadoPantalla.clip );

} // Vertices


/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Rotacion( void )
 *
 ******************************************************************************/
void Grafi3D::Rotacion( void )
{
	sr1 = sin( r1 ); sr2 = sin( r2 ); sr3 = sin( r3 );
	cr1 = cos( r1 ); cr2 = cos( r2 ); cr3 = cos( r3 );
}

/*******************************************************************************
 *
 *      METODO:
 *              void Grafi3D::Calcula3D( float *sx, float *sy, float x, float y, float z, )
 *
 ******************************************************************************/
void Grafi3D::Calcula3D( float *sx, float *sy, float x, float y, float z )
{
	float           xa = 0.0, ya = 0.0, za = 0.0;


	x = (-1)*x;
	xa = cr1*x - sr1*z;
	za = sr1*x + cr1*z;
	x = cr2*xa + sr2*y;
	ya = cr2*y - sr2*xa;
	z = cr3*za - sr3*ya;
	y = sr3*za + cr3*ya;
	x = x + mx;
	y = y + my;
	z = z+mz;
	*sx = d*x/z;
	*sy = d*y/z;
}


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

