/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              GVIEW.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Mon May 06 10:43:15 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

/*******************************************************************************
 *
 *      INCLUDES:
 *
 ******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>
#include <stdarg.h>
#include <time.h>
#include <iostream.h>
#include <fstream.h>


/*******************************************************************************
 *
 *      VARIABLES GLOBALES:
 *
 ******************************************************************************/
FILE *fp;
short x, y;


/*******************************************************************************
 *
 *      PROTOTIPOS:
 *
 ******************************************************************************/
int ReadBytes( FILE *file, void *addr, unsigned long size );
void Paleta( char color, char rojo, char verde, char azul );
void Modo( char mod );
int Descomprime( void );


/*******************************************************************************
 *
 *      FUNCTION:
 *		int ReadBytes( FILE *file, void *addr, unsigned long size )
 *
 ******************************************************************************/
int ReadBytes( FILE *file, void *addr, unsigned long size )
{
	while( size > 0x8000 )
    	{
      		if( fread( addr, 1, 0x8000, file) != 0x8000 )
		{
			return 0;
		}
      		addr = (char*)addr + 0x8000;
      		size -= 0x8000;
    	}
  	if( fread( addr, 1, size, file ) != size )
	{
    		return 0;
	}
  	return 1;
}

 
/*******************************************************************************
 *
 *      FUNCTION:
 *		void Paleta( char color, char rojo, char verde, char azul )
 *
 ******************************************************************************/
void Paleta( char color, char rojo, char verde, char azul )
{
	outportb( 0x3c8, color );
	outportb( 0x3c9, rojo );
	outportb( 0x3c9, verde );
	outportb( 0x3c9, azul );
}

	
/*******************************************************************************
 *
 *      FUNCTION:
 *		void Modo( char mod )
 *
 ******************************************************************************/
void Modo( char mod )
{
	union REGS reg;


	reg.h.ah = 0;
	reg.h.al = mod;
	int86( 0x10, &reg, &reg );
}


/*******************************************************************************
 *
 *      FUNCTION:
 *		int Descomprime( void ) 
 *
 ******************************************************************************/
int Descomprime( void ) 
{
	unsigned int	dat = 0;
	register int	zx = 0, zy = 0;
	char		ch;
	unsigned char	r, g, b;
	int		rep = 1;


	if( fseek( fp, -768, SEEK_END ) < 0 )
	{
		return 0;
	}
	for( dat = 0; dat < 256; dat++ )
	{
		r = getc( fp );
		g = getc( fp );
		b = getc( fp );
		r = 63 * r / 255;
		g = 63 * g / 255;
		b = 63 * b / 255;
		Paleta( dat, r, g, b );
	}
	if( fseek( fp, 128, SEEK_SET ) < 0 )
	{
		return 0;
	}
	dat = 0;
	zx = 0;
	zy = 0;
	while( !feof( fp ) )
	{
		ch = getc( fp );

		if( feof( fp ) )
		{
			break;
		}

		if( ( ch & 192 ) == 192 )
		{
			rep = ( ch & 63 );
			ch = getc( fp );
		}

		for( int con = 0; con < rep; con++ )
		{
			pokeb( 0xA000, zy * 320 + zx, ch );	
			zx++;
			if( zx > x )
			{
				zy++;
				zx =0;
			}
			if( zy > y )
			{
				goto end;
			}
		}
		rep = 1;
	}
end:
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *
 ******************************************************************************/
int ViewPCX( char *filename )
{
	char			ch;
	short			x1, x2, y1, y2;


	if( ( fp = fopen( filename, "rb" ) ) == NULL )
	{
		return 0;
	}
	if( !ReadBytes( fp, &ch, 1 ) )
	{
		fclose( fp );
		return 0;
	}
	if( ch != 10 )
	{
		fclose( fp );
		return 0;
	}
	if( !ReadBytes( fp, &ch, 1 ) )
	{
		fclose( fp );
		return 0;
	}
	if( ch != 5 )
	{
		fclose( fp );
		return 0;
	}
	if( fseek( fp, 4, SEEK_SET ) < 0 )
	{
		fclose( fp );
		return 0;
	}
	x1 = getw( fp );
	y1 = getw( fp );
	x2 = getw( fp );
	y2 = getw( fp );

	x = x2 - x1;
	y = y2 - y1;

	if( !Descomprime() )
	{
		fclose( fp );
		return 0;
	}
	// getch();
	fclose( fp );
	return 1;
}


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FIN DE FICHERO:
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
