/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              PROCESA.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Thu Apr 16 12:20:45 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

/*******************************************************************************
 *
 *      INCLUDES:
 *
 ******************************************************************************/
#include "GRaton.Hpp"

#include "doserror.h"
#include "xms.h"
#include "xmsarray.h"

#include "menu.h"
#include "view.hpp"
#include "grafico.hpp"
#include "glista.hpp"
#include "gview.hpp"
#include "working.hpp"
#include "unbsp.hpp"
#include "tracelog.hpp"
#include "test055.hpp"


/*******************************************************************************
 *
 *      DEFINES:
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *      TYPEDEF:
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *      VARIABLES IMPORTADAS:
 *
 ******************************************************************************/
extern int                     		adaptador;        /* tipo del adaptador ... */
extern int					modo;       	/* modo del adaptador ... */
extern XMSarray<miptex_t>              	*gMipTexs;              // miptex_t que se van a dibujar por pantalla...
extern XMSarray<miptex_t>              	*gMipTexs;              // miptex_t que se van a dibujar por pantalla...
extern XMSarray<dhull_t>               	*gHulls;                // dhull_t que se van a dibujar por pantalla...
extern XMSarray<node_t>                	*gNodes;                // nodes que se van a dibujar por pantalla...
extern XMSarray<dleaf_t>               	*gLeafs;                // dleaf_t que se van a dibujar por pantalla...
extern XMSarray<surface_t>             	*gSurfaces;             // surface_t que se van a dibujar por pantalla...
extern XMSarray<edge_t>                	*gEdges;                // edges que se van a dibujar por pantalla...
extern XMSarray<vertex_t>              	*gVertexs;              // vertexs que se van a dibujar por pantalla...
extern XMSarray<GEntiti>               	*gGEntities;            // gentities que se van a dibujar por pantalla...
extern XMSarray<long>                  	*gGEntiSelecs;          // indices de gentities seleccionadas...
extern XMSarray<long>                  	*gGEntiTags;            // indices de gentities targets...
extern XMSarray<GLine>                 	*gSPs;                  // puntos para dibujar la superficie en X=cte.
extern XMSarray<long>                   *gLeafSelecs;           // indices de los leafs seleccionados;
extern XMSarray<GLine>                  *gGLineSelecs;          // indices de las GLines seleccionadas.
extern XMSarray<long>                   *gSurfSelecs;           // indices de las superficies seleccionadas.
extern XMSarray<dleaf_t>                *gAreaSelecs;           // areas seleccionadas.
extern long                            numMipTexs;
extern long                            numHulls;
extern long                            numNodes;
extern long                            numLeafs;
extern long                            numSurfaces;
extern long                            numEdges;
extern long                            numVertexs;
extern long                            numGEntities;
extern long                            numGEntiSelecs;
extern long                            numGEntiTags;
extern long                            numSPs;
extern long                            numLeafSelecs;
extern long                            numGLineSelecs;
extern long                            numSurfSelecs;
extern long                            numAreaSelecs;

extern float                            r;              // razon para dibujar el grafico ...
extern Direccion                        direccion;      // direccion para mover el dibujo en panatalla ...
extern Plano                            plano;          // plano para dibujar en panatalla...
extern unsigned long                    client_stat;    // estado del dibujo de la pantalla...
extern unsigned long                    client_selec;   // estado de la seleccion del dibujo de la pantalla ...

extern Bsp                              *bsp;           // clase para manipular ficheros BSP.
extern XMSarray<char>                   *pBSP;          // puntero al buffer donde alojar el fichero BSP.
extern long                             sizeBSP;        // tamano del buffer del fichero BSP.
extern XMSarray<char>                   *pX;            // puntero al buffer donde alojar el fichero THI.
extern long                             sizeX;          // tamano del buffer del fichero THI.


extern XMSarray<ClassId>                *pClassIds;     // tabla de identificadores de nombres de classnames.
extern long                             numClassIds;    // # de identificadores de nombres de classnames.
extern XMSarray<char>                   *pClassNames;   // puntero al buffer para los nombres de las entities.
extern long                             sizeClassNames; // tamano del buffer para los nombres de las entities.

extern int                              x, y, z;        // coordenadas iniciales para centrar el grafico.

extern Working                          *working;       // clase para simular que se esta procesando un orden.

extern char            			editClassName[MAX_CLASSNAME_LEN];	// nombre de la entiti que se ha seleccionado para editar.
extern char            			editMipTexName[MAX_MIPTEXNAME_LEN];	// nombre de la textura que se ha seleccionado para editar.

extern char                            mypath[257];            // path inicial donde se ejecuta el programa.
extern char                            mypalette[257];            // path inicial donde se ejecuta el programa.

/*******************************************************************************
 *
 *      VARIABLES GLOBALES:
 *
 ******************************************************************************/
float                            r2d;            // razon para dibujar el grafico en 2d ...
float                            r3d;            // razon para dibujar el grafico en 3d ...


/*******************************************************************************
 *
 *      FUNCTION:
 *              void Test055::Refresca( void )
 *
 ******************************************************************************/
void Test055::Refresca( void )
{
	pantalla.Refresca();
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              void Test055::Limpiar( void )
 *
 ******************************************************************************/
void Test055::Limpiar( void )
{
	switch( grafico )
	{
		case _3D:
		{       
			client.g3d->LimpiarGrafico();
		}
		break;

		default:
		case _2D:
		{       
			client.gra->LimpiarGrafico();
		}
		break;
	}
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::Escala( void )
 *
 ******************************************************************************/
int Test055::Escala( void )
{

	switch( grafico )
	{
		case _3D:
		{       
			(*client.g3d) * r;
		}
		break;

		default:
		case _2D:
		{       
			(*client.gra) * r;
		}
		break;
	}
	Actualiza();

	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::Actualiza( void )
 *
 ******************************************************************************/
int Test055::Actualiza( void )
{
	unsigned long           mask = 0x00000000;
	dleaf_t                 leaf;



	switch( grafico ) {

	case _3D:
	{       
		// Dibujamos el leaf seleccionado en 3D.
		if( client_stat & 0x10000000 ) {
			leaf = (*gAreaSelecs)[0];
			client.g3d->Actualiza( SELECT_COLOR, gAreaSelecs, numAreaSelecs, NULL, 0, &leaf );
			if( client_stat & 0x00000002 ) {
				client.g3d->Actualiza( LEAF_COLOR, gLeafs, numLeafs, gLeafSelecs, numLeafSelecs, &leaf );
			}
			if( client_stat & 0x00000008 )
			{
				client.g3d->Actualiza( GSURFACE_COLOR, gGLineSelecs, numGLineSelecs, &leaf );
			}
			return 1;
		}
		if( client_stat & 0x00000001 ) {
			if( !gNodes->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Nodes Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gNodes"  );
				return 0;
			}
			client.g3d->Actualiza( GNODE_COLOR, gNodes );
		}
		if( client_stat & 0x00000002 )
		{
			if( !gLeafs->valid() ) {
				MessageBox( "Test055::Actualiza(): Alloc Leaves Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gLeafs"  );
				return 0;
			}
			client.g3d->Actualiza( LEAF_COLOR, gLeafs, numLeafs );
		}
		if( client_stat & 0x00000004 ) {
			if( !gHulls->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Hulls Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gHulls"  );
				return 0;
			}
			client.g3d->Actualiza( GDHULL_COLOR, gHulls, numHulls );
		}
		if( client_stat & 0x00000008 )
		{
			if( !gSPs->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Lines Error" );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gSPs"  );
				client_stat = client_stat & ~0x00000008;
				return 0;
			}
			client.g3d->Actualiza( GSURFACE_COLOR, gSPs, numSPs );
		}
		if( client_stat & 0x00000010 )
		{
			if( !gSPs->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Lines Error" );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gSPs"  );
				client_stat = client_stat & ~0x00000010;
				return 0;
			}
			client.g3d->Vertices( GVERTEX_COLOR, gSPs, numSPs );
		}
	}
	break;

	default:
	case _2D:       
	{
		if( client_stat & 0x00000001 ) {
			if( !gNodes->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Nodes Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gNodes"  );
				return 0;
			}
			client.gra->Actualiza( GNODE_COLOR, plano, gNodes );
		}
		if( client_stat & 0x00000002 ) {
			if( !gLeafs->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Leaves Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gLeafs"  );
				return 0;
			}
			client.gra->Actualiza( LEAF_COLOR, plano, gLeafs, numLeafs );
		}
		if( client_stat & 0x00000004 ) {
			if( !gHulls->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Hulls Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gHulls"  );
				return 0;
			}
			client.gra->Actualiza( GDHULL_COLOR, plano, gHulls );
		}
		if( client_stat & 0x00000008 )
		{
			if( !gSPs->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Lines Error" );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gSPs"  );
				client_stat = client_stat & ~0x00000008;
				return 0;
			}
			client.gra->Actualiza( GSURFACE_COLOR, gSPs, numSPs, plano );

		}
		if( client_stat & 0x00000010 )
		{
			if( !gSPs->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Lines Error" );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gSPs"  );
				client_stat = client_stat & ~0x00000010;
				return 0;
			}
			client.gra->Vertices( GVERTEX_COLOR, gSPs, numSPs, plano );
		}
		if( client_stat & 0x80000000 ) {
			mask = 0x80FFFF00;
			if( !gGEntiSelecs->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Selec Entities Queue Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntiSelecs"  );
				return 0;
			}
			client.gra->Entities( SELECT_COLOR, plano, mask, gGEntities, numGEntities, gHulls, gGEntiSelecs, numGEntiSelecs );
		}
		if( client_stat & 0x40000000 ) {
			mask = 0x40FFFF00;
			if( !gGEntiTags->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Tag Entities Queue Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntiTags"  );
				return 0;
			}
			client.gra->Entities( TAG_COLOR, plano, mask, gGEntities, numGEntities, gHulls, gGEntiTags, numGEntiTags );
			return 1;
		}
		if( client_stat & 0x20000000 ) {
			if( !gAreaSelecs->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Selecs Leafs Queue Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gLwafSelecs"  );
				return 0;
			}
			client.gra->Actualiza( SELECT_COLOR, plano, gAreaSelecs, numAreaSelecs );
			return 1;
		}
		if( client_stat & 0x00004000 ) {
			mask = 0x00004000;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( FUNC_COLOR, plano, mask, gGEntities, numGEntities, gHulls, NULL );
		}
		if( client_stat & 0x00008000 ) {
			mask = 0x00008000;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( TRIGGER_COLOR, plano, mask, gGEntities, numGEntities, gHulls, NULL );
		}
		if( client_stat & 0x00000100 ) {
			mask = 0x00000100;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( LIGHT_COLOR, plano, mask, gGEntities, numGEntities, NULL, NULL );
		}
		if( client_stat & 0x00020000 ) {
			mask = 0x00020000;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( AMBIENT_COLOR, plano, mask, gGEntities, numGEntities, NULL, NULL );
		}
		if( client_stat & 0x00000200 ) {
			mask = 0x00000200;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( WEAPON_COLOR, plano, mask, gGEntities, numGEntities, NULL, NULL );
		}
		if( client_stat & 0x00000400 ) {
			mask = 0x00000400;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( MONSTER_COLOR, plano, mask, gGEntities, numGEntities, NULL, NULL );
		}
		if( client_stat & 0x00000800 ) {
			mask = 0x00000800;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( ITEM_COLOR, plano, mask, gGEntities, numGEntities, NULL, NULL );
		}
		if( client_stat & 0x00001000 ) {
			mask = 0x00001000;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( INFO_COLOR, plano, mask, gGEntities, numGEntities, NULL, NULL );
		}
		if( client_stat & 0x00002000 ) {
			mask = 0x00002000;
			if( !gGEntities->valid() )
			{
				MessageBox( "Test055::Actualiza(): Alloc Entities Error"  );
				TraceLog( TEST_LOG, "Test055::Actualiza(): validErr gGEntities"  );
				return 0;
			}
			client.gra->Entities( PATH_COLOR, plano, mask, gGEntities, numGEntities, NULL, NULL );
		}
	}
	break;
	}
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::Mover( int flag = 0 )
 *
 ******************************************************************************/
int Test055::Mover( int flag )
{
	GTeclado        teclado;



	switch( grafico )
	{
		case _3D:
		{
			if( !flag )
			{
				client.g3d->Mover( direccion );
			}
			else
			{
				client.g3d->Mover( direccion, flag );
			}
		}
		break;

		default:
		case _2D:
		{       
			client.gra->Mover( direccion );
		}
		break;
	}
	Actualiza();

	return 1;
}

/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::Edit( void )
 *
 ******************************************************************************/
int Test055::Edit( void )
{
	GRaton          raton;
	GEntiti         gEntiti;
	long            index;
	char            buf[MAX_CLASSNAME_LEN];
	long            size1, size12, size2;
	char            specific[MAX_SPECIFIC_LEN];
	int             i;
	GEvento         control;
	Evento          suceso;



	gEntiti.x = 0.0;
	gEntiti.y = 0.0;
	gEntiti.z = 0.0;
	gEntiti.c = 0x00000000;
	gEntiti.model = 0;
	gEntiti.target = 0;
	gEntiti.targetname = 0;
	gEntiti.index = -1;

	if( edit.ven != NULL )
	{
		GSExclusiva exclusiva = (*edit.ent)( "Plantilla", "Uno" );

		// Editar.
		if( exclusiva.Opcion == 1 )
		{
			// Si hay alguna Gentiti seleccionada.
			if( numGEntiSelecs )
			{
				// Iniciamos la ventana de procesando una orden.
				message = InitVentana( "Message", 10, 10, 60, 15, GVenBuf::Blanco, GVenBuf::Azul, &message );
				working = new Working( message );
				pantalla.Muestra( "Message" );
				pantalla.Refresca();
	
				// Obtenemos su indice.
				index = gGEntiSelecs->at( 0 );

				// Obtenemos la Gentiti.
				gEntiti = gGEntities->at( index );
			
				bsp->GetBspEntiti( gEntiti.index, pX, &sizeX, &size12, &size2 );
				size1 = sizeX - size12 - size2;
				for( long l = 0; l < size12;) {
					for( i = 0;(*pX)[size1+l] != '\n'; i++, l++ ) {
						specific[i] = (*pX)[size1+l];
					}
					specific[i] = '\0';
					working->AddLine( specific );
					l++;
				}
				do { control >> suceso; } while( suceso.Quien == Evento::Vacio );

				// Eliminamos la ventana de procesando una orden.
				pantalla.Elimina( "Message" );
				EndVentana( &message );
				delete working;  
			}
		}
		// Suprimir.
		if( exclusiva.Opcion == 2 )
		{
			// Si hay alguna Gentiti seleccionada.
			if( numGEntiSelecs )
			{
				// Obtenemos su indice.
				index = gGEntiSelecs->at( 0 );

				// Obtenemos la Gentiti.
				gEntiti = (*gGEntities)[index];
		
				// Si es suprimible.    
				if( gEntiti.c & 0x00001F00 )
				{
					// La eliminamos de memoria.
					bsp->Supr( pX, &sizeX, &gEntiti );
	     
					// Escribimos el cambio realizado en memoria en fichero temporal.
					if( !FreeFile( pX, sizeX, bsp->file[0] ) ) {
						TraceLog( TEST_LOG, "Test055():Edit(): FreeFile %s",  bsp->file[0] );
						return 0;
					}
					// Inizializamos de nuevo el array de GEntities.
					if( !bsp->InitGEntities( gGEntities, &numGEntities, pClassIds, numClassIds ) ) {
						TraceLog( TEST_LOG, "Test055::Edit(): InitGEntitiesErr" );
						return 0;
					}
					// TraceLog( TEST_LOG, "numGEntities=%ld", numGEntities );
				}
			}
		}
		// Mover.
		if( exclusiva.Opcion == 3 )
		{
			// Si hay alguna Gentiti seleccionada.
			if( numGEntiSelecs )
			{
				// Obtenemos su indice.
				index = gGEntiSelecs->at( 0 );

				// Obtenemos la Gentiti.
				gEntiti = (*gGEntities)[index];
		
				// Si es movible        
				if( gEntiti.c & 0x00001F00 )
				{
					// Obtenemos las coordenadas de la entiti en el mapa a partir de la posicion del raton.
					client.gra->SetGEntiti( plano, raton.PosicionHorizontal(), raton.PosicionVertical(), &gEntiti );

					// La movemos de memoria.
					bsp->Move( pX, &sizeX, &gEntiti );
	     
					// Escribimos el cambio realizado en memoria en fichero temporal.
					if( !FreeFile( pX, sizeX, bsp->file[0] ) ) {
						TraceLog( TEST_LOG, "Test055():Edit(): FreeFile %s",  bsp->file[0] );
						return 0;
					}
					// Inizializamos de nuevo el array de GEntities.
					if( !bsp->InitGEntities( gGEntities, &numGEntities, pClassIds, numClassIds ) ) {
						TraceLog( TEST_LOG, "Test055::Edit(): InitGEntitiesErr" );
						return 0;
					}
					// TraceLog( TEST_LOG, "numGEntities=%ld", numGEntities );
				}
			}
		}
		if( exclusiva.Opcion == 4 )
		{
			if( client_stat & 0x00000E00 )
			{
				// Obtenemos las coordenadas de la entiti en el mapa a partir de la posicion del raton.
				client.gra->SetGEntiti( plano, raton.PosicionHorizontal(), raton.PosicionVertical(), &gEntiti );

				// Obtenemos el nombre que esta selecionado en la lista.
				selec.lis->GetDato( &buf[0] );

				// A partir del nombre obtenemos el identificador de la gentiti.
				GetClassId( pClassIds, numClassIds, &buf[0], &gEntiti.c );

				// Escribimos en memoria la nueva GEntiti.
				bsp->Insert( pX, &sizeX, &gEntiti, pClassIds, numClassIds );
	     
				// Escribimos el cambio realizado en memoria en fichero temporal.
				if( !FreeFile( pX, sizeX, bsp->file[0] ) ) {
				// TraceLog( TEST_LOG, "Test055():Edit(): FreeFile %s",  bsp->file[0] );
					return 0;
				}
				// Inizializamos de nuevo el array de GEntities.
				if( !bsp->InitGEntities( gGEntities, &numGEntities, pClassIds, numClassIds ) ) {
					TraceLog( TEST_LOG, "Test055::Edit(): InitGEntitiesErr" );
					return 0;
				}
				// TraceLog( TEST_LOG, "numGEntities=%ld", numGEntities );
			}
		}
	}
	// Editar.
	else {
		// Si hay alguna Gentiti seleccionada.
		if( numGEntiSelecs )
		{
			// Iniciamos la ventana de procesando una orden.
			message = InitVentana( "Message", 10, 10, 60, 15, GVenBuf::Blanco, GVenBuf::Azul, &message );
			working = new Working( message );
			pantalla.Muestra( "Message" );
			pantalla.Refresca();
	
			// Obtenemos su indice.
			index = gGEntiSelecs->at( 0 );

			// Obtenemos la Gentiti.
			gEntiti = gGEntities->at( index );
			
			bsp->GetBspEntiti( gEntiti.index, pX, &sizeX, &size12, &size2 );
			size1 = sizeX - size12 - size2;
			for( long l = 0; l < size12;) {
				for( i = 0;(*pX)[size1+l] != '\n'; i++, l++ ) {
					specific[i] = (*pX)[size1+l];
				}
				specific[i] = '\0';
				working->AddLine( specific );
				l++;
			}
			do { control >> suceso; } while( suceso.Quien == Evento::Vacio );

			// Eliminamos la ventana de procesando una orden.
			pantalla.Elimina( "Message" );
			EndVentana( &message );
			delete working;  
		}
	}
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::MessageBox( char* aMessage, int aStyle = 0x0001 )
 *
 ******************************************************************************/
int Test055::MessageBox( char* aMessage, int aStyle )
{
	int                     cod;    
	Boton                   *boton1 = NULL;
	Boton                   *boton2 = NULL;
	GCampo                  *campo1 = NULL;
	GCampo                  *campo2 = NULL;
	Cola<GCampo>            campo;
	char			buf[513];
	char			*ptr1, *ptr2;
	int			end = 0, x = 0, y = 0;



	if( ( aStyle & 0x0001 ) && !( aStyle & 0x0002 ) ) {
		boton1 = new Boton( "   Ok   ", 1 );
		campo1 = new GCampo( "Uno", 25, 10, boton1 );
		campo << *campo1;
	}
	if( ( aStyle & 0x0002 ) && !( aStyle & 0x0001 ) ) {
		boton2 = new Boton( " Cancel ", 2 );
		campo2 = new GCampo( "Dos", 25, 10, boton2 );
		campo << *campo2;
	}
	if( ( aStyle & 0x0002 ) && ( aStyle & 0x0001 ) )
	{
		boton1 = new Boton( "   Ok   ", 1 );
		boton2 = new Boton( " Cancel ", 2 );
		campo1 = new GCampo( "Uno", 15, 10, boton1 );
		campo2 = new GCampo( "Dos", 35, 10, boton2 );
		campo << *campo1;
		campo << *campo2;
	}
	InitVentana( "Message", MESSAGE_LEFT, MESSAGE_TOP, MESSAGE_WIDTH, MESSAGE_HEIGHT, GVenBuf::Blanco, GVenBuf::Azul, &message );

	GPlantilla p(   "Plantilla",
			pantalla( "Message" ),
			campo,
			GVenBuf::Blanco, GVenBuf::Azul,
			GVenBuf::Amarillo, GVenBuf::Azul );
       
	// Crea el objeto de entrada de datos
	GEntrada peticion( &pantalla, p );

	
	pantalla( "Message" )->rdbuf()->FijaPosicionCursor( 1, 1 );

	ptr1 = ptr2 = aMessage;

	while( !end )
	{
		for( ptr1 = ptr2; *ptr2 != '\0' && *ptr2 != '\n'; ptr2++ );	
		{
			if( *ptr2 == '\n' )
			{
				*ptr2 = '\0';
			}
			else
			{
				end = 1;
			}
			strcpy( buf, ptr1 );
			pantalla( "Message" )->rdbuf()->PosicionCursor( x, y );
			*pantalla( "Message" ) << PosCursor( 1, y ) << buf;
			pantalla( "Message" )->rdbuf()->PosicionCursor( x, y );
			pantalla( "Message" )->rdbuf()->FijaPosicionCursor( 1, y+1 );
			ptr2++;
		}
	}

	// Muestra la ventana.
	pantalla.Muestra( message );

	pantalla.Refresca();
 
	// Ejecuta la peticin.
	cod = peticion.Ejecuta();

	// Acabamos con el mensaje.
	EndVentana( &message );

	if( boton1 != NULL ) {
		delete boton1;
	}
	if( boton2 != NULL ) {
		delete boton2;
	}
	if( campo1 != NULL ) {
		delete campo1;
	}
	if( campo2 != NULL ) {
		delete campo2;
	}
	return cod;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::InitEditVentana( void )
 *
 ******************************************************************************/
int Test055::InitEditVentana( void )
{
	dhull_t         hull;



	switch( client_selec )
	{
		case 0x00000004:
			InitVentana( "Edit", TEX_EDIT_LEFT, TEX_EDIT_TOP, TEX_EDIT_WIDTH, TEX_EDIT_HEIGHT, GVenBuf::Negro, GVenBuf::GrisClaro, &edit.ven );

			edit.mul = new SMultiple( 1, 2 );

			edit.pla = new GPlantilla(      "Plantilla",
							pantalla( "Edit" ),
							GCampo( "Ocho", 2, 6, edit.mul ), 
							GVenBuf::Negro, GVenBuf::GrisClaro,
							GVenBuf::Negro, GVenBuf::GrisClaro );

			// Crea el objeto de entrada de datos
			edit.ent = new GEntrada( &pantalla, *edit.pla ); 

			// Se muestra la ventana.
			pantalla.Muestra( "Edit" );

			// Saca el texto por la ventana.
			*pantalla( "Edit" ) << PosCursor( 2, 1 ) << "Texture=";
			*pantalla( "Edit" ) << PosCursor( 2, 3 ) << "Width=";
			*pantalla( "Edit" ) << PosCursor( 2, 4 ) << "Height=";
			*pantalla( "Edit" ) << PosCursor( 6, 6 ) << "Save as PCX";
			*pantalla( "Edit" ) << PosCursor( 6, 7 ) << "Save as BMP";

		break;

		case 0x00000002:
			InitVentana( "Edit", ARE_EDIT_LEFT, ARE_EDIT_TOP, ARE_EDIT_WIDTH, ARE_EDIT_HEIGHT, GVenBuf::Negro, GVenBuf::GrisClaro, &edit.ven );

			for( int i = 0; i < 6; i++ )
			{
				edit.ente[i] = new GEntero( 8, 0, 8, i+3, "Edit", &pantalla );
			}
			edit.pla = new GPlantilla(      "Plantilla",
							pantalla( "Edit" ),
							GCampo( "Dos", 8, 3, edit.ente[0] ) + 
							GCampo( "Tres", 8, 4, edit.ente[1] ) + 
							GCampo( "Cuatro", 8, 5, edit.ente[2] ) + 
							GCampo( "Cinco", 8, 6, edit.ente[3] ) + 
							GCampo( "Seis", 8, 7, edit.ente[4] ) + 
							GCampo( "Siete", 8, 8, edit.ente[5] ), 
							GVenBuf::Negro, GVenBuf::GrisClaro,
							GVenBuf::Negro, GVenBuf::Verde );

			// Crea el objeto de entrada de datos
			edit.ent = new GEntrada( &pantalla, *edit.pla ); 

			// Se muestra la ventana.
			pantalla.Muestra( "Edit" );

			// Saca el texto por la ventana.
			*pantalla( "Edit" ) << PosCursor( 2, 1 ) << "Leaf=";
			*pantalla( "Edit" ) << PosCursor( 2, 3 ) << "min X=";
			*pantalla( "Edit" ) << PosCursor( 2, 4 ) << "min Y=";
			*pantalla( "Edit" ) << PosCursor( 2, 5 ) << "min Z=";
			*pantalla( "Edit" ) << PosCursor( 2, 6 ) << "max X=";
			*pantalla( "Edit" ) << PosCursor( 2, 7 ) << "max Y=";
			*pantalla( "Edit" ) << PosCursor( 2, 8 ) << "max Z=";

			hull = (*gHulls)[0];

			edit.ente[0]->SetValue( hull.bound.min.x );
			edit.ente[1]->SetValue( hull.bound.min.y );
			edit.ente[2]->SetValue( hull.bound.min.z );
			edit.ente[3]->SetValue( hull.bound.max.x );
			edit.ente[4]->SetValue( hull.bound.max.y );
			edit.ente[5]->SetValue( hull.bound.max.z );
		break;

		case 0x00000001:
		default:
			InitVentana( "Edit", ITE_EDIT_LEFT, ITE_EDIT_TOP, ITE_EDIT_WIDTH, ITE_EDIT_HEIGHT, GVenBuf::Negro, GVenBuf::GrisClaro, &edit.ven );

			edit.exc = new SExclusiva( 1, 4 );

			edit.pla = new GPlantilla(      "Plantilla",
							pantalla( "Edit" ),
							GCampo( "Uno", 2, 4, edit.exc ), 
							GVenBuf::Negro, GVenBuf::GrisClaro,
							GVenBuf::Negro, GVenBuf::GrisClaro );

			// Crea el objeto de entrada de datos
			edit.ent = new GEntrada( &pantalla, *edit.pla ); 

			// Se muestra la ventana.
			pantalla.Muestra( "Edit" );

			// Saca el texto por la ventana.
			*pantalla( "Edit" ) << PosCursor( 8, 4 ) << "Edit";
			*pantalla( "Edit" ) << PosCursor( 8, 5 ) << "Supr";
			*pantalla( "Edit" ) << PosCursor( 8, 6 ) << "Move";
			*pantalla( "Edit" ) << PosCursor( 8, 7 ) << "Insert";

		break;
	}
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::ActualizaEditVentana( void )
 *
 ******************************************************************************/
int Test055::ActualizaEditVentana( void )
{
	dleaf_t         leaf;
	miptex_t	miptex;
	GVenBuf::Color	color;
	char		buf[MAX_CLASSNAME_LEN];
	char		filename[257];
	char		viewname[257];
	int		j = 0;
	long		index = 0;
	GEvento         control;
	Evento          suceso;
	GRaton		raton;



	if( edit.ven != NULL )
	{       
		switch( client_selec )
		{
			case 0x00000004:

				if( selec.ven != NULL )
				{
					strcpy( buf, editMipTexName );

					j = strlen( buf );

					if( j < 8 )
					{
						for( ; j < 8; j++ )
						{
							buf[j] = ' ';
						}
					}
					buf[8] = '\0';
					color = pantalla( "Edit" )->rdbuf()->TintaActual();
					pantalla( "Edit" )->rdbuf()->TintaActual( GVenBuf::Rojo );
					*pantalla( "Edit" ) << PosCursor( 10, 1 ) << buf;
					pantalla( "Edit" )->rdbuf()->TintaActual( color );

					if( ( index = GetMipTex( editMipTexName, gMipTexs, numMipTexs, &miptex ) ) >= 0 )
					{
						*pantalla( "Edit" ) << PosCursor( 8, 3 ) << "     ";
						*pantalla( "Edit" ) << PosCursor( 9, 4 ) << "     ";
						color = pantalla( "Edit" )->rdbuf()->TintaActual();
						pantalla( "Edit" )->rdbuf()->TintaActual( GVenBuf::Rojo );
						*pantalla( "Edit" ) << PosCursor( 8, 3 ) << miptex.width;
						*pantalla( "Edit" ) << PosCursor( 9, 4 ) << miptex.height;
						pantalla( "Edit" )->rdbuf()->TintaActual( color );
					}
					closegraph();

					Modo( 0x13 );

					strcpy( filename, bsp->pathbsp );	
					if( editMipTexName[0] != '*' && editMipTexName[0] != '+' )
					{
						strcpy( viewname, editMipTexName );
					}
					else
					{
						strcpy( buf, editMipTexName );
						buf[0] = '_';
						strcpy( viewname, buf );
					}
					strcat( filename, viewname );	
					strcat( filename, ".PCX" );	

					if( !ViewPCX( filename ) )
					{
						TraceLog( TEST_LOG, "Test055::ActualizaEditVentana(): ViewPCXErr %s", viewname );
					}
					do { control >> suceso; } while( suceso.Quien == Evento::Vacio );

					// Inicializamos el modo grafico.
					initgraph( &adaptador, &modo, mypath );

					pantalla( "Edit" )->rdbuf()->BordeVentana( GVenBuf::Simple );
					pantalla( "Selec" )->rdbuf()->BordeVentana( GVenBuf::Doble );

					pantalla.Refresca2();
				
					// Mostamos el raton.
					raton.MuestraCursor();
		
					GSMultiple multiple = (*edit.ent)( "Plantilla", "Ocho" );


					if( multiple.Opcion[0].Estado )
					{
						// Obtenemos el directorio donde guardar el PCX.
						strcpy( filename, mypath );
						strcat( filename, "\\PCX" );
						mkdir( filename );
						strcat( filename, "\\" );
						strcat( filename, viewname );
						strcat( filename, ".PCX" );
						TraceLog( TEST_LOG, "mypalette=%s", mypalette );
						// TraceLog( TEST_LOG, "filename=%s", filename );
						if( !bsp->SaveMipTex( miptex, index, filename, mypalette, 0 ) )
						{
							TraceLog( TEST_LOG, "Test055:ActualizaEdit(): SaveMipTexErr" );
						}
					}
					if( multiple.Opcion[1].Estado )
					{
						strcpy( filename, mypath );
						strcat( filename, "\\BMP" );
						mkdir( filename );
						strcat( filename, "\\" );
						strcat( filename, viewname );
						strcat( filename, ".BMP" );
						TraceLog( TEST_LOG, "mypalette=%s", mypalette );
						// TraceLog( TEST_LOG, "filename=%s", filename );
						if( !bsp->SaveMipTex( miptex, index, filename, mypalette, 1 ) )
						{
							TraceLog( TEST_LOG, "Test055:ActualizaEdit(): SaveMipTexErr" );
						}
					}

				}
			break;


			case 0x00000002:
/*
				if( numLeafSelecs == 1 )
				{
					leaf = (*gLeafs)[(*gLeafSelecs)[0]];
				}
				else 
				{
					leaf = (*gAreaSelecs)[0];
				}
*/
				leaf = (*gAreaSelecs)[0];

				if( selec.ven != NULL )
				{
					*pantalla( "Edit" ) << PosCursor( 8, 1 ) << (*gLeafSelecs)[0];
					edit.ente[0]->SetValue( leaf.bound.min.x );
					edit.ente[1]->SetValue( leaf.bound.min.y );
					edit.ente[2]->SetValue( leaf.bound.min.z );
					edit.ente[3]->SetValue( leaf.bound.max.x );
					edit.ente[4]->SetValue( leaf.bound.max.y );
					edit.ente[5]->SetValue( leaf.bound.max.z );
				}       
			break;

			case 0x00000001:
				if( selec.ven != NULL )
				{
					for( j = 0; j < ITE_EDIT_WIDTH-2; j++ )
					{
						buf[j] = editClassName[j];
					}

					j = strlen( buf );

					if( j < ITE_EDIT_WIDTH-2 )
					{
						for( ; j < ITE_EDIT_WIDTH-2; j++ )
						{
							buf[j] = ' ';
						}
					}
					buf[ITE_EDIT_WIDTH-2] = '\0';
					color = pantalla( "Edit" )->rdbuf()->TintaActual();
					pantalla( "Edit" )->rdbuf()->TintaActual( GVenBuf::Rojo );
					*pantalla( "Edit" ) << PosCursor( 2, 2 ) << buf;
					pantalla( "Edit" )->rdbuf()->TintaActual( color );
				}
			default:
			break;
		}
	}
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::InitSelecVentana( void )
 *
 ******************************************************************************/
int Test055::InitSelecVentana( void )
{

	switch( client_selec )
	{
		case 0x00000004:
			// Inicializamos la ventana de la lista.
			InitVentana( "Selec", TEX_SELEC_LEFT, TEX_SELEC_TOP, TEX_SELEC_WIDTH, TEX_SELEC_HEIGHT, GVenBuf::Negro, GVenBuf::GrisClaro, &selec.ven );

			// Muestra la ventana.
			pantalla.Muestra( "Selec" );

			// Inicializamos la lista.
			if( ( selec.lis = new GLista( ITE_SELEC_WIDTH, ITE_SELEC_HEIGHT, "Selec", &pantalla, this ) ) == NULL )
			{
				TraceLog( TEST_LOG, "Test055::InitSelecVenentana():: newErr" );
				return 0;
			}
		break;

		case 0x00000002:
			// Inicializamos la ventana de la lista.
			InitVentana( "Selec", ARE_SELEC_LEFT, ARE_SELEC_TOP, ARE_SELEC_WIDTH, ARE_SELEC_HEIGHT, GVenBuf::Negro, GVenBuf::GrisClaro, &selec.ven );

			// Muestra la ventana.
			pantalla.Muestra( "Selec" );

			// Inicializamos la lista.
			if( ( selec.lis = new GLista( ARE_SELEC_WIDTH, ARE_SELEC_HEIGHT, "Selec", &pantalla, this ) ) == NULL )
			{
				TraceLog( TEST_LOG, "Test055::InitSelecVenentana():: newErr" );
				return 0;
			}
		break;

		case 0x00000001:
			// Inicializamos la ventana de la lista.
			InitVentana( "Selec", ITE_SELEC_LEFT, ITE_SELEC_TOP, ITE_SELEC_WIDTH, ITE_SELEC_HEIGHT, GVenBuf::Negro, GVenBuf::GrisClaro, &selec.ven );

			// Muestra la ventana.
			pantalla.Muestra( "Selec" );

			// Inicializamos la lista.
			if( ( selec.lis = new GLista( ITE_SELEC_WIDTH, ITE_SELEC_HEIGHT, "Selec", &pantalla, this ) ) == NULL )
			{
				TraceLog( TEST_LOG, "Test055::InitSelecVenentana():: newErr" );
				return 0;
			}
		break;
	}
	// Actualizamos la ventana.
	ActualizaSelecVentana();
	
	return 1;

}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::ActualizaSelecVentana( void )
 *
 ******************************************************************************/
int Test055::ActualizaSelecVentana( void )
{
	long            size = 0;
	long		l = 0;
	miptex_t	miptex;
	char		**mipTexNames;


	switch( client_selec )
	{
		case 0x00000004:
			if( selec.ven != NULL )
			{
				if( numMipTexs )
				{
					mipTexNames = new char*[numMipTexs];

					for( l = 0; l < numMipTexs; l++ )
					{
						mipTexNames[l] = new char[MAX_DATOS_LEN];

						miptex = (*gMipTexs)[l];

						strcpy( mipTexNames[l], miptex.name );
					}
					selec.lis->Actualiza( mipTexNames, numMipTexs );

					for( l = 0; l < numMipTexs; l++ )
					{
						delete [] mipTexNames[l];
					}
				}
			}       
		break;

		case 0x00000002:
			if( selec.ven != NULL )
			{
				if( numLeafSelecs )
				{
					selec.lis->Actualiza( gLeafSelecs, numLeafSelecs );
				}
			}       
		break;

		case 0x00000001:
		default:
			if( selec.ven != NULL )
			{
				// Comprobamos el estado del buffer de classnames.
				if( !pClassNames->valid() )
				{
					TraceLog( TEST_LOG, "Test055::ActualizaSelecVentana(): validErr pClassNames"  );
					return 0;
				}
				// Obtenemos la lista de las classnames.
				GetListClassName( pClassNames, &size, pClassIds, numClassIds, client_stat );

				// Actualizamos la lista.
				selec.lis->Actualiza( pClassNames, size );
			}       
		break;
	}
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::EndEditVentana( void )
 *
 ******************************************************************************/
int Test055::EndEditVentana( void )
{
	EndVentana( &edit.ven );

	if( edit.pla != NULL )
	{
		delete edit.pla;
		edit.pla = NULL;
	}
	if( edit.ent != NULL )
	{
		delete edit.ent;
		edit.ent = NULL;
	}
	if( edit.exc != NULL )
	{
		delete edit.exc;
		edit.exc = NULL;
	}
	if( edit.mul != NULL )
	{
		delete edit.mul;
		edit.mul = NULL;
	}
	for( int i = 0; i < 6; i++ )
	{
		if( edit.ente[i] != NULL )
		{
			delete edit.ente[i];
			edit.ente[i] = NULL;
		}
	}
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::EndSelecVentana( void )
 *
 ******************************************************************************/
int Test055::EndSelecVentana( void )
{
	EndVentana( &selec.ven );

	if( selec.lis != NULL )
	{
		delete selec.lis;
		selec.lis = NULL;
	}
	return 1;
}


/*******************************************************************************
 *
 *      METODOS:
 *              int Test055::GEntitiMessage( void ) 
 *
 ******************************************************************************/
int Test055::GEntitiMessage( void ) 
{
	long                    i = 0;
	long                    indice = 0;
	GEntiti                 gentiti;
	char                    buf[MAX_CLASSNAME_LEN];
	int                     linea, columna;
	GRaton                  raton;
	dhull_t                 dhull;



	// Para todas las gentities seleccionadas.
	for( i = 0; i < numGEntiSelecs; i++ )
	{
		indice = gGEntiSelecs->at( i );
		gentiti = gGEntities->at( indice );
		GetClassName( pClassIds, numClassIds, buf, gentiti.c );

		// Convertir la columna a ordenada de ventana
		columna = raton.PosicionHorizontal() / 8 + 1;

		// Convertir la columna a ordenada de ventana
		linea = raton.PosicionVertical() / 8 + 1;

		outtextxy( (columna+1) * textwidth( "X" ), (linea-1) * textheight( "X" ), buf ) ;
		if( gentiti.c & 0x01000000 ) {
/*
			dhull = (*gHulls)[gentiti.model];
			sprintf( buf, "min=(%d, %d, %d)", (int)dhull.bound.min.x, (int)dhull.bound.min.y, (int)dhull.bound.min.z );
			outtextxy( (columna+1) * textwidth( "X" ), (linea) * textheight( "X" ), buf ) ;
			sprintf( buf, "max=(%d, %d, %d)", (int)dhull.bound.max.x, (int)dhull.bound.max.y, (int)dhull.bound.max.z );
			outtextxy( (columna+1) * textwidth( "X" ), (linea+1) * textheight( "X" ), buf ) ;
*/
		}
		else {
			sprintf( buf, "x=%d y=%d z=%d", (int)gentiti.x, (int)gentiti.y, (int)gentiti.z );
			outtextxy( (columna+1) * textwidth( "X" ), (linea) * textheight( "X" ), buf ) ;
		}
	}
	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::Procesa( unsigned int id )
 *
 ******************************************************************************/
int Test055::Procesa( unsigned int id )
{ 
	int                     salida = 0;             // salida del programa.
	unsigned int            exec = 0x0000;          // mascara de funciones a ejecutar.
	GRaton                  raton;                  // objeto para manejar el raton.
	char                    filename[257];          // nombre del fichero para abrir.


	
	switch( id ) {

		case ID_FIL_OPE_XXX:
			if( !CloseFile() ) {
				MessageBox( "Test055::Procesa() Close File Error" );
				TraceLog( TEST_LOG, "Test055::Procesa() CloseFileErr %s", bsp->filebsp );
				salida = 1;
			}
			if( !GetFile( &filename[0] ) ) {
				MessageBox( "Test055::Procesa() Get File Error" );
				TraceLog( TEST_LOG, "Test055::Procesa() GetFileErr %s", &filename[0] );
				salida = 1;
			}
			if( !OpenFile( &filename[0] ) ) {
				MessageBox( "Test055::Procesa() Open File Error" );
				TraceLog( TEST_LOG, "Test055::Procesa() OpenFileErr %s", &filename[0] );
				salida = 1;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_FIL_SAV_XXX:
			if( !SaveFile( bsp->filebsp ) ) {
				MessageBox( "Test055::Procesa() Save File Error " );
				TraceLog( TEST_LOG, "Test055::Procesa() SaveFileErr %s", bsp->filebsp );
				salida = 1;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_FIL_QUI_XXX:
			salida = 1;
			break;

		case ID_EDI_ITE_XXX:
			client_selec = 0x00000001;
			numLeafSelecs = 0;
			numGLineSelecs = 0;
			numSurfSelecs = 0;
			numAreaSelecs = 0;
			client_stat = client_stat & ~0x20000000;
			client_stat = client_stat & ~0x10000000;
			EliminarVentanas();
			if( client_stat & 0x00000020 ) {
				client_stat = client_stat & ~0x00000020;
				numGEntiSelecs = 0;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH, CLIENT_HEIGHT );
				r = client.gra->razon;
			} else {
				client_stat = client_stat | 0x00000020;
				InitClientVentana( CLIENT_LEFT+ITE_EDIT_WIDTH+2, CLIENT_TOP, CLIENT_WIDTH-ITE_EDIT_WIDTH-2, CLIENT_HEIGHT );
				r = client.gra->razon;
				InitEditVentana( );
				InitSelecVentana();
			}
			client.gra->razon = r;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_EDI_ARE_XXX:
			// r = client.gra->razon;
			numGEntiSelecs = 0;
			numLeafSelecs = 0;
			numGLineSelecs = 0;
			numSurfSelecs = 0;
			numAreaSelecs = 0;
			EliminarVentanas();
			if( client_stat & 0x00000040 ) {
				client_stat = client_stat & ~0x00000040;
				client_stat = client_stat & ~0x20000000;
				client_stat = client_stat & ~0x10000000;
				client_selec = 0x00000001;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH, CLIENT_HEIGHT );
			} else {
				client_stat = client_stat | 0x00000040;
				client_selec = 0x00000002;
				numLeafSelecs = 0;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH-ARE_EDIT_WIDTH-2, CLIENT_HEIGHT );
				InitEditVentana();
				InitSelecVentana();
			}
			// client.gra->razon = r;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_EDI_TEX_XXX:
			client_selec = 0x00000004;
			numGEntiSelecs = 0;
			numLeafSelecs = 0;
			numGLineSelecs = 0;
			numSurfSelecs = 0;
			numAreaSelecs = 0;
			client_stat = client_stat & ~0x20000000;
			client_stat = client_stat & ~0x10000000;
			EliminarVentanas();
			if( client_stat & 0x08000000 ) {
				client_stat = client_stat & ~0x08000000;
				client_selec = 0x00000001;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH, CLIENT_HEIGHT );
				r = client.gra->razon;
			} else {
				client_stat = client_stat | 0x08000000;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH-TEX_EDIT_WIDTH-2, CLIENT_HEIGHT );
				r = client.gra->razon;
				InitEditVentana( );
				InitSelecVentana();
			}
			client.gra->razon = r;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;
		case ID_OPT_3DX_XXX:
			if( client_stat & 0x00000080 ) {
				client_stat = client_stat & ~0x00000080;
				if( client_stat & 0x00000020 ) {
					EliminarVentanas();
					InitClientVentana( CLIENT_LEFT+ITE_EDIT_WIDTH+2, CLIENT_TOP, CLIENT_WIDTH-ITE_EDIT_WIDTH-2, CLIENT_HEIGHT );
					InitEditVentana();
					InitSelecVentana();
				}
				else if( client_stat & 0x00000040 ) {
					EliminarVentanas();
					InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH-ARE_EDIT_WIDTH-2, CLIENT_HEIGHT );
					InitEditVentana();
					InitSelecVentana();
				} else {
					InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH, CLIENT_HEIGHT );
				}
			}
			else {
				client_stat = client_stat | 0x00000080;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH, CLIENT_HEIGHT, _3D );
			}
			// client.gra->razon = r;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_OPT_ZOO_INX:
			r = 1.25;
			exec = 0x0001 | 0x0002 | 0x0020;
			break;

		case ID_OPT_ZOO_OUT:
			r = 1 / 1.25;
			exec = 0x0001 | 0x0002 | 0x0020;
			break;

		case ID_OPT_MOV_IZQ:
			direccion = Left;
			exec = 0x0001 | 0x0004 | 0x0020;
			break;

		case ID_OPT_MOV_ARR:
			direccion = Up;
			exec = 0x0001 | 0x0004 | 0x0020;
			break;

		case ID_OPT_MOV_DER:
			direccion = Right;
			exec = 0x0001 | 0x0004 | 0x0020;
			break;

		case ID_OPT_MOV_ABA:
			direccion = Down;
			exec = 0x0001 | 0x0004 | 0x0020;
			break;

		case ID_OPT_MOV_CIZ:
			direccion = Left;
			exec = 0x0001 | 0x0100 | 0x0020;
			break;

		case ID_OPT_MOV_CAR:
			direccion = Up;
			exec = 0x0001 | 0x0100 | 0x0020;
			break;

		case ID_OPT_MOV_CDE:
			direccion = Right;
			exec = 0x0001 | 0x0100 | 0x0020;
			break;

		case ID_OPT_MOV_CAB:
			direccion = Down;
			exec = 0x0001 | 0x0100 | 0x0020;
			break;

		case ID_OPT_MOV_DIZ:
			direccion = Left;
			exec = 0x0001 | 0x0200 | 0x0020;
			break;

		case ID_OPT_MOV_DAR:
			direccion = Up;
			exec = 0x0001 | 0x0200 | 0x0020;
			break;

		case ID_OPT_MOV_DDE:
			direccion = Right;
			exec = 0x0001 | 0x0200 | 0x0020;
			break;

		case ID_OPT_MOV_DAB:
			direccion = Down;
			exec = 0x0001 | 0x0200 | 0x0020;
			break;

		case ID_OPT_PLA_XXX:
			plano = X0;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_OPT_PLA_YXX:
			plano = Y0;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_OPT_PLA_ZXX:
			plano = Z0;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_DRA_BOU_NOD:
			if( client_stat & 0x00000001 ) {
				client_stat = client_stat & ~0x00000001;
			} else {
				client_stat = client_stat | 0x00000001;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_DRA_BOU_DLE:
			if( client_stat & 0x00000002 ) {
				client_stat = client_stat & ~0x00000002;
			} else {
				client_stat = client_stat | 0x00000002;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_DRA_BOU_DHU:
			if( client_stat & 0x00000004 ) {
				client_stat = client_stat & ~0x00000004;
			} else {
				client_stat = client_stat | 0x00000004;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_DRA_SUR_XXX:
			if( client_stat & 0x00000008 ) {
				client_stat = client_stat & ~0x00000008;
			} else {
				client_stat = client_stat | 0x00000008;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_DRA_VER_XXX:
			if( client_stat & 0x00000010 ) {
				client_stat = client_stat & ~0x00000010;
			} else {
				client_stat = client_stat | 0x00000010;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_ENT_ITE_LIG:
			if( client_stat & 0x00000100 ) {
				client_stat = client_stat & ~0x00000100;
			} else {
				client_stat = client_stat | 0x00000100;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_ENT_ITE_AMB:
			if( client_stat & 0x00020000 ) {
				client_stat = client_stat & ~0x00020000;
			} else {
				client_stat = client_stat | 0x00020000;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_ENT_ITE_WEA:
			if( client_stat & 0x00000200 ) {
				client_stat = client_stat & ~0x00000200;
			} else {
				client_stat = client_stat | 0x00000200;
			}
			exec = 0x0001 | 0x0008 | 0x0020 | 0x0080;
			break;

		case ID_ENT_ITE_MON:
			if( client_stat & 0x00000400 ) {
				client_stat = client_stat & ~0x00000400;
			} else {
				client_stat = client_stat | 0x00000400;
			}
			exec = 0x0001 | 0x0008 | 0x0020 | 0x0080;
			break;

		case ID_ENT_ITE_ITE:
			if( client_stat & 0x00000800 ) {
				client_stat = client_stat & ~0x00000800;
			} else {
				client_stat = client_stat | 0x000000800;
			}
			exec = 0x0001 | 0x0008 | 0x0020 | 0x0080;
			break;

		case ID_ENT_ITE_INF:
			if( client_stat & 0x00001000 ) {
				client_stat = client_stat & ~0x00001000;
			} else {
				client_stat = client_stat | 0x000001000;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_ENT_ITE_PAT:
			if( client_stat & 0x00002000 ) {
				client_stat = client_stat & ~0x00002000;
			} else {
				client_stat = client_stat | 0x000002000;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_ENT_MOD_FUN:
			if( client_stat & 0x00004000 ) {
				client_stat = client_stat & ~0x00004000;
			} else {
				client_stat = client_stat | 0x000004000;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_ENT_MOD_TRI:
			if( client_stat & 0x00008000 ) {
				client_stat = client_stat & ~0x00008000;
			} else {
				client_stat = client_stat | 0x000008000;
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_XXX_ENT_SEL:
			client_stat = client_stat | 0x80000000;
			exec = 0x0001 | 0x0008 | 0x0010 | 0x0020;
			break;

		case ID_XXX_ENT_UNS:
			client_stat = client_stat & ~0x80000000;
			client_stat = client_stat & ~0x40000000;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_XXX_ENT_TAG:
			client_stat = client_stat | 0x80000000;
			client_stat = client_stat | 0x40000000;
			exec = 0x0001 | 0x0008 | 0x0010 | 0x0020;
			break;

		case ID_XXX_ENT_UNT:
			client_stat = client_stat & ~0x40000000;
			exec = 0x0001 | 0x0008 | 0x0010 | 0x0020;
			break;

		case ID_XXX_ARE_SEL:
			client_stat = client_stat | 0x20000000;
			ActualizaEditVentana();
			ActualizaSelecVentana();
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_XXX_ARE_UNS:
			client_stat = client_stat & ~0x20000000;
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_XXX_EDT_ENT:
			client_stat = client_stat & ~0x80000000;
			client_stat = client_stat & ~0x40000000;
			exec = 0x0001 | 0x0008 | 0x0020 | 0x0040;
			break;

		case ID_XXX_EDT_ARE:
			if( client_stat & 0x10000000 ) {
				EndClientVentana();
				client_stat = client_stat & ~0x10000000;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH-ARE_EDIT_WIDTH-2, CLIENT_HEIGHT );
				client.gra->razon = r2d;
			} else {
				r2d = client.gra->razon;
				EndClientVentana();
				client_stat = client_stat | 0x10000000;
				InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH-ARE_EDIT_WIDTH-2, CLIENT_HEIGHT, _3D );
			}
			exec = 0x0001 | 0x0008 | 0x0020;
			break;

		case ID_XXX_EDT_CNA:
			if( client_stat & 0x00000020 ) {
				ActualizaEditVentana();
				exec = 0x0001 | 0x0008 | 0x0020;
			}
			break;

		case ID_XXX_EDT_GLI:
			if( client_stat & 0x10000000 ) {
				ActualizaEditVentana();
				exec = 0x0001 | 0x0008 | 0x0020;
			}
			break;

		case ID_XXX_EDT_TEX:
			if( client_stat & 0x08000000 ) {
				ActualizaEditVentana();
				exec = 0x0001 | 0x0008 | 0x0020;
			}
			break;

		case ID_HEL_INF_XXX:
			MessageBox( STR_HEL_INF_XXX );
			break;

		case ID_HEL_ABO_XXX:
			MessageBox( STR_HEL_INF_XXX );
			break;

		default:
			salida = 1;
			break;
	}
	raton.OcultaCursor();

	if( exec & 0x0040 )
	{
		Edit();
	}
	if( exec & 0x0001 )
	{
		Limpiar();
	}
	if( exec & 0x0002 )
	{
		Escala();
	}
	if( exec & 0x0004 )
	{
		Mover();
	}
	if( exec & 0x0100 )
	{
		Mover( 1 );
	}
	if( exec & 0x0200 )
	{
		Mover( 2 );
	}
	if( exec & 0x0008 )
	{
		Actualiza();
	}
	if( exec & 0x0020 )
	{
		Refresca();
	}
	if( exec & 0x0010 )
	{
		GEntitiMessage();
	}
	if( exec & 0x0080 )
	{
		ActualizaSelecVentana();
	}
	raton.MuestraCursor();
	
	return salida;
}

/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

