/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              TEST055.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Wen Jun 19 23:20:30 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

/*******************************************************************************
 *
 *      INCLUDES:
 *
 ******************************************************************************/
#include <dos.h>
#include <graphics.h>
#include <direct.h>

#include "GRaton.Hpp"
#include "GVentana.Hpp"
#include "GEntrada.Hpp"

#include "doserror.h"
#include "xms.h"
#include "xmsarray.h"

#include "gview.hpp"
#include "menu.h"
#include "vstruct.h"
#include "tracelog.hpp"
#include "unbsp.hpp"
#include "working.hpp"
#include "test055.hpp"


/*******************************************************************************
 *
 *      VARIABLES IMPORTADAS:
 *
 ******************************************************************************/
extern unsigned _stklen = 25000;         // Se fija una pila mayor


/*******************************************************************************
 *
 *      VARIABLES EXPORTADAS:
 *
 ******************************************************************************/
int _stdout = 0;
int _file = 0;

int                             adaptador = VGA;        /* tipo del adaptador ... */
int                             modo = VGAMED;          /* modo del adaptador ... */
XMSarray<miptex_t>              *gMipTexs;              // miptex_t que se van a dibujar por pantalla...
XMSarray<dhull_t>               *gHulls;                // dhull_t que se van a dibujar por pantalla...
XMSarray<node_t>                *gNodes;                // nodes que se van a dibujar por pantalla...
XMSarray<dleaf_t>               *gLeafs;                // dleaf_t que se van a dibujar por pantalla...
XMSarray<surface_t>             *gSurfaces;             // surface_t que se van a dibujar por pantalla...
XMSarray<edge_t>                *gEdges;                // edges que se van a dibujar por pantalla...
XMSarray<vertex_t>              *gVertexs;              // vertexs que se van a dibujar por pantalla...
XMSarray<GEntiti>               *gGEntities;            // gentities que se van a dibujar por pantalla...
XMSarray<long>                  *gGEntiSelecs;          // indices de gentities seleccionadas.
XMSarray<long>                  *gGEntiTags;            // indices de gentities targets.
XMSarray<GLine>                 *gSPs;                  // puntos para dibujar la superficie en X=cte.
XMSarray<long>                  *gLeafSelecs;           // indices de los leafs seleccionados.
XMSarray<GLine>                 *gGLineSelecs;          // indices de las GLines seleccionadas.
XMSarray<long>                  *gSurfSelecs;           // indices de las surface_t seleccionadas.
XMSarray<dleaf_t>               *gAreaSelecs;           // indices de las areas seleccionadas.
long                            numMipTexs = 0;
long                            numHulls = 0;
long                            numNodes = 0;
long                            numLeafs = 0;
long                            numSurfaces = 0;
long                            numEdges = 0;
long                            numVertexs = 0;
long                            numGEntities = 0;
long                            numGEntiSelecs = 0;
long                            numGEntiTags = 0;
long                            numSPs = 0;
long                            numLeafSelecs = 0;
long                            numGLineSelecs = 0;
long                            numSurfSelecs = 0;
long                            numAreaSelecs = 0;
long                            sizeMipTexs = 0;
long                            sizeHulls = 0;
long                            sizeNodes = 0;
long                            sizeLeafs = 0;
long                            sizeSurfaces = 0;
long                            sizeEdges = 0;
long                            sizeVertexs = 0;
long                            sizeGEntities = 0;
long                            sizeGEntiSelecs = 0;
long                            sizeGEntiTags = 0;
long                            sizeSPs = 0;
long                            sizeLeafSelecs = 0;
long                            sizeGLineSelecs = 0;
long                            sizeSurfSelecs = 0;
long                            sizeAreaSelecs = 0;

float                           r = 1.0;                // razon para dibujar el rectangulo ...
Direccion                       direccion = Right;      // direccion para mover el dibujo en panatalla ...
Plano                           plano = Z0;             // plano para dibujar en panatalla ... 
unsigned long                   init_stat = 0x00000000; // estado de inicializacion de los datos ...
unsigned long                   client_stat = 0x00000E02;   // estado del dibujo de la pantalla ...
unsigned long                   client_selec = 0x00000001;  // estado de la seleccion del dibujo de la pantalla ...
unsigned long                   edit_stat = 0x00000000; // estado del dibujo de la pantalla ...

Bsp                             *bsp;                   // clase para manipular ficheros BSP.
XMSarray<char>                  *pBSP;                  // puntero a memoria XMS donde alojar el fichero BSP.
long                            sizeBSP;                // tamano del fichero BSP.
XMSarray<char>                  *pX;                    // puntero a memoria XMS donde alojar el fichero THI.
long                            sizeX;                  // tamano del fichero THI.

XMSarray<ClassId>               *pClassIds;             // tabla de identificadores de nombres de classnames.
long                            numClassIds;            // # de identificadores de nombres de classnames.
long                            sizeClassIds;           // tamano de identificadores de nombres de classnames.
XMSarray<char>                  *pClassNames;           // puntero al buffer para los nombres de las entities.
long                            sizeClassNames;         // tamano del buffer para los nombres de las entities.

int                             x, y, z;                // coordenadas iniciales para pasar de la pantalla al mapa.

Working                         *working;               // clase para indicar que se esta procesando alguna orden.

char                            editClassName[MAX_CLASSNAME_LEN];       // nombre de la entiti que se ha seleccionado para editar.
char                            editMipTexName[MAX_MIPTEXNAME_LEN];     // nombre de la entiti que se ha seleccionado para editar.

char                            mypath[257];            // path inicial donde se ejecuta el programa.
char                            mypalette[257];         // paleta para los graficos.



/*******************************************************************************
 *
 *      VARIABLES GLOBALES:
 *
 ******************************************************************************/

/*******************************************************************************
 *
 *      PROTOTIPOS:
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *      PROGRAMA PRINCIPAL:
 *
 ******************************************************************************/
void main( int argc, char* argv[] )
{
	Test055         test055;
	char            filename[257];
	char            string[513];
	int             response = 0x0000;



	getcwd( mypath, 257 );

	strcpy( mypalette, mypath );
	strcat( mypalette, "\\PALETTE.LMP" );

	test055.MessageBox( STR_INI_INF_XXX );

	do {
		if( ( argc != 2 ) || ( response != 0 ) ) {
			if( !test055.GetFile( &filename[0] ) ) {
				test055.MessageBox( "main(): Get BSP File Error" );
				TraceLog( TEST_LOG, "main(): GetFileErr" );
				closegraph();
				Modo( 0x03 );
				exit( -1 );
			}
		}
		else {
			strcpy( &filename[0], argv[1] );
		}       
		strcpy( &string[0], "Open BSP File " );
		strcat( &string[0], &filename[0] );
		strcat( &string[0], " ?" );

		response = test055.MessageBox( &string[0], 0x0003 );

	} while( response != 1 );

	if( !test055.OpenFile( &filename[0] ) ) {
		test055.MessageBox( "main(): Open BSP File Error" );
		TraceLog( TEST_LOG, "main(): OpenFileErr" );
		closegraph();
		Modo( 0x03 );
		exit( -1 );
	}
	// Se asigna la ventana para dibujar.
	test055.ActivaVentana( Test055::_Client );

	test055.Ejecuta();
}


/*******************************************************************************
 *
 *      CLASS:
 *              Test055
 *
 ******************************************************************************/
/*******************************************************************************
 *
 *      CONSTRUCTOR:
 *              Test055::Test055()
 *
 ******************************************************************************/
Test055::Test055():pantalla( GES::Modo50 )
{
	GRaton                  raton;                  /* objeto para manejar el raton ... */



	message = NULL;

	client.ven = NULL;
	client.gra = NULL;
	client.g3d = NULL;

	edit.ven = NULL;
	edit.pla = NULL;
	edit.ent = NULL;
	edit.exc = NULL;
	edit.mul = NULL;

	for( int i = 0; i < 6; i++ ) {
		edit.ente[i] = NULL;
	}
	selec.ven = NULL;       
	selec.lis = NULL;       

	gfile = NULL;

	strcpy( editClassName, "" );

	// Creamos el buffer para manipular el fichero BSP en memoria.
	if( ( pBSP = new XMSarray<char>( MAX_BSP_SIZE ) ) == NULL ) {
		TraceLog( TEST_LOG, "Test055::Test055(): newErr pBSP" );
	}
	// Creamos el buffer para manipular entries en memoria.
	if( ( pX = new XMSarray<char>( MAX_ENTRY_SIZE ) ) == NULL ) {
		TraceLog( TEST_LOG, "Test055::Test055(): newErr pX" );
	}
	// Creamos el buffer para manipular los nombres de entities en memoria.
	if( ( pClassNames = new XMSarray<char>( MAX_CLASSNAME_SIZE ) ) == NULL )
	{
		TraceLog( TEST_LOG, "Test055::Test055(): newErr pClassName" );
	}
/*
	Modo( 0x13 );
	if( !ViewPCX( "C:\\TESTS\\TEST055\\TEST055.PCX" ) )
	{
		TraceLog( TEST_LOG, "Test055::Test055(): ViewPCXErr" );
	}
	getch();
*/
	// Inicializamos el modo grafico.
	initgraph( &adaptador, &modo, mypath );

	// Mostamos el raton.
	raton.MuestraCursor();

	// Se crea la ventana del menu.
	InitMenu();

	// Se crea la ventana cliente.
	InitClientVentana( CLIENT_LEFT, CLIENT_TOP, CLIENT_WIDTH, CLIENT_HEIGHT );

}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::InitClientVentana( int left, int top, int width, int height, TipoGrafico gra = _2D )
 *
 ******************************************************************************/
int Test055::InitClientVentana( int left, int top, int width, int height, TipoGrafico gra )
{
	// Ponemos el tipo de graficos.
	grafico = gra;

	// Inicializamos la ventana de la cliente.
	InitVentana( "Client", left, top, width, height, GVenBuf::GrisClaro, GVenBuf::Negro, &client.ven );
			
	// Muestra la ventana.
	pantalla.Muestra( "Client" );

	// Creamos la zona para graficos.
	switch( grafico )
	{
		case _3D:
			if( ( client.g3d = new Grafi3D( client.ven ) ) == NULL ) {
				TraceLog( TEST_LOG, "InitClientVentana(): newErr" );
				return 0;
			}
		break;  

		default:
		case _2D:
			if( ( client.gra = new Grafico( client.ven ) ) == NULL ) {
				TraceLog( TEST_LOG, "InitClientVentana(): newErr" );
				return 0;
			}
		break;  
	}
	return 1;
}


/*******************************************************************************
 *
 *      FUNCTION:
 *              int Test055::EndClientVentana( void )
 *
 ******************************************************************************/
int Test055::EndClientVentana( void )
{
	EndVentana( &client.ven );

	if( client.gra != NULL ) {
		delete client.gra;
		client.gra = NULL;
	}
	if( client.g3d != NULL ) {
		delete client.g3d;
		client.g3d = NULL;
	}
	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::LoadBSP( char* dirname )
 *
 ******************************************************************************/
int Test055::LoadBSP( char* dirname )
{
	char            classfile[257];
	miptex_t        m;



	if( !( numMipTexs = InitMipTexs( dirname, NULL ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init MipTexs Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitMipTexsErr" );
		return 0;
	}
	gMipTexs = new XMSarray<miptex_t>( numMipTexs );
	if( !gMipTexs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc MipTexs Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gMipTexs"  );
		return 0;
	}
	if( !( numMipTexs = InitMipTexs( dirname, gMipTexs ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init MipTexs Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitMipTexsErr" );
		return 0;
	}
/*
	for( long l = 0; l < numMipTexs; l++ )
	{
		m = (*gMipTexs)[l];
		TraceLog( TEST_LOG, "MipTexs[%ld]=%s, %ld, %ld, %ld, %ld, %ld, %ld", l, m.name, m.width, m.height, m.offsets[0], m.offsets[1], m.offsets[2], m.offsets[3] );
	}
*/
	if( !( numLeafs = InitDLeafs( dirname, NULL ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init Leaves Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitDLeafsErr" );
		return 0;
	}
	gLeafs = new XMSarray<dleaf_t>( numLeafs );
	if( !gLeafs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Leaves Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gLeafs"  );
		return 0;
	}
	if( !InitDLeafs( dirname, gLeafs ) ) {
		MessageBox( "Test055::LoadBSP(): Init Leaves Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitDLeafsErr" );
		return 0;
	}
	if( !( numNodes = InitNodes( dirname, NULL ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init Nodes Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitNodesErr" );
		return 0;
	}
	gNodes = new XMSarray<node_t>( numNodes );
	if( !gNodes->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Nodes Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gNodes"  );
		return 0;
	}
	if( !InitNodes( dirname, gNodes ) ) {
		MessageBox( "Test055::LoadBSP(): Init Nodes Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitNodesErr" );
		return 0;
	}
	if( !( numHulls = InitDHulls( dirname, NULL ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init Hulls Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitDHullsErr" );
		return 0;
	}
	gHulls = new XMSarray<dhull_t>( numHulls );
	if( !gHulls->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Hulls Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gHulls"  );
		return 0;
	}
	if( !InitDHulls( dirname, gHulls ) ) {
		MessageBox( "Test055::LoadBSP(): Init Hulls Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitDHullsErr" );
		return 0;
	}
	if( !( numSurfaces = InitSurfaces( dirname, NULL ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init Surfaces Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitSurfacesErr" );
		return 0;
	}
	gSurfaces = new XMSarray<surface_t>( numSurfaces );
	if( !gSurfaces->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Surfaces Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gSurfaces"  );
		return 0;
	}
	if( !InitSurfaces( dirname, gSurfaces ) ) {
		MessageBox( "Test055::LoadBSP(): Init Surfaces Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitSurfacesErr" );
		return 0;
	}
	if( !( numEdges = InitEdges( dirname, NULL ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init Edges Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitEdgesErr" );
		return 0;
	}
	gEdges = new XMSarray<edge_t>( numEdges );
	if( !gEdges->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Edges Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gEdges"  );
		return 0;
	}
	if( !InitEdges( dirname, gEdges ) ) {
		MessageBox( "Test055::LoadBSP(): Init Edges Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitEdgesErr" );
		return 0;
	}
	if( !( numVertexs = InitVertexs( dirname, NULL ) ) ) {
		MessageBox( "Test055::LoadBSP(): Init Vertexs Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitVertexsErr" );
		return 0;
	}
	gVertexs = new XMSarray<vertex_t>( numVertexs );
	if( !gVertexs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Vertexs Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gVertexs"  );
		return 0;
	}
	if( !InitVertexs( dirname, gVertexs ) ) {
		MessageBox( "Test055::LoadBSP(): Init Vertexs Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitGVertexsErr" );
		return 0;
	}
	pClassIds = new XMSarray<ClassId>( MAX_CLASSNAME_NUM );

	if( !pClassIds->valid() )
	{
		EndVentana( &message );
		MessageBox( "Test055::LoadBSP(): Alloc ClassIds Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr pClassIds"  );
		return 0;
	}
	istrcpy( classfile, mypath );
	istrcat( classfile, CLASSNAMES_DAT );
	numClassIds = InitClassIds( classfile, pClassIds, &numClassIds );
	if( !numClassIds )
	{
		EndVentana( &message );
		MessageBox( "Test055::LoadBSP(): Init ClassNames Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitClassNamesErr pClassIds"  );
		return 0;
	}
	if( !bsp->InitGEntities( NULL, &numGEntities, pClassIds, numClassIds ) ) {
		MessageBox( "Test055::LoadBSP(): Init Entities Error" );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitGEntitiesErr %ld", numGEntities );
		return 0;
	}
	gGEntities = new XMSarray<GEntiti>( MAX_GENTITIES_NUM );
	if( !gGEntities->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Entities Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gGEntities"  );
		return 0;
	}
	if( !bsp->InitGEntities( gGEntities,&numGEntities, pClassIds, numClassIds ) ) {
		MessageBox( "Test055::LoadBSP(): Init Entities Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): InitGEntitiesErr" );
		return 0;
	}
	numGEntiSelecs = 0;
	gGEntiSelecs = new XMSarray<long>( MAX_SELECTS_NUM );
	if( !gGEntiSelecs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Selec Entities Queue Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gGEntiSelecs"  );
		return 0;
	}
	numGEntiTags = 0;
	gGEntiTags = new XMSarray<long>( MAX_TAGS_NUM );
	if( !gGEntiTags->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Tag Entities Array Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gGEntiTags"  );
		return 0;
	}
	numLeafSelecs = 0;
	gLeafSelecs = new XMSarray<long>( MAX_LEAFSELECS_NUM );
	if( !gLeafSelecs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Selec Leafs Queue Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gLeafSelecs"  );
		return 0;
	}
	numGLineSelecs = 0;
	gGLineSelecs = new XMSarray<GLine>( MAX_GLINESELECS_NUM );
	if( !gGLineSelecs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Selec Lines Queue Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gGLineSelecs"  );
		return 0;
	}
	numSurfSelecs = 0;
	gSurfSelecs = new XMSarray<long>( MAX_SURFSELECS_NUM );
	if( !gSurfSelecs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Selec Surfaces Queue Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gSurfSelecs"  );
		return 0;
	}
	numAreaSelecs = 0;
	gAreaSelecs = new XMSarray<dleaf_t>( MAX_AREASELECS_NUM );
	if( !gAreaSelecs->valid() )
	{
		MessageBox( "Test055::LoadBSP(): Alloc Selec Area Queue Error"  );
		TraceLog( TEST_LOG, "Test055::LoadBSP(): validErr gAreaSelecs"  );
		return 0;
	}
	sizeMipTexs = (long)sizeof( miptex_t ) * numMipTexs;
	sizeNodes = (long)sizeof( node_t ) * numNodes;
	sizeHulls = (long)sizeof( dhull_t ) * numHulls;
	sizeLeafs = (long)sizeof( dleaf_t ) * numLeafs;
	sizeSurfaces = (long)sizeof( surface_t ) * numSurfaces;
	sizeEdges = (long)sizeof( edge_t ) * numEdges;
	sizeVertexs = (long)sizeof( vertex_t ) * numVertexs;
	sizeGEntities = (long)sizeof( GEntiti ) * numGEntities;
	sizeClassIds = (long)sizeof( ClassId ) * numClassIds;
	sizeGEntiSelecs = (long)( sizeof( long ) * MAX_SELECTS_NUM );
	sizeGEntiTags = (long)( sizeof( long ) * MAX_TAGS_NUM );
	sizeLeafSelecs = (long)( sizeof( long ) * MAX_SELECTS_NUM );
	sizeGLineSelecs = (long)( sizeof( GLine ) * MAX_GLINESELECS_NUM );
	sizeSurfSelecs = (long)( sizeof( long ) * MAX_SURFSELECS_NUM );
	sizeAreaSelecs = (long)( sizeof( dleaf_t ) * MAX_AREASELECS_NUM );

	TraceLog( TEST_LOG, "numMipTexs %ld: size %ld: total size %ld", numMipTexs, (long)sizeof( miptex_t ), sizeMipTexs );
	TraceLog( TEST_LOG, "numNodes %ld: size %ld: total size %ld", numNodes, (long)sizeof( node_t ), sizeNodes );
	TraceLog( TEST_LOG, "numHulls %ld: size %ld: total size %ld", numHulls, (long)sizeof( dhull_t ), sizeHulls );
	TraceLog( TEST_LOG, "numLeafs %ld: size %ld: total size %ld", numLeafs, (long)sizeof( dleaf_t ), sizeLeafs );
	TraceLog( TEST_LOG, "numSurfaces %ld: size %ld: total size %ld", numSurfaces, (long)sizeof( surface_t ), sizeSurfaces );
	TraceLog( TEST_LOG, "numEdges %ld: size %ld: total size %ld", numEdges, (long)sizeof( edge_t ), sizeEdges );
	TraceLog( TEST_LOG, "numVertexs %ld: size %ld: total size %ld", numVertexs, (long)sizeof( vertex_t ), sizeVertexs );
	TraceLog( TEST_LOG, "numGEntities %ld: size %ld: total size %ld", numGEntities, (long)sizeof( GEntiti ), sizeGEntities );
	TraceLog( TEST_LOG, "numClassIds %ld: size %ld: total size %ld", numClassIds, (long)sizeof( ClassId ), sizeClassIds );
	TraceLog( TEST_LOG, "numGEntiSelecs %ld: size %ld: total size %ld", (long)MAX_SELECTS_NUM, (long)sizeof( long ), sizeGEntiSelecs );
	TraceLog( TEST_LOG, "numGEntiTags %ld: size %ld: total size %ld", (long)MAX_TAGS_NUM, (long)sizeof( long ), sizeGEntiTags );
	TraceLog( TEST_LOG, "numLeafSelecs %ld: size %ld: total size %ld", (long)MAX_SELECTS_NUM, (long)sizeof( long ), sizeLeafSelecs );
	TraceLog( TEST_LOG, "numGLineSelecs %ld: size %ld: total size %ld", (long)MAX_GLINESELECS_NUM, (long)sizeof( GLine ), sizeGLineSelecs );
	TraceLog( TEST_LOG, "numSurfSelecs %ld: size %ld: total size %ld", (long)MAX_SURFSELECS_NUM, (long)sizeof( long ), sizeSurfSelecs );
	TraceLog( TEST_LOG, "numAreaSelecs %ld: size %ld: total size %ld", (long)MAX_AREASELECS_NUM, (long)sizeof( dleaf_t ), sizeAreaSelecs );

	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::InitSurface( void )
 *
 ******************************************************************************/
int Test055::InitSurface( void )
{
	GEntiti         gE;
	int             gx, gy, gz;


	// Iniciamos la ventana de procesando una orden.
	message = InitVentana( "Message", 10, 10, 60, 8, GVenBuf::Blanco, GVenBuf::Azul, &message );
	working = new Working( message );
	pantalla.Muestra( "Message" );
	pantalla.Refresca();
	working->AddString( "Processing Points" );

	gSPs = new XMSarray<GLine>( MAX_GLINES_NUM );

	if( !gSPs->valid() )
	{
		EndVentana( &message );
		MessageBox( "Test055::InitSurface(): Alloc Lines Error" );
		TraceLog( TEST_LOG, "Test055::InitSurface(): validErr gSPs"  );
		return 0;
	}
	numSPs = InitGLines( gLeafs, numLeafs, gSurfaces, gEdges, gVertexs, gSPs, &numSPs );
	if( !numSPs )
	{
		EndVentana( &message );
		MessageBox( "Test055::InitSurface(): Init Points Error" );
		TraceLog( TEST_LOG, "Test055::InitSurface(): InitGLinesErr gSPs"  );
		return 0;
	}
	sizeSPs = (long)sizeof( GLine ) * numSPs;
	TraceLog( TEST_LOG, "numSPs %ld: size %ld: total size %ld", numSPs, (long)sizeof( GLine ), sizeSPs );
	init_stat = init_stat | 0x00000001;

	// Eliminamos la ventana de procesando una orden.
	pantalla.Elimina( "Message" );
	EndVentana( &message );
	delete working;

	return 1;
}


/*******************************************************************************
 *
 *      DESTRUCTOR:
 *              Test055::~Test055()
 *
 ******************************************************************************/
Test055::~Test055()
{
	CloseFile();

	// Eliminamos el buffer para manipular en memoria el fichero BSP.
	delete pBSP;

	// Eliminamos el buffer para manipular en memoria entities.
	delete pX;

	// Elimina el menu.
	EndMenu();

	// Elimina las ventanas.
	EliminarVentanas();

	// Refrescamos la pantalla.
	Refresca();

	// Salimos del modo grafico.
	closegraph();

	// Ponemos el modo normal.
	Modo( 0x03 );
	
	// cambiamos al directorio inicial.
	chdir( mypath );

}


/*******************************************************************************
 *
 *      METODO:
 *              void Test055::Ejecuta( void )
 *
 ******************************************************************************/
void Test055::Ejecuta( void )
{
	int                     salida = 0;
	GEvento                 control;
	Evento                  suceso;



	while( !salida )
	{
		do { control >> suceso; } while( suceso.Quien == Evento::Vacio );

		salida = ProcesaMensaje( suceso );
	}
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::InitMenu( void )
 *
 ******************************************************************************/
int Test055::InitMenu( void )
{

	// Se crea el men

	zoom = new GNodo(       "Zoom",         /* nodo interior del menu ... */
				GOpcion( "*+In", ID_OPT_ZOO_INX ) +
				GOpcion( "*-Out", ID_OPT_ZOO_OUT ) );


	plane = new GNodo(      "Plane",        /* nodo interior del menu ... */
				GOpcion( "*X=cte", ID_OPT_PLA_XXX ) +
				GOpcion( "*Y=cte", ID_OPT_PLA_YXX ) +
				GOpcion( "*Z=cte", ID_OPT_PLA_ZXX ) ); 

	boundbox = new GNodo(   "BoundBoxes",        /* nodo interior del menu ... */
				GOpcion( "*Nodes", ID_DRA_BOU_NOD ) +
				GOpcion( "*Leaves", ID_DRA_BOU_DLE ) +
				GOpcion( "H*ulls", ID_DRA_BOU_DHU ) );

	items = new GNodo(      "Items",
				GOpcion( "Li*ghts", ID_ENT_ITE_LIG ) +
				GOpcion( "*Ambient", ID_ENT_ITE_AMB ) +
				GOpcion( "*Weapons", ID_ENT_ITE_WEA ) +
				GOpcion( "*Monsters", ID_ENT_ITE_MON ) +
				GOpcion( "It*ems", ID_ENT_ITE_ITE ) +
				GOpcion( "*Infos", ID_ENT_ITE_INF ) +
				GOpcion( "*Paths", ID_ENT_ITE_PAT ) );

	models = new GNodo(     "Models",
				GOpcion( "Fun*cions", ID_ENT_MOD_FUN ) +
				GOpcion( "T*riggers", ID_ENT_MOD_TRI ) );


	menu = new GMenu(       &pantalla,                      /* menu principal ... */
				GNodo(  "*File",
					GOpcion( "*Open", ID_FIL_OPE_XXX ) +
					GOpcion( "*Save", ID_FIL_SAV_XXX ) +
					GOpcion( "*Quit", ID_FIL_QUI_XXX ) ) +
				GNodo(  "*Edit",
					GOpcion( "*Items", ID_EDI_ITE_XXX ) +
					GOpcion( "*Areas", ID_EDI_ARE_XXX ) +
					GOpcion( "*Textures", ID_EDI_TEX_XXX ) ) +
				GNodo(  "*Options",
					GOpcion( "*2D/3D", ID_OPT_3DX_XXX ) +
					GOpcion( "*Zoom", *zoom ) +
					GOpcion( "*Plane", *plane ) ) +
				GNodo(  "*Draw",
					GOpcion( "*BoundBoxes", *boundbox ) +
					GOpcion( "*Surfaces", ID_DRA_SUR_XXX ) +
					GOpcion( "*Vertices", ID_DRA_VER_XXX ) ) +
				GNodo(  "E*ntities",
					GOpcion( "*Items", *items ) +
					GOpcion( "*Models", *models ) ) +
				GNodo( "*Help",
					GOpcion( "*About", ID_HEL_ABO_XXX ) +
					GOpcion( "*Info", ID_HEL_INF_XXX ) ),
				GVenBuf::Negro, GVenBuf::GrisClaro,
				GVenBuf::Negro, GVenBuf::Verde,
				GVenBuf::Rojo, GVenBuf::GrisClaro,
				GVenBuf::Rojo, GVenBuf::Verde,
				this );
	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::EndMenu( void )
 *
 ******************************************************************************/
int Test055::EndMenu( void )
{
	delete menu;
	delete zoom;
	delete boundbox;
	delete plane;
	delete items;
	delete models;

	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              void Test055::EliminarVentanas( void )
 *
 ******************************************************************************/
void Test055::EliminarVentanas( void )
{
	if( edit.ven != NULL )
	{
		EndEditVentana();
	}
	if( selec.ven != NULL )
	{
		EndSelecVentana();
	}
	if( client.ven != NULL )
	{
		EndClientVentana();
	}
}


/*******************************************************************************
 *
 *      METODO:
 *              void Test055::ActivaVentana( Test055::TipoVentana v )
 *
 ******************************************************************************/
void Test055::ActivaVentana( Test055::TipoVentana v )
{
	switch( v )
	{
		case Test055::_Client:
			if( activa != Test055::_Client )
			{
				menu->DesactivaBarraMenu();
				if( edit.ven != NULL )
				{
					pantalla( "Edit" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( selec.ven != NULL )
				{
					pantalla( "Selec" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( client.ven != NULL )
				{
					pantalla( "Client" )->rdbuf()->BordeVentana( GVenBuf::Doble );
				}
				Refresca();
				Actualiza();
				activa = Test055::_Client;
			}
		break;

		case Test055::_Edit:
			if( activa != Test055::_Edit )
			{
				menu->DesactivaBarraMenu();
				if( client.ven != NULL )
				{
					pantalla( "Client" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( selec.ven != NULL )
				{
					pantalla( "Selec" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( edit.ven != NULL )
				{
					pantalla( "Edit" )->rdbuf()->BordeVentana( GVenBuf::Doble );
				}
				Refresca();
				Actualiza();
				activa = Test055::_Edit;
			}
		break;

		case Test055::_Selec:
			if( activa != Test055::_Selec )
			{
				menu->DesactivaBarraMenu();
				if( edit.ven != NULL )
				{
					pantalla( "Edit" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( client.ven != NULL )
				{
					pantalla( "Client" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( selec.ven != NULL )
				{
					pantalla( "Selec" )->rdbuf()->BordeVentana( GVenBuf::Doble );
				}
				Refresca();
				Actualiza();
				activa = Test055::_Selec;
			}
		break;
		case Test055::_Menu:
		default:
			if( activa != Test055::_Menu )
			{
				if( client.ven != NULL )
				{
					pantalla( "Client" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( edit.ven != NULL )
				{
					pantalla( "Edit" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				if( selec.ven != NULL )
				{
					pantalla( "Selec" )->rdbuf()->BordeVentana( GVenBuf::Simple );
				}
				menu->ActivaBarraMenu();
				Refresca();
				Actualiza();
				activa = Test055::_Menu;
			}
		break;
	}

}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::ProcesaMensaje( Evento& suceso )
 *
 ******************************************************************************/
int Test055::ProcesaMensaje( Evento& suceso )
{
	int                     cod = 0;        // codigo de retorno.
	long                    gI = 0;         // indice de la gentiti seleccionada .
	GEntiti                 gE;             // gentiti seleccionada.
	GEvento                 control;
	GRaton                  raton;
	dleaf_t                 leaf;
	shortbox_t              sbox;
	dhull_t                 hull;



	if( suceso.Quien == Evento::Teclado )
	{
		/* comprobar si la tecla  corresponde a alguna del la barra del menu. */
		if( menu->EstaEnBarraMenu( suceso.Tecla ) )
		{
			control.Inserta( suceso.Tecla );
			ActivaVentana( Test055::_Menu );
			cod = menu->Ejecuta();
			ActivaVentana( Test055::_Client );
		}
		else
		{
			switch( suceso.Tecla )
			{
				case GTeclado::F2:
					cod = Procesa( ID_FIL_SAV_XXX );
				break;

				case '+':
					cod = Procesa( ID_OPT_ZOO_INX );
				break;

				case '-':
					cod = Procesa( ID_OPT_ZOO_OUT );
				break;

				case 'x':
				case 'X':
					cod = Procesa( ID_OPT_PLA_XXX );
				break;

				case 'y':
				case 'Y':
					cod = Procesa( ID_OPT_PLA_YXX );
				break;

				case 'z':
				case 'Z':
					cod = Procesa( ID_OPT_PLA_ZXX );
				break;

				case 'n':
				case 'N':
					cod = Procesa( ID_DRA_BOU_NOD );
				break;

				case 'l':
				case 'L':
					cod = Procesa( ID_DRA_BOU_DLE );
				break;

				case 'u':
				case 'U':
					cod = Procesa( ID_DRA_BOU_DHU );
				break;

				case 's':
				case 'S':
					cod = Procesa( ID_DRA_SUR_XXX );
				break;

				case 'v':
				case 'V':
					cod = Procesa( ID_DRA_VER_XXX );
				break;

				case 'g':
				case 'G':
					cod = Procesa( ID_ENT_ITE_LIG );
				break;

				case 'a':
				case 'A':
					cod = Procesa( ID_ENT_ITE_AMB );
				break;

				case 'w':
				case 'W':
					cod = Procesa( ID_ENT_ITE_WEA );
				break;

				case 'm':
				case 'M':
					cod = Procesa( ID_ENT_ITE_MON );
				break;

				case 'e':
				case 'E':
					cod = Procesa( ID_ENT_ITE_ITE );
				break;

				case 'i':
				case 'I':
					cod = Procesa( ID_ENT_ITE_INF );
				break;

				case 'p':
				case 'P':
					cod = Procesa( ID_ENT_ITE_PAT );
				break;

				case 'c':
				case 'C':
					cod = Procesa( ID_ENT_MOD_FUN );
				break;

				case 'r':
				case 'R':
					cod = Procesa( ID_ENT_MOD_TRI );
				break;

				case GTeclado::DERECHA:
					cod = Procesa( ID_OPT_MOV_DER );
				break;

				case GTeclado::ARRIBA:
					cod = Procesa( ID_OPT_MOV_ARR );
				break;

				case GTeclado::IZQUIERDA:
					cod = Procesa( ID_OPT_MOV_IZQ );
				break;

				case GTeclado::ABAJO:
					cod = Procesa( ID_OPT_MOV_ABA );
				break;

				case 0x18d:
					cod = Procesa( ID_OPT_MOV_CAR );
				break;

				case 0x174:
					cod = Procesa( ID_OPT_MOV_CIZ );
				break;

				case 0x191:
					cod = Procesa( ID_OPT_MOV_CAB );
				break;

				case 0x173:
					cod = Procesa( ID_OPT_MOV_CDE );
				break;

				case 0x198:
					cod = Procesa( ID_OPT_MOV_DAR );
				break;

				case 0x19d:
					cod = Procesa( ID_OPT_MOV_DIZ );
				break;

				case 0x1a0:
					cod = Procesa( ID_OPT_MOV_DAB );
				break;

				case 0x19b:
					cod = Procesa( ID_OPT_MOV_DDE );
				break;

				default:
					TraceLog( TEST_LOG, "%x", suceso.Tecla );
				break;
			}
		}
	}
	else
	{
		GVentana *cual = pantalla( pantalla.Ventana(    suceso.Posicion.X / 8+1,
								suceso.Posicion.Y / 8+1 ) );

		if( cual == pantalla( "Client" ) )
		{
			ActivaVentana( Test055::_Client );

			if( suceso.Boton == Evento::ClickI )
			{
				switch( client_selec )
				{
				case 0x00000001:
				{
					if( grafico == _2D )
					{
						numGEntiSelecs = 0;
	
						if( client.gra->GetGEntiti( plano, suceso.Posicion.X, suceso.Posicion.Y, client_stat & 0x00FFFF00, &gI, gGEntities, numGEntities, gHulls ) )
						{
							numGEntiSelecs = 1;
							gGEntiSelecs->at( 0 ) = gI;
							gE = gGEntities->at( gI );

							if( gE.c & 0x02000000 )
							{
								numGEntiTags = 0;
								if( GetGEntitiTargetName( gE.target, gGEntities, numGEntities, gGEntiTags, &numGEntiTags ) )
								{
									cod = Procesa( ID_XXX_ENT_TAG );
								}
								else
								{
									cod = Procesa( ID_XXX_ENT_SEL );
								}
							}
							else
							{
								cod = Procesa( ID_XXX_ENT_SEL );
							}
						}
						else
						{
							numGEntiSelecs = 0;
							numGEntiTags = 0;
							cod = Procesa( ID_XXX_ENT_UNS );
						}
					}
				}
				break;

				case 0x00000002:
				{
					if( grafico == _2D )
					{
						hull = (*gHulls)[0];

						switch( plano )
						{
							case X0:
								if( edit.ven != NULL )
								{
									sbox.min.x = atoi( (*edit.ent)( "Plantilla", "Dos" ) );
									sbox.max.x = atoi( (*edit.ent)( "Plantilla", "Cinco" ) );
								}
								else
								{
									sbox.min.x = hull.bound.min.x;
									sbox.max.x = hull.bound.max.x;
								}
							break;

							case Y0:
								if( edit.ven != NULL )
								{
									sbox.min.y = atoi( (*edit.ent)( "Plantilla", "Tres" ) );
									sbox.max.y = atoi( (*edit.ent)( "Plantilla", "Seis" ) );
								}
								else
								{
									sbox.min.y = hull.bound.min.y;
									sbox.max.y = hull.bound.max.y;
								}
							break;

							case Z0:
							default:
								if( edit.ven != NULL )
								{
									sbox.min.z = atoi( (*edit.ent)( "Plantilla", "Cuatro" ) );
									sbox.max.z = atoi( (*edit.ent)( "Plantilla", "Siete" ) );
								}
								else
								{
									sbox.min.z = hull.bound.min.z;
									sbox.max.z = hull.bound.max.z;
								}
							break;
						}
						// TraceLog( TEST_LOG, "area=%d,%d,%d %d,%d,%d", sbox.min.x, sbox.min.y, sbox.min.z, sbox.max.x, sbox.max.y, sbox.max.z );

						client.gra->SetArea( plano, &sbox );
						pantalla.Refresca();
						numAreaSelecs = 1;
						leaf.bound = sbox;
						(*gAreaSelecs)[0] = leaf;
						numLeafSelecs = 0;
						// TraceLog( TEST_LOG, "area=%d,%d,%d %d,%d,%d", sbox.min.x, sbox.min.y, sbox.min.z, sbox.max.x, sbox.max.y, sbox.max.z );

						if( InitLeafs( sbox, gLeafs, numLeafs, gLeafSelecs, &numLeafSelecs ) )
						{
							numGLineSelecs = 0;

							if( InitGLines( sbox, gSPs, numSPs, gGLineSelecs, &numGLineSelecs  ) )
							{
							}
							cod = Procesa( ID_XXX_ARE_SEL );

						}
						else {
							cod = Procesa( ID_XXX_ARE_UNS );
						}
					}

				}
				break;
				} // switch
			}
			else if( suceso.Boton == Evento::ClickD )
			{
				if( client_selec & 0x00000001 )
				{
					if( grafico == _2D )
					{
						cod = Procesa( ID_XXX_EDT_ENT );
					}
				}
				else if( client_selec & 0x00000002 )
				{
					cod = Procesa( ID_XXX_EDT_ARE );
					Actualiza();
				}
			}
		}
		else if( cual == pantalla( "Edit" ) )
		{
			if( suceso.Boton == Evento::ClickI )
			{
				ActivaVentana( Test055::_Edit );
				cod = edit.ent->Ejecuta2();
				control.Inserta( 1, 0, raton.PosicionHorizontal(), raton.PosicionVertical() );
			}
			else if( suceso.Boton == Evento::ClickD )
			{
				ActivaVentana( Test055::_Edit );
				cod = edit.ent->Ejecuta2();
				control.Inserta( 0, 1, raton.PosicionHorizontal(), raton.PosicionVertical() );
			}
		}
		else if( cual == pantalla( "Selec" ) )
		{
			if( suceso.Boton == Evento::ClickI )
			{
				ActivaVentana( Test055::_Selec );
				cod = selec.lis->Ejecuta();
				control.Inserta( 1, 0, raton.PosicionHorizontal(), raton.PosicionVertical() );
			}
			else if( suceso.Boton == Evento::ClickD )
			{
				ActivaVentana( Test055::_Selec );
				cod = selec.lis->Ejecuta();
				control.Inserta( 0, 1, raton.PosicionHorizontal(), raton.PosicionVertical() );
			}
		}
		else
		{
			if( suceso.Boton == Evento::ClickI )
			{
				control.Inserta( 1, 0, raton.PosicionHorizontal(), raton.PosicionVertical() );
				ActivaVentana( Test055::_Menu );
				cod = menu->Ejecuta();
				control.Inserta( 1, 0, raton.PosicionHorizontal(), raton.PosicionVertical() );
			}
			else if( suceso.Boton == Evento::ClickD )
			{
				control.Inserta( 0, 1, raton.PosicionHorizontal(), raton.PosicionVertical() );
				ActivaVentana( Test055::_Menu );
				cod = menu->Ejecuta();
				control.Inserta( 1, 0, raton.PosicionHorizontal(), raton.PosicionVertical() );
			}
		}
	}
	return cod;
}


/*******************************************************************************
 *
 *      METODO:
 *              GVentana* Test055::InitVentana( char* name,
 *                                              int x,
 *                                              int y,
 *                                              int ancho,
 *                                              int alto,
 *                                              GVenBuf::Color T,
 *                                              GVenBuf::Color F,
 *                                              GVentana** v )
 *
 ******************************************************************************/
GVentana* Test055::InitVentana( char* name,
				int x,
				int y,
				int ancho,
				int alto,
				GVenBuf::Color T,
				GVenBuf::Color F,
				GVentana** v )
{
	if( *v == NULL )
	{
		*v = new GVentana(      name,
					ancho, alto,
					GVenBuf::Doble,
					T,
					F );

		pantalla.Anade( **v, x, y );

	}
	return *v;

}


/*******************************************************************************
 *
 *      METODO:
 *              void Test055::EndVentana( GVentana** v )
 *
 ******************************************************************************/
void Test055::EndVentana( GVentana** v )
{
	if( *v != NULL )
	{
		// Oculta la ventana.
		pantalla.Elimina( *v );

		// Eliminamos la ventana temporal.
		delete *v;

		// Refresca la pantalla.
		pantalla.Refresca();
	}
	*v = NULL;

}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::GetFile( char *filaname )
 *
 ******************************************************************************/
int Test055::GetFile( char* filename )
{
	if( ( gfile = new GFile( FILE_LEFT, FILE_TOP, FILE_WIDTH, FILE_HEIGHT, &pantalla, filename ) ) == NULL )
	{
		TraceLog( TEST_LOG, "Test055::GetFile(): newErr" );
		return 0;
	}
	gfile->Ejecuta(); 

	delete gfile;

	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::OpenFile( char *filaname )
 *
 ******************************************************************************/
int Test055::OpenFile( char* filename )
{
	char*           ptr;
	char            dirname[257];
	GEntiti         gE;



	if( ( bsp = new Bsp( filename ) ) == NULL ) {
		MessageBox( "Test055::OpenFile(): Alloc Memory Error" );
		TraceLog( TEST_LOG, "Test055::OpenFile(): newErr" );
		return 0;
	}
	// Obtenemos el directorio donde descomprimir los datos.
	strcpy( dirname, bsp->filebsp );
	for( ptr = dirname; *ptr != '\0'; ptr++ );
	for( ; *ptr != '.'; ptr-- );
	strcpy( ptr, ".DIR" );
	mkdir( dirname );

	// Descomprimimos los datos.
	if( !bsp->UnPackBsp() ) {
		MessageBox( "Test055::OpenFile(): UnPack BSP File Error" );
		TraceLog( TEST_LOG, "Test055::OpenFile(): UnPackBspErr" );
		return 0;
	}
/*
	// Obtenemos la informacion de la posicion inicial.
	if( bsp->Version() != VERSION_NUM ) {
		MessageBox( "Test055::OpenFile(): Unknow Version Error" );
		TraceLog( TEST_LOG, "Test055::OpenFile(): GetGEntitiErr" );
		return 0;
	}
*/
	if( ( AllocFile( pX, &sizeX, bsp->file[0] ) ) == NULL ) {
		MessageBox( "Test055::OpenFile(): Alloc BSP File Error" );
		TraceLog( TEST_LOG, "Test055::OpenFile(): AllocFileErr %s",  bsp->file[0] );
		return 0;
	}
	if( !LoadBSP( bsp->pathbsp ) ) {
		MessageBox( "Test055::OpenFile(): Load BSP Data Error" );
		TraceLog( TEST_LOG, "Test055::OpenFile(): LoadBSPErr Unable to load %s", bsp->filebsp );
		return 0;
	}
	if( !InitSurface() ) {
		MessageBox( "Test055::OpenFile(): Init Surfaces Error" );
		TraceLog( TEST_LOG, "Test055::OpenFile(): InitSurfacesErr"  );
		return 0;
	}
	if( bsp->UnTexBsp( gMipTexs, numMipTexs, mypalette, 0 ) != numMipTexs ) {
		MessageBox( "Test055::OpenFile(): UnPacking Textures Error" );
		TraceLog( TEST_LOG, "Test055::OpenFile(): UnTexBspErr" );
		return 0;
	}
	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::CloseFile( void )
 *
 ******************************************************************************/
int Test055::CloseFile( void )
{
	char            string[257];
	int             response = 0x0000;



	strcpy( string, "Do you want save changes to " );
	strcat( string, bsp->filebsp );
	strcat( string, " ?" );
	response = MessageBox( string, 0x0003 );        

	if( response == 0x0001 ) {
		// Salvamos los cambios 
		if( !SaveFile( bsp->filebsp ) ) {
			TraceLog( TEST_LOG, "Test055::CloseFile(): SaveFileErr %s", bsp->filebsp );
			return 0;
		}
	}
	// Eliminamos los datos.
	delete gNodes;
	delete gHulls;
	delete gLeafs;
	delete gSurfaces;
	delete gEdges;
	delete gVertexs;
	delete gSPs;
	delete gGEntities;
	delete pClassIds;
	delete pClassNames;
	delete gGEntiSelecs;
	delete gGEntiTags;
	delete gLeafSelecs;
	delete gGLineSelecs;
	delete gSurfSelecs;
	delete gAreaSelecs;

	// Eliminamos la clase para manipular ficheros BSP.
	delete bsp;

	// Ponemos el estado de inicializacion a cero.
	init_stat = 0;

	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::SaveFile( char* filename )
 *
 ******************************************************************************/
int Test055::SaveFile( char* filename )
{
	int             error = 0;      // flag de error si no se puede empaquetar el fichero BSP.


	// Iniciamos la ventana de procesando una orden.
	message = InitVentana( "Message", 10, 10, 60, 8, GVenBuf::Blanco, GVenBuf::Azul, &message );
	working = new Working( message );
	pantalla.Muestra( "Message" );
	pantalla.Refresca();
	working->AddString( "Saving BSP Entries" );

	// Adaptamos las entradas en el fichero BSP.
	if( !bsp->UpdateEntry( 0, sizeX ) ) {
		TraceLog( TEST_LOG, "Test055::Savefile(): UpdateEntryErr" );
		error = 1;
	}
	// Escribimos en el fichero la entrada en memoria.
	if( !FreeFile( pX, sizeX, bsp->file[0] ) ) {
		TraceLog( TEST_LOG, "Test055::CloseFile(): FreeFile %s",  bsp->file[0] );
		error = 1;
	}
	// Enpaquetamos el fichero BSP.
	if( !bsp->PackBsp( pBSP, pX, filename ) ) {
		TraceLog( TEST_LOG, "Test055::SaveFile(): PackBspErr %s", filename );
		error = 1;
	}
	working->AddString( "Saving BSP Done" );

	// Eliminamos la ventana de procesando una orden.
	pantalla.Elimina( "Message" );
	EndVentana( &message );
	delete working;  

	// Si se produjo algun error.
	if( error ) {
		MessageBox( "Test055::SaveFile(): Saving File Error" );
		return 0;
	}
	return 1;
}


/*******************************************************************************
 *
 *      METODO:
 *              int Test055::Selected( unsigned int id )
 *
 ******************************************************************************/
int Test055::Selected( unsigned int id )
{
	char                    buf[MAX_CLASSNAME_LEN];
	long                    s;
	dleaf_t                 leaf;
	int                     cod = 0;


	switch( client_selec )
	{
		case 0x00000004:
			
			selec.lis->GetDato( &editMipTexName[0] );

			cod = Procesa( ID_XXX_EDT_TEX );

		break;

		case 0x00000002:

			selec.lis->GetDato( &buf[0] );

			s = atol( buf );

			numLeafSelecs = 1;

			(*gLeafSelecs)[0] = s;

			leaf = (*gLeafs)[s];

			numGLineSelecs = 0;

			if( InitGLines( leaf.bound, gSPs, numSPs, gGLineSelecs, &numGLineSelecs  ) )
			{
			}
			cod = Procesa( ID_XXX_EDT_GLI );
		break;

		case 0x00000001:
			
			selec.lis->GetDato( &editClassName[0] );

			cod = Procesa( ID_XXX_EDT_CNA );

		break;

		default:
			cod = 0;
		break;
	}
	return cod;
}


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

