/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              TEST055.HPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Tue Jun 19 23:40:45 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
#ifndef _TEST055_HPP_
#define _TEST055_HPP_


/*******************************************************************************
 *
 *      INCLUDES:
 *
 ******************************************************************************/
#include "GMenu.Hpp"
#include "GVentaGr.Hpp"
#include "GEvento.Hpp"
#include "GEntrada.Hpp"


#include "grafico.hpp"
#include "grafi3d.hpp"
#include "glista.hpp"
#include "gfile.hpp"


/*******************************************************************************
 *
 *      DEFINES:
 *
 ******************************************************************************/
#define TEST_LOG                        ".\\TEST055"
#define ACT_COLOR                       GVenBuf::GrisClaro
#define DESACT_COLOR                    GVenBuf::Azul
#define SELECT_COLOR                    GVenBuf::Blanco
#define TAG_COLOR                       GVenBuf::AzulClaro
#define GDHULL_COLOR                    GVenBuf::Rojo
#define LEAF_COLOR                      GVenBuf::Azul
#define GNODE_COLOR                     GVenBuf::Amarillo
#define GSURFACE_COLOR                  GVenBuf::Verde
#define GVERTEX_COLOR                   GVenBuf::GrisClaro
#define GENTITI_COLOR                   GVenBuf::Rojo
#define FONDO_COLOR                     GVenBuf::Negro
#define LIGHT_COLOR                     GVenBuf::MalvaClaro
#define AMBIENT_COLOR                   GVenBuf::GrisClaro
#define WEAPON_COLOR                    GVenBuf::Malva
#define MONSTER_COLOR                   GVenBuf::Marron
#define ITEM_COLOR                      GVenBuf::AzulClaro
#define INFO_COLOR                      GVenBuf::CelesteClaro
#define PATH_COLOR                      GVenBuf::Amarillo
#define FUNC_COLOR                      GVenBuf::Celeste
#define TRIGGER_COLOR                   GVenBuf::RojoClaro

#define CLIENT_LEFT                     1
#define CLIENT_TOP                      4
#define CLIENT_WIDTH                    78
#define CLIENT_HEIGHT                   38
#define ITE_EDIT_LEFT                   1
#define ITE_EDIT_TOP                    4
#define ITE_EDIT_WIDTH                  18
#define ITE_EDIT_HEIGHT                 8
#define ITE_SELEC_LEFT                  1
#define ITE_SELEC_TOP                   14
#define ITE_SELEC_WIDTH                 18
#define ITE_SELEC_HEIGHT                28
#define ARE_EDIT_LEFT                   61
#define ARE_EDIT_TOP                    4
#define ARE_EDIT_WIDTH                  18
#define ARE_EDIT_HEIGHT                 8
#define ARE_SELEC_LEFT                  61
#define ARE_SELEC_TOP                   14
#define ARE_SELEC_WIDTH                 18
#define ARE_SELEC_HEIGHT                28
#define TEX_EDIT_LEFT                   61
#define TEX_EDIT_TOP                    4
#define TEX_EDIT_WIDTH                  18
#define TEX_EDIT_HEIGHT                 8
#define TEX_SELEC_LEFT                  61
#define TEX_SELEC_TOP                   14
#define TEX_SELEC_WIDTH                 18
#define TEX_SELEC_HEIGHT                28
#define MESSAGE_LEFT                    10
#define MESSAGE_TOP                     10
#define MESSAGE_WIDTH                   60
#define MESSAGE_HEIGHT                  13
#define FILE_LEFT                       20
#define FILE_TOP                        10
#define FILE_WIDTH                      40
#define FILE_HEIGHT                     15




/*******************************************************************************
 *
 *      DEFINES:
 *
 ******************************************************************************/
#define STR_HEL_INF_XXX         "QGRAPH Version 1.5.0.\n\nPlease E-MAIL commentaries/informations/news about Quake or bugs/ideas/hints about this program.\n\nemail:jbergara@sarenet.es\nhttp://www.hughchristie.kent.sch.uk/qpage/qgraph.html"
#define STR_INI_INF_XXX         "QGRAPH Version 1.5.0.\n\nPlease E-MAIL commentaries/informations/news about Quake or bugs/ideas/hints about this program.\n\nemail:jbergara@sarenet.es\nhttp://www.hughchristie.kent.sch.uk/qpage/qgraph.html"
#define CLASSNAMES_DAT          "\\CNAMES.DAT"


/*******************************************************************************
 *
 *      PROTOTIPOS
 *
 ******************************************************************************/

/*******************************************************************************
 *
 *      STRUCT
 *
 ******************************************************************************/
struct GClient
{
	GVentana        *ven;
	Grafico         *gra;
	Grafi3D         *g3d;
};


/*******************************************************************************
 *
 *      STRUCT
 *
 ******************************************************************************/
struct GEdit
{
	GVentana        *ven;
	GEntrada        *ent;
	GPlantilla      *pla;
	SExclusiva      *exc;
	SMultiple      	*mul;
	GEntero         *ente[6];
	
};


/*******************************************************************************
 *
 *      STRUCT
 *
 ******************************************************************************/
struct GEditLeaf
{
	GVentana        *ven;
	GEntrada        *ent;
	GPlantilla      *pla;
	GCampo          *exc;
	
};


/*******************************************************************************
 *
 *      STRUCT
 *
 ******************************************************************************/
struct GSelec
{
	GVentana        *ven;
	GLista          *lis;
};


/*******************************************************************************
 *
 *      CLASS:
 *
 ******************************************************************************/
class Test055:  public RaizMenu,
		public SelectedHandler
{
    public:

	enum                    TipoVentana { _Menu, _Client, _Edit, _Selec };

	TipoVentana             activa;

	enum                    TipoGrafico { _2D, _3D };

	TipoGrafico             grafico;


    public:

				Test055();

				~Test055();

	void                    Ejecuta( void );

	int                     LoadBSP( char* filename );

	int                     InitSurface( void );

	void                    ActivaVentana( Test055::TipoVentana tipo );

	int                     MessageBox( char* aMessage, int aStyle = 0x0001 );

	int                     GetFile( char *filename );

	int                     OpenFile( char *filename );

	int                     SaveFile( char *filename );


    private:

	int                     Procesa( unsigned int id );

	int                     Selected( unsigned int id );

	int                     Escala( void );

	int                     Mover( int flag = 0 );

	int                     Actualiza( void );

	void                    Limpiar( void );

	void                    Refresca( void );

	int                     Edit( void );

	int                     GEntitiMessage( void );

	GESGrafico              pantalla;

	GMenu                   *menu;

	GVentana                *message;

	GEdit                   edit;

	GSelec                  selec;

	GClient                 client;

	GFile                   *gfile;

	GNodo                   *zoom, *plane, *boundbox, *items, *models;

	int                     ProcesaMensaje( Evento& evt );

	void                    EliminarVentanas( void );

	int                     InitMenu( void );

	int                     EndMenu( void );

	int                     InitClientVentana( int left, int top, int width, int height, TipoGrafico gra = _2D );

	int                     EndClientVentana( void );

	int                     InitEditVentana( );

	int                     ActualizaEditVentana( void );

	int                     EndEditVentana( void );

	int                     InitSelecVentana( );

	int                     ActualizaSelecVentana( void );

	int                     EndSelecVentana( void );

	GVentana*               InitVentana( char* name, int left, int top, int width, int height, GVenBuf::Color T, GVenBuf::Color F, GVentana** v );

	void                    EndVentana( GVentana** v );

	int                     CloseFile( void );

};


#endif


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

