/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      FICHERO:
 *              UNBSP.HPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      PROFILE INFORMATION:
 *
 *      OBJECT MODIFICATION DATE:
 *              Fri May 10 12:44:55 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
#ifndef _UNBSP_HPP_
#define _UNBSP_HPP_


/*******************************************************************************
 *
 *      INCLUDES
 *
 ******************************************************************************/
#include <stdio.h>


#include "doserror.h"
#include "xmsarray.h"
#include "qstruct.h"
#include "vstruct.h"


/*******************************************************************************
 *
 *      PROTOTIPOS:
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *      DEFINES:
 *
 ******************************************************************************/
#define VERSION_NUM                     0x0000001C   // # de version 
#define MAX_MIPTEXS_NUM                 512   	// maximo # de miptex_t totales. 
#define MAX_NODES_NUM                   65535   // maximo # de nodos totales. 
#define MAX_DHULLS_NUM                  65535   // maximo # de dhulls totales. 
#define MAX_LEAFS_NUM                   65535   // maximo # de dleafs totales. 
#define MAX_SURFACES_NUM                65535   // maximo # de superficies totales. 
#define MAX_EDGES_NUM                   65535   // maximo # de edges totales. 
#define MAX_VERTEXS_NUM                 65535   // maximo # de vertexs totales. 
#define MAX_SURFGLINES_NUM              513     // maximo # de edges en una superficie.
#define MAX_SURFEDGES_NUM               129     // maximo # de edges en una superficie.
#define MAX_LEAFSURFS_NUM               129     // maximo # de superficies en un leaf.
#define MAX_GENTITIES_NUM               1025    // maximo # de gentities totales. 
#define MAX_GLINES_NUM                  32767   // maximo # de gpoints totales. 
#define MAX_GLINESELECS_NUM             32767   // maximo # de glines seleccionados. 
#define MAX_LEAFSELECS_NUM              65535   // maximo # de dleaf_t seleccionados. 
#define MAX_SURFSELECS_NUM             	65535   // maximo # de surface_t seleccionados. 
#define MAX_AREASELECS_NUM             	1   	// maximo # de areas seleccionadas. 
#define MAX_TAGS_NUM                    33      // maximo # de targetnames para una gentiti seleccionada.
#define MAX_SELECTS_NUM                 1       // maximo # de selecciones. 
#define MAX_ENTRY_SIZE                  1048576 // maximo # de caracteres para los ficheros de entries. 
#define MAX_BSP_SIZE                    2097152 // maximo # de caracteres para el fichero bsp. 
#define MAX_ENTITI_LEN                  513     // maximo # de caracteres para una entiti.
#define MAX_SPECIFIC_LEN                257     // maximo # de caracteres para cada linea de la entiti.
#define MAX_MIPTEXNAME_LEN              16      // maximo # de caracteres para los nombres de las texturas.
#define MAX_CLASSNAME_LEN               33      // maximo # de caracteres para los classnames.
#define MAX_CLASSNAME_NUM               100     // maximo # de classnames.
#define MAX_CLASSNAME_SIZE              4096    // maximo # de caracteres para classnames.
#define MAX_CLASSWEAPON_NUM             6       // maximo # de classnames de weapons
#define MAX_CLASSMONSTER_NUM            9       // maximo # de classnames de monstruos 
#define MAX_CLASSITEM_NUM               15       // maximo # de classnames de items 
#define MAX_ENTRY_NUM                   15      // maximo # de entradas en el dheader_t del BSP

#define BUFFSIZE                        8192    // tamano del buffer para copiar archivos.


/*******************************************************************************
 *
 *      PROTOTIPOS:
 *
 ******************************************************************************/
int ReadBytes( FILE *file, void *addr, unsigned long size );
int WriteBytes( FILE *file, void *addr, unsigned long size );
long SaveBMP( FILE *file, BitMap *bmptr, RGB *palette256 );
long SavePCX( FILE *file, BitMap *bmptr, RGB *palette256 );
long fsize( FILE * file );
XMSarray<char>* AllocFile( XMSarray<char> *pX, long* size, char* filename );
int FreeFile( XMSarray<char>* pX, long size, char* filename );
long InitMipTexs( char *dirname, XMSarray<miptex_t>* gMipTex );
long InitDHulls( char *dirname, XMSarray<dhull_t>* gDHull );
long InitNodes( char *dirname, XMSarray<node_t>* gNode );
long InitDLeafs( char *dirname, XMSarray<dleaf_t>* gDLeaf );
long InitSurfaces( char *dirname, XMSarray<surface_t>* gSurface );
long InitEdges( char *dirname, XMSarray<edge_t>* gEdge );
long InitVertexs( char *dirname, XMSarray<vertex_t>* gVertex );
long GetGEntitiTargetName( long targetname, XMSarray<GEntiti>* XGE, long numXGE, XMSarray<long>* XGI, long* numXGIs );
long GetGEntiti( long id, XMSarray<GEntiti>* XGE, long numXGE, XMSarray<long>* XGI, long* numXGIs );
long SurfaceToGLine( surface_t s, XMSarray<edge_t> *XE, XMSarray<vertex_t> *XV, XMSarray<GLine> *pGLines, long *numGLines );
long InitGLines( XMSarray<dleaf_t> *XL, long numXLs, XMSarray<surface_t> *XS, XMSarray<edge_t> *XE, XMSarray<vertex_t> *XV, XMSarray<GLine> *XG, long *numXGs );
long InitGLines( XMSarray<dleaf_t> *XL, XMSarray<long> *XLI, long numXLIs, XMSarray<surface_t> *XS, XMSarray<edge_t> *XE, XMSarray<vertex_t> *XV, XMSarray<GLine> *XG, long *numXGs );
long InitGLines( shortbox_t sbox, XMSarray<GLine> *XG, long numXGs, XMSarray<GLine> *XGIs, long *numXGIs );
long InitGLines( XMSarray<dleaf_t> *XL, XMSarray<long> *XLI, long numXLIs, XMSarray<GLine> *XG, long numXGs, XMSarray<GLine> *XGIs, long *numXGIs );
long InitLeafs( shortbox_t sbox, XMSarray<dleaf_t> *XL, long numXLs, XMSarray<long> *XLIs, long *numXLIs );
long LeafSurfaces( XMSarray<dleaf_t> *XL, XMSarray<long> *XLI, long numXLIs, XMSarray<long> *XSI, long *numXSIs );
long InitClassIds( char* filename, XMSarray<ClassId> *pClassIds, long *numClassIds );
char* GetClass( char* buf, char* className );
char* GetClassName( XMSarray<ClassId> *pClassId, long maxClassId, char* buf, unsigned long mask );
long GetClassId( XMSarray<ClassId> *pClassId, long maxClassId, char* buf, unsigned long* mask );
long GetListClassName( XMSarray<char> *pClassNames, long *size, XMSarray<ClassId> *pClassId, long maxClassId, unsigned long mask );
long GetMipTex( char *nameMipTex, XMSarray<miptex_t> *XM, long numXMs, miptex_t *miptex );



/*******************************************************************************
 *
 *      CLASS:
 *
 ******************************************************************************/
class Bsp
{
    public:
				Bsp( char* filebsp );

				~Bsp();


    public:

	char                    pathbsp[257];

	char                    filebsp[257];

	long                    sizebsp;

	char                    file[MAX_ENTRY_NUM][257];

	dentry_t                entry[MAX_ENTRY_NUM];

	dheader_t               header;


    public:

	int                     UnPackBsp( void );

	int                     PackBsp( XMSarray<char> *pBSP, XMSarray<char> *pXMS, char *filename = NULL );

	int                     UnPackBsp( dentry_t entry, char* filename );

	int                     PackBsp( dentry_t *entry, char *filename, XMSarray<char> *pBSP, XMSarray<char> *pTHI );

	long                    Version( void ) { return header.version; } 

	int                     UpdateEntry( unsigned int index, long size );

	long			UnTexBsp( XMSarray<miptex_t> *XT, long numXTs, char *palettename, int type ); 

	int			SaveMipTex( miptex_t miptex, long index, char *filename, char *palettename, int type ); 

	XMSarray<char>*         GetBspEntiti(   long index,
						XMSarray<char> *pX,
						long *size,
						long *size12,
						long *size2 );

	char*                   GetEntitiSpecific(      char *specific,
							char *ptr,
							long size,
							char **ptr1,
							long *size12,
							char **ptr2,
							long *size2 );

	long                    InitGEntities(  XMSarray<GEntiti> *pXE,
						long *numGE,
						XMSarray<ClassId> *pClassIds,
						long maxClassIds );

	long                    Move( XMSarray<char> *ptr, long *size, GEntiti *pGE );

	long                    Supr( XMSarray<char> *ptr, long *size, GEntiti *pGE );

	long                    Insert( XMSarray<char> *ptr,
					long *size,
					GEntiti *pGE,
					XMSarray<ClassId> *pClassIds,
					long maxClassIds );

	
};


#endif


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *      END OF FILE
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

