/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FICHERO:
 *		VSTRUCT.H
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 * 	PROFILE INFORMATION:
 *
 * 	OBJECT MODIFICATION DATE:
 *		Wen Apr 24 10:11:34 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
#ifndef _VSTRUCT_H_
#define _VSTRUCT_H_


/*******************************************************************************
 *
 *	INCLUDES:
 *
 ******************************************************************************/
#include "qstruct.h"


/*******************************************************************************
 *
 *	ENUMERACION:
 *		Direccion
 *
 ******************************************************************************/
enum Direccion { Left, Up, Right, Down };


/*******************************************************************************
 *
 *	ENUMERACION:
 *		Plano
 *
 ******************************************************************************/
enum Plano {  XYZ = 0x0000, X0 = 0x0001, Y0 = 0x0002, Z0 = 0x0004 };


/*******************************************************************************
 *
 *	STRUCT:
 *		GLine
 *
 ******************************************************************************/
struct GLine
{
	vertex_t	sv;
	vertex_t	ev;
};

/*******************************************************************************
 *
 *	STRUCT:
 *		GEntiti
 *
 ******************************************************************************/
struct GEntiti
{
	float			x;
	float			y;
	float			z;
	unsigned long		c;
	unsigned long		model;
	unsigned long		target;
	unsigned long		targetname;
	long			index;
};


/*******************************************************************************
 *
 *	STRUCT:
 *		ClassId
 *
 ******************************************************************************/
struct ClassId
{
	char	className[33];
	long	classId;
	long	classMembers;	
};


/*******************************************************************************
 *
 *      STRUCT:
 *		RGB
 *
 ******************************************************************************/
struct RGB
{
	char	R;
	char	G;
	char 	B;
};


/*******************************************************************************
 *
 *      STRUCT:
 *		BitMap
 *
 ******************************************************************************/
typedef struct 
{
	unsigned short	width;
	unsigned short	height;
	char*		data;
} BitMap;


/*******************************************************************************
 *
 *      STRUCT:
 *		BMPHeader
 *
 ******************************************************************************/
struct BMPHeader
{
	/* BITMAPFILEHEADER */
	unsigned long	bfSize;
	unsigned short	bfReserved1;
	unsigned short	bfReserved2;
	long		bfOffBits;

	/* BITMAPINFOHEADER */
	unsigned long	biSize;
	long		biWidth;
	long		biHeight;
	unsigned short	biPlanes;
	unsigned short	biBitCount;
	unsigned long	biCompression;
	unsigned long	biSizeImage;
	long		biXPelsPerMeter;
	long		biYPelsPerMeter;
	unsigned long	biClrUsed;
	unsigned long	biClrImportant;
};


/*******************************************************************************
 *
 *      STRUCT:
 *		PCXHeader
 *
 ******************************************************************************/
struct PCXHeader
{
	char		originator;
	char		version;
	char		encoding;
	char		bitsperpixel;

	unsigned int	x1;
	unsigned int	y1;
	unsigned int	x2;
	unsigned int	y2;

	unsigned int	modehres;
	unsigned int	modevres;
	unsigned char	pal[48];
	char		charsize;
	char		nplanes;
	unsigned int	bytesperline;
	unsigned int	displaytype;
	char 		filter[58];
};


#endif


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/


