/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FICHERO:
 *		WORKING.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 * 	PROFILE INFORMATION:
 *
 * 	OBJECT MODIFICATION DATE:
 *		Tue May 14 10:31:15 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

/*******************************************************************************
 *
 *	INCLUDES:
 *
 ******************************************************************************/
#include <stdio.h>


#include "working.Hpp"
#include "tracelog.hpp"


/*******************************************************************************
 *
 *	VARIABLES EXPORTADAS:
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *	CONSTRUCTOR:
 *		GEntero::GEntero( int ancho, int valor, int col, int lin, char* n, GES *pantalla )
 *
 ******************************************************************************/
GEntero::GEntero( int ancho, int valor, int col, int lin, char* n, GES *pantalla ):Entero( ancho, valor )
{
	istrcpy( name, n );

	columna = col;
	linea = lin;

	p = pantalla;
}
	

/*******************************************************************************
 *
 *	METODO:
 *		int GEntero::SetValue( int valor )
 *
 ******************************************************************************/
GEntero::SetValue( int valor )
{
	char		buf[33];
	int		i =0, len = 0;


	itoa( valor, buf, 10 );

	len = istrlen( buf );

	ColCursor = 1;

	for( i = 0; i < Columnas; i++ )
	{
		Inserta( ' ' );
	}
	ColCursor = 1;

	for( i = 0; i < len; i++ )
	{
		Inserta( buf[i] );
	}
	for( i = 0; i < Columnas; i++ )
	{
		*(*p)( name ) << PosCursor( columna+i, linea ) << " ";
	}
	*(*p)( name ) << PosCursor( columna, linea ) << buf;

	return  valor;
}

	
/*******************************************************************************
 *
 *	CONSTRUCTOR:
 *		Working::Working()
 *
 ******************************************************************************/
Working::Working():v( 0 )
{ 
	x = 0;
	y = 0;
	alto = 0;
	ancho = 0;
}


/*******************************************************************************
 *
 *	CONSTRUCTOR:
 *		Working::Working( GVentana* v )
 *
 ******************************************************************************/
Working::Working( GVentana* v ):v( v )
{
	x = 0;
	y = 0;
	ancho = ( Ventana() -> rdbuf() -> Cols() - 2 );
   	alto = ( Ventana() -> rdbuf() -> Lins() - 2 );
}


/*******************************************************************************
 *
 *	CONSTRUCTOR:
 *		Working::Working( const Working& O )
 *
 ******************************************************************************/
Working::Working( const Working& O )
{ 
	x = O.x;
	y = O.y;
	v = O.v;
	ancho = O.ancho;
   	alto = O.alto;
}


/*******************************************************************************
 *
 *	OPERATOR:
 *		void Working::operator = ( const Working& O )
 *
 ******************************************************************************/
void Working::operator = ( const Working& O )
{
	x = O.x;
	y = O.y;
	v = O.v;
	ancho = O.ancho;
   	alto = O.alto;
}


/*******************************************************************************
 *
 *	OPERATOR:
 *		void Working::operator == ( const Working& O )
 *
 ******************************************************************************/
int Working::operator == ( const Working& O )
{
	if( x != O.x ) {
		return 0;
	}
	if( y != O.y ) {
		return 0;
	}
	if( !( v == O.v ) ) {
		return 0;
	}
	if( ancho != O.ancho || alto != O.alto )
	{
		return 0;
	}
	return 1;
}

  
/*******************************************************************************
 *
 *	METODO:
 *		void Working::AddLine( char *str )
 *
 ******************************************************************************/
void Working::AddLine( char *string )
{
	AddString( string );

	x = 0; y++;

	if( y > alto+1 ) {
		y = 0;
	}
}


/*******************************************************************************
 *
 *	METODO:
 *		void Working::AddString( char *str )
 *
 ******************************************************************************/
void Working::AddString( char *string )
{
	int		len;



	len = istrlen( string );

	for( int i = 0; i < len; i++ )
	{
		AddChar( string[i] );
	}
}


/*******************************************************************************
 *
 *	METODO:
 *		void Working::AddChar( char c )
 *
 ******************************************************************************/
void Working::AddChar( char c )
{
	struct viewporttype	estadoPantalla;
	char			buf[2];


       	// Se preserva el rea establecida actualmente
	getviewsettings( &estadoPantalla );

        // Se delimita el rea de pantalla donde se llevar a cabo la representacin
   	setviewport( 	( Ventana() -> rdbuf() -> Col() ) * 8,
                	( Ventana() -> rdbuf() -> Lin() ) * 8,
                	( Ventana() -> rdbuf() -> Col() + Ventana() -> rdbuf() -> Cols() ) * 8,
                	( Ventana() -> rdbuf() -> Lin() + Ventana() -> rdbuf() -> Lins() ) * 8,
                	1 );

	buf[0] = c;
	buf[1] = '\0';

	setcolor( Ventana() -> rdbuf() -> TintaActual() ) ;

	outtextxy( x * textwidth( "X" ), y * textheight( "X" ), buf ) ;

	if( x < ancho+1 )
	{
		x++;
	}
	else
	{
		x = 0;
		y++;
		if( y > alto+1 )
		{
			LimpiarWorking();
			y = 0;
		}
	}
	setviewport( estadoPantalla.left, estadoPantalla.top, estadoPantalla.right, estadoPantalla.bottom, estadoPantalla.clip );

}


/*******************************************************************************
 *
 *	METODO:
 *		void Working::LimpiarWorking( void )
 *
 ******************************************************************************/
void Working::LimpiarWorking( void )
{
	GVenBuf::Color		color1 , color2;
	char			buf[2];



	buf[0] = 219;
	buf[1] = '\0';

	color1 = v->rdbuf()->TintaActual(); 

	color2 = v->rdbuf()->FondoVentana(); 

	setcolor( color2 );
	
        for( int j = 0; j < alto+2; j++ )
        {
        	for( int i = 0; i < ancho+2; i++ )
        	{
			outtextxy( i * textwidth( "X" ), j * textheight( "X" ), buf ) ;
		}
	}
	v->rdbuf()->TintaActual( color1 ); 

}


/*******************************************************************************
 *
 *	METODO:
 *		void Working::Ventana( GVentana * V )
 *
 ******************************************************************************/
void Working::Ventana( GVentana * V )
{
	v = V;
}


/*******************************************************************************
 *
 *	METODO:
 *		GVentana* Working::Ventana( void )
 *
 ******************************************************************************/
GVentana* Working::Ventana( void )
{
	return v;
}


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

