/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FICHERO:
 *		WORKING.HPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 * 	PROFILE INFORMATION:
 *
 * 	OBJECT MODIFICATION DATE:
 *		Mon May 06 10:33:20 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
#ifndef _WORKING_HPP_
#define _WORKING_HPP_


#ifndef __cplusplus
#error No se puede utilizar Working en C
#endif



/*******************************************************************************
 *
 *	INCLUDES:
 *
 ******************************************************************************/
#include <graphics.h>
#include <string.h>
#include <iostream.h>


#include "gventana.hpp"
#include "gentrada.hpp"

	// Si el modelo de memoria seleccionado permite varios segmentos de datos
	// habr que utilizar las versiones far de algunas funciones

#if defined(__LARGE__) || defined(__HUGE__) || defined(__COMPACT__)

	#define istrcpy( orig, dest )	_fstrcpy( (orig), (dest) )
	#define istrcmp( orig, dest )	_fstrcmp( (orig), (dest) )
	#define istrcat( orig, dest )	_fstrcat( (orig), (dest) )

#else

	#define istrcpy( orig, dest )	strcpy( (orig), (dest) )
	#define istrcmp( orig, dest )	strcmp( (orig), (dest) )
	#define istrcat( orig, dest )	strcat( (orig), (dest) )

#endif


/*******************************************************************************
 *
 *	CLASS:
 *		GEntero:
 *
 ******************************************************************************/
class GEntero: public Entero
{
    public:

				GEntero( int ancho, int inicial, int col, int lin, char* name, GES* p  );

    public:

	int			SetValue( int value );

    private:

	char                    name[17];
 
				// Pantalla destino de la representacin.
	GES*                    p;

	int			columna, linea;

};
	
	
/*******************************************************************************
 *
 *	CLASS:
 *		Working:
 *
 ******************************************************************************/
class Working
{
    public:

				Working();

				Working( GVentana* v );

				Working( const Working& R );

	void			operator = ( const Working& R );

	int			operator == ( const Working& R );

				// Anade un caracter en la ventana.
	void			AddChar( char c );

				// Anade un caracter en la ventana.
	void			AddLine( char *line );

				// Anade una string en la ventana.
	void			AddString( char *string );

				// Limpia el working; 
	void			LimpiarWorking( void );

				// Establece la ventana destino
	void			Ventana( GVentana* v );

				 // Devuelve la ventana destino
	GVentana*		Ventana( void );


    private:

	GVentana*		v; // Ventana destino de la representacin.

	int			alto, ancho;	// Dimensiones del rea destino.

	int			x, y;	// Posicion actual del cursor.
};


#endif // _WORKING_HPP_


/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

