/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FICHERO:
 *		STRING.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 * 	PROFILE INFORMATION:
 *
 * 	OBJECT MODIFICATION DATE:
 *		Tue May 07 16:45:10 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *
 *	INCLUDES:
 *
 ******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*******************************************************************************
 *
 *	METODO:
 *		const char* Word( unsigned int index, char* buff )
 *
 ******************************************************************************/
const char* Word( unsigned int index, char* ptr )
{
	char			*ptr1,
				*ptr2;



	ptr1 = ptr;

	/* empezamos a recorrer la cadena hasta la palabra. */
	for( int i = 0; i < index; i++ ) {
		/* si hay espacios al principio de la cadena ... */
		if( *ptr1 == ' ' ) {
			for( ; *ptr1 == ' '; ptr1++ );
		}
		/* si hay no espacios al principio de la cadena ... */
		if( *ptr1 != ' ' ) {
			for( ; *ptr1 != ' '; ptr1++ );
		}
	}
	/* si hay espacios al principio de la cadena ... */
	if( *ptr1 == ' ' ) {
		for( ; *ptr1 == ' '; ptr1++ );
	}

	/* ahora que ptr1 apunta al principio de la cadena hacemos que ptr2 apunte al final de la palabra. */
	for( ptr2 = ptr1; *ptr2 != ' ' && *ptr2 != '\0'; ptr2++ );

	*ptr2 = '\0';

	strcpy( ptr, ptr1 );

	return ptr;

}


/*******************************************************************************
 *
 *	METODO:
 *		const char* Word2( unsigned int index, char* buff )
 *
 ******************************************************************************/
const char* Word2( unsigned int index, char* ptr )
{
	char		buf[257];
	char		*ptr1, *ptr2;



	strcpy( buf, Word( index, ptr ) );

	ptr1 = &buf[0];

	if( buf[0] == '"' )
	{
		ptr1 = &buf[1];
	}
	for( ptr2 = ptr1; *ptr2 != '"' && *ptr2 != '\0' && *ptr2 != '\r'; ptr2++ );

	if( *ptr2 == '"' || *ptr2 == '\r' )
	{
		*ptr2 = '\0';
	}
	strcpy( ptr, ptr1 );

	return ptr;
}


/*******************************************************************************
 *
 *	FUNCTION:
 *		const char* GetFileName( char* file, char* buf )
 *
 *	DESCRIPTION:
 *		Obtiene el nombre de un fichero a partir del path completo
 *		del fichero.
 *
 *	PARAMETROS:
 *
 *	Input:
 *		char* file
 *			Fichero con el path completo.
 *			
 *	RETURN:
 *		char*
 *			Nombre del fichero sin el path.
 *
 *	OBSERVACIONES:
 *	
 *
 ******************************************************************************/
const char* GetFileName( char* file, char* buf )
{
	char* ptr;

	for( ptr = file; *ptr != '\0'; ptr++ );

	for( ; *ptr != '\\'; ptr-- );

	ptr++;

	strcpy( buf, ptr );

	return buf;

}



/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

