/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FICHERO:
 *		TRACELOG.CPP
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 * 	PROFILE INFORMATION:
 *
 * 	OBJECT MODIFICATION DATE:
 *		Tue Feb 20 10:22:45 1996
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/
/*******************************************************************************
 *
 *	INCLUDES:
 *
 ******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>

#include <iostream.h>
#include <fstream.h>


#include "tracelog.hpp"


/*******************************************************************************
 *
 *	VARIABLES EXPORTADAS:
 *
 ******************************************************************************/


/*******************************************************************************
 *
 *	FUNCTION 
 *		void TraceLog( const char* fileName, const char* fmt, ... )
 *
 ******************************************************************************/
void TraceLog( const char* fileName, const char* fmt, ... )
{
	long 			rc;
	char 			timebuf[256+1];
	char 			buf[256+1];
	char 			logFileName[256+1];
	struct tm		*tp;
	time_t 			newtime;
	va_list 		ap;
	ofstream		ofs;


	
	time( &newtime );
	tp = localtime( &newtime );
	strftime( timebuf, sizeof( timebuf ), "%a %b %d %Y %H:%M:%S", tp ); 
	strcat( timebuf, "\n" );

	va_start( ap, fmt );
	vsprintf( buf, fmt, ap );
	strcat( buf, "\n" );
	va_end( ap );

if( _file )
{
	if( fileName != NULL && strcmp( fileName, "" ) ) {
		strcpy( logFileName, fileName );
		strcat( logFileName, ".LOG" );

		ofs.open( logFileName, ios::app );
		ofs << timebuf << buf;
		ofs.flush();
		ofs.close();
	}
}

if( _stdout )
{
	cout << timebuf << buf;
	cout.flush();
}

}



/*******************************************************************************
 *------------------------------------------------------------------------------
 *
 *	FIN DE FICHERO
 *
 *------------------------------------------------------------------------------
 ******************************************************************************/

